| vim:filetype=asm68k:smartindent
| Glue functions to move between C and generated code.
|
| Copyright (C) 2006 Nick Tarleton.
| Licensed under the GNU General Public License; see COPYING.txt.

.text
.even
.globl call_gen

call_gen:
	link.w	%fp,#0
	movem.l	%d2-%d7/%a2-%a5,-(%sp) | save regs

	movea.l	z80_base(%pc),%a0 | z80_base
	movea.l	%a0,%a1
	add.l	#0x8000,%a1
	movea.l	12(%fp),%a2 | regs
	movem.w	(%a2)+,%d0-%d5
	move.l	#0xffff,%d7
	and.l	%d7,%d0 | zero high words because long displacement mode
	and.l	%d7,%d1 | is used for (hl), etc.
	and.l	%d7,%d2
	and.l	%d7,%d4
	and.l	%d7,%d5
	move.w	(%a2),%d6 | sp
	and.l	%d7,%d6
	lea	(%a0,%d6),%a5
	clr.w	-(%a5) | bottom-of-stack marker

	| run code
	lea	save_sp(%pc),%a2
	move.l	%sp,(%a2)
	movea.l	8(%fp),%a2
	jmp	(%a2)

return_from_z80:
	move.l	save_sp(%pc),%sp
	| I'm actually not sure anything could screw up %sp, but why not make it
	| more stable.
	movea.l	12(%fp),%a2 | restore regs
	movem.w	%d0-%d5,(%a2)

	movem.l	(%sp)+,%d2-%d7/%a2-%a5 | restore regs
	unlk	%fp
.globl no_op
no_op:
	rts

save_sp:
	.long 0

.globl z80_return
z80_return:
	move.w	(%a5)+,%d6	| pop z80 return address
	tst.w	%d6
	beq	return_from_z80	| zero = bottom of stack = end of program
	movem.l	%d0-%d1/%a0-%a1/%a5,-(%sp)	| save regs
	move.w	%d6,-(%sp)
	move.w	#0x0500,%d0	| disable I1-5 for speed
	trap	#1
	move.l	(0xc8),%a5	| OPTIMIZE_ROM_CALLS
	bsr	translate
	addq.l	#2,%sp
	move.w	#0x0000,%d0
	trap	#1
	move.l	%a0,%a2
	movem.l	(%sp)+,%d0-%d1/%a0-%a1/%a5
	move.w	%d7,%ccr	| put ccr in proper state
	jmp	(%a2)
