/* TIGCC Library Routines
 * Copyright (C) 2000-2005 Zeljko Juric,
 *                         Thomas Nussbaumer,
 *                         Kevin Kofler, and
 *                         Sebastian Reichelt
 * TIGCC is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * Modified by Nick Tarleton to support variable screen widths and have
 * different register parameters.
 */

typedef enum {
	multi_SPRT_XOR,
	multi_SPRT_OR,
	multi_SPRT_AND
} SPRMODE;

void multi_Sprite8(short x asm("d0"),
			short y asm("d1"),
			short h asm("d2"),
			short screen_w_in_bytes asm("d3"),
			void* buff asm("a2"),
			const unsigned char *sprite asm("a3"),
			SPRMODE mode asm("d4"))
{
  long addr=(long)buff+screen_w_in_bytes*y+((x>>3)&0xfffe),d1;
  unsigned short cnt=24-(x&15),data;
  for(;h--;addr+=screen_w_in_bytes)
    {
      data=*sprite++;
      if(mode==multi_SPRT_AND) *(long*)addr&=~((long)(~data&0xff)<<cnt);
      else
        {
          d1=(long)data<<cnt;
          if(mode==multi_SPRT_XOR) *(long*)addr^=d1;
          else *(long*)addr|=d1;
        }
    }
}
