/*
 * General definitions for targets.
 *
 * Copyright (C) 2005 Nick Tarleton.
 * Licensed under the GNU General Public License; see COPYING.txt.
 */

#ifndef _multi_TARGET_H
#define _multi_TARGET_H

#ifndef TESTING_ON_PC
#	include <asmtypes.h>
#endif

typedef struct {
	void (* load) (BYTE* fdata); // Load a file.
		// fdata should point to 2 bytes after the target type tag.
		// If it is on the heap, it must be locked.
	void (* run) (void); // Run a loaded file.
	void* (* handle_RST) (BYTE op);
		// Handle an RST to a given address.
		// Passed the opcode, not the address.
		// Returns the address to call, or NULL if do nothing.
	void* (* handle_CALL) (WORD addr);
		// Handle a CALL. Returns NULL if it's an in-program call,
		// address to call otherwise.
	void* (* handle_IN) (BYTE port); // Handle input from a given port.
	void* (* handle_OUT) (BYTE port); // Handle output to a port.
} TARGET;

/* Current target. */
extern TARGET* cur_target;

/* Defined targets. */
#define TAG_TI83PLUS 0x84
extern TARGET target_ti83plus;

#endif
