/*
 * Test framework for translation.
 * Requires ttdasm installed.
 *
 * Copyright (C) 2005 Nick Tarleton.
 * Licensed under the GNU General Public License; see COPYING.txt.
 */

#include <stdio.h>
#include <stdlib.h>

#include "compat.h"
#include "globals.inc"

#include "../xlate.h"
#include "../misc.h"

#ifdef LITTLE_ENDIAN_PC
#	define TERMINATOR 0xADDE
#else
#	define TERMINATOR 0xDEAD
#endif

static char the_code[] = {
	0,
	0332, 1, 0x80,
	0057,
	0xED, 0 // terminator
};

int main(void)
{
	FILE* output = fopen("test-asm-out", "wb");
	M68K_CODE translated, ptr;

	z80_base = the_code - 0x8000;
	xlate_zero_statics();
	translated = translate(0x8000);
	// output until terminator is encountered
	for(ptr = translated; *(WORD *)ptr != TERMINATOR; ptr++)
		putc(*(ptr), output);

	fclose(output);
	printf("%p\n", translated);
	system("ttdasm -raw test-asm-out");
	remove("test-asm-out");
	return 0;
}
