| vim:filetype=asm68k:smartindent:foldmethod=marker:foldmarker={{{,}}}
| TI-83+ target: library function implementations for graph screen functions.
|
| Copyright (C) 2006 Nick Tarleton.
| Licensed under the GNU General Public License; see COPYING.txt.

.include "asm.inc"
.include "ti83plus.inc"
.include "ion.inc"

.text
.even

| clear screen, used by clrlcdfull and the C code
.globl clear_viewport
clear_viewport: |{{{
	lea	VIEWPORT_START,%a2
	moveq	#VIEWPORT_H-1,%d6
1:	clr.l	(%a2)+
	clr.l	(%a2)+
	clr.l	(%a2)+
	lea	NEXT_LINE_SKIP(%a2),%a2
	dbra	%d6,1b
	rts
|}}}

| clear entire screen and gbuf
.globl TI83P_func_clrlcdfull
TI83P_func_clrlcdfull:
	bsr clear_viewport | and fall off to grbufclr

| clear entire gbuf, don't touch screen
.globl TI83P_func_grbufclr
TI83P_func_grbufclr: |{{{
	lea	gbuf-0x8000(%a1),%a2
	move.w	#GRBUF_SIZE_LONGS-1,%d6
1:	clr.l	(%a2)+
	dbra	%d6,1b
	rts
|}}}

| copy gbuf to screen
.globl TI83P_func_grbufcpy
TI83P_func_grbufcpy: |{{{
	lea	gbuf-0x8000(%a1),%a2
	lea	VIEWPORT_START,%a3
	moveq	#VIEWPORT_H-1,%d6
1:	move.l	(%a2)+,(%a3)+
	move.l	(%a2)+,(%a3)+
	move.l	(%a2)+,(%a3)+
	lea	NEXT_LINE_SKIP(%a3),%a3
	dbra	%d6,1b
	rts
|}}}

| draw line from (B,C) to (D,E) on screen
| y-coordinates are reversed (0 at bottom, 63 at top) - quite dumb
.globl TI83P_func_darkline
TI83P_func_darkline: |{{{
	movem.l	%d0-%d2/%a0-%a1,-(%sp)
	move.w	#1,-(%sp) | A_NORMAL
	| compute coordinates
	moveq	#63,%d6
	sub.b	%d1,%d6	| second Y
	add.w	#VIEWPORT_Y,%d6
	move.w	%d6,-(%sp)
	lsr.w	#8,%d1	| second X
	move.b	%d1,%d6
	add.w	#VIEWPORT_X,%d6
	move.w	%d6,-(%sp)
	moveq	#63,%d6
	sub.b	%d0,%d6	| first Y
	add.w	#VIEWPORT_Y,%d6
	move.w	%d6,-(%sp)
	lsr.w	#8,%d0	| first X
	move.b	%d0,%d6
	add.w	#VIEWPORT_X,%d6
	move.w	%d6,-(%sp)
	| actual call
	movea.l	0xC8,%a0
	movea.l	4*DrawLine(%a0),%a0
	jsr	(%a0)
	lea	10(%sp),%sp
	movem.l	(%sp)+,%d0-%d2/%a0-%a1
|}}}
