// The Ion Include File by Dan Englender

//----> Safe Memory Areas
// saferam1 = 768 bytes (apdram)
// saferam2 = 531 bytes (statram)
// saferam3 = 128 bytes (textmem)
// saferam4 = 66 bytes (ops)
// saferam5 = 10 bytes (imathptrs)

#define TI83P_appBackupScreen	 0x9872	// 768 bytes
#define TI83P_ldhlind	 0x4009
#define TI83P_htimesl	 0x4276
#define TI83P_convop1	 0x4AEF
#define TI83P_contrast	 0x8447
#define TI83P_darkline	 0x47DD
#define TI83P_darkpoint	 0x47F2
#define TI83P_archUnarch	 0x4FD8
#define TI83P_enoughRam	 0x42FD
#define TI83P_usermemoff	 0x89EC
#define TI83P_libstart	 0x0004
#define TI83P_progstart	 0x9D95
//saferam1	=0x86EC
#define TI83P_saferam1	 0x9872
#define TI83P_saferam2	 0x858f
#define TI83P_saferam3	 0x8508
#define TI83P_saferam4	 0x8478
#define TI83P_saferamp	 0x9872
#define TI83P_saferamp2	 0x8251
#define TI83P_homeup		 0x4558
#define TI83P_newline	 0x452E
#define TI83P_cleargbuf	 0x4BD0
#define TI83P_indicatorOn	 0x456D
#define TI83P_indicatorOff	 0x4570
#define TI83P_copygbuf	 0x486A
#define TI83P_clrlcdf	 0x4540
#define TI83P_cleartextshad	 0x454C
#define TI83P_clrscr		 0x4543
#define TI83P_clrscrf	 0x4546
#define TI83P_cline		 0x4798
#define TI83P_iline		 0x47E0
#define TI83P_ipoint		 0x47E3
#define TI83P_ParseInp	 0x4A9B
#define TI83P_divhlby10	 0x400F
#define TI83P_cphlde		 0x400C
#define TI83P_disphl		 0x4507
#define TI83P_divhlbya	 0x4012
#define TI83P_hltimes9	 0x40F9
#define TI83P_vputmap	 0x455E
#define TI83P_vputs		 0x4561
#define TI83P_vputsn		 0x4564
#define TI83P_putmap		 0x4501
#define TI83P_puts		 0x450A
#define TI83P_putps		 0x4510
#define TI83P_putc		 0x4504
#define TI83P_getkey		 0x4972
#define TI83P_getk		 0x4744
#define TI83P_getcsc		 0x4018
//_RCLY		=0x4EE0
//_RCLX		=0x4EE8
#define TI83P_memfree	 0x42E5
#define TI83P_chksysvar	 0x42F1
#define TI83P_findsym	 0x42F4
//_CREATEGDB	=0x4486
//_CREATEREAL	=0x4452
//_CREATESTRNG	=0x4472
#define TI83P_createprog	 0x4339
#define TI83P_createprotprog	 0x4E6D
#define TI83P_delvar		 0x4351
#define TI83P_insertmem	 0x42F7
#define TI83P_deletemem	 0x4357
#define TI83P_lcdbusy	 0x4051
#define TI83P_op1		 0x8478
#define TI83P_op2		 0x8483
#define TI83P_op3		 0x8499
#define TI83P_op4		 0x8499
#define TI83P_op5		 0x84A4
#define TI83P_op6		 0x84AF
#define TI83P_imathptr1	 0x84D3
#define TI83P_imathptr2	 0x84D5
#define TI83P_imathptr3	 0x84D7
#define TI83P_imathptr4	 0x84D9
#define TI83P_imathptr5	 0x84DB
#define TI83P_progptr		 0x9830
#define TI83P_cmdshad		 0x966E
#define TI83P_plotsscreen	 0x9340
#define TI83P_symtable	 0xFE6E
#define TI83P_currow		 0x844B
#define TI83P_curcol		 0x844C
#define TI83P_pencol		 0x86D7
#define TI83P_penrow		 0x86D8
#define TI83P_curgy		 0x8D18
#define TI83P_curgx		 0x8D19
#define TI83P_PushRealO1	  0x43BA
#define TI83P_PushRealO2	  0x43B7
#define TI83P_PushRealO3	  0x43B4
#define TI83P_PushRealO4	  0x43B1
#define TI83P_PushRealO5	  0x43AE
#define TI83P_PushRealO6	  0x43AB
#define TI83P_FPAdd	  0x4072
#define TI83P_FPDiv	  0x4099
#define TI83P_FPMult	  0x4084
#define TI83P_OP1ExOP4	  0x421C
#define TI83P_OP1Set0	  0x41BF
#define TI83P_OP3SET2	  0x41A4
#define TI83P_PopRealO1	 0x4390
#define TI83P_PopRealO2	 0x438D
#define TI83P_PopRealO3	 0x438A
#define TI83P_PopRealO4	 0x4387
#define TI83P_PopRealO5	 0x4384
#define TI83P_PopRealO6	 0x4381
#define TI83P_op5exop6	 0x420A
#define TI83P_op5set0	 0x41B3
#define TI83P_cpop1op2	 0x4111
#define TI83P_op3toop4	 0x4114
#define TI83P_op1toop4	 0x4117
#define TI83P_op2toop4	 0x411A
#define TI83P_op4toop2	 0x411D
#define TI83P_op3toop2	 0x4120
#define TI83P_op1toop3	 0x4123
#define TI83P_op5toop2	 0x4126
#define TI83P_op5toop6	 0x4129
#define TI83P_op5toop4	 0x412C
#define TI83P_op1toop2	 0x412F
#define TI83P_op6toop2	 0x4132
#define TI83P_op6toop1	 0x4135
#define TI83P_op4toop1	 0x4138
#define TI83P_op5toop1	 0x413B
#define TI83P_op3toop1	 0x413E
#define TI83P_op6toop5	 0x4141
#define TI83P_op4toop5	 0x4144
#define TI83P_op3toop5	 0x4147
#define TI83P_op2toop5	 0x414A
#define TI83P_op2toop6	 0x414D
#define TI83P_op1toop6	 0x4150
#define TI83P_op1toop5	 0x4153
#define TI83P_op2toop1	 0x4156
#define TI83P_op2toop3	 0x416E
#define TI83P_op4toop3	 0x4171
#define TI83P_op5toop3	 0x4174
#define TI83P_op4toop6	 0x4177
#define TI83P_OP1Set1	  0x419B
#define TI83P_OP1Set2	  0x41A7
#define TI83P_OP1Set3	  0x41A1
#define TI83P_OP1Set4	  0x419E
#define TI83P_pushop1	 0x43C9
#define TI83P_popop1		 0x437E
#define TI83P_arc_unarc	  0x4FD8
#define TI83P_sin		 0x40BD
#define TI83P_zeroop1	 0x41C5
#define TI83P_zeroop2	 0x41C8
#define TI83P_zeroop3	 0x41CB
#define TI83P_setxxop1	 0x478C
#define TI83P_setxxop2	 0x478F
#define TI83P_setxxxxop2	 0x4792
#define TI83P_dispop1a	 0x4BF7
#define TI83P_mov9toop1	 0x417A
#define TI83P_delvararc	 0x4fC6
#define TI83P_ptemp		 0x982E
#define TI83P_grbuf		 TI83P_plotsscreen
#define TI83P_graph_mem	 TI83P_plotsscreen
#define TI83P_gbuf		 TI83P_plotsscreen
#define TI83P_sram		 TI83P_saferam1
#define TI83P_apdram		 TI83P_saferam1
#define TI83P_statram		 TI83P_saferam2
#define TI83P_statvars	 TI83P_saferam2
#define TI83P_vat		 TI83P_progptr
#define TI83P_saferam5	 TI83P_imathptr1
#define TI83P_grbufcpy	 TI83P_copygbuf
#define TI83P_grbufclr	 TI83P_cleargbuf
#define TI83P_clrlcdfull      TI83P_clrlcdf
#define TI83P_clrscrnfull	 TI83P_clrscrf
#define TI83P_chkfindsym      TI83P_chksysvar
#define TI83P_textshadow	 TI83P_saferam3
#define TI83P_savesscreen      TI83P_saferam1
//-----> TI83P_Ion Functions
#define TI83P_lVectors	 TI83P_cmdshad+80
#define TI83P_ionVersion	 TI83P_lVectors
#define TI83P_ionRandom	 TI83P_lVectors+3
#define TI83P_ionPutSprite	 TI83P_lVectors+6
#define TI83P_ionLargeSprite	 TI83P_lVectors+9
#define TI83P_ionGetPixel	 TI83P_lVectors+12
#define TI83P_ionFastCopy	 TI83P_lVectors+15
#define TI83P_ionDetect	 TI83P_lVectors+18
#define TI83P_ionDecompress	 TI83P_lVectors+21


#define TI83P_trigflags               0           // IY OFFSET VALUE
#define TI83P_trigdeg                 2
//
#define TI83P_plotflags               2           // IY OFFSET VALUE
#define TI83P_plotloc                 1
#define TI83P_plotdisp                2
//
#define TI83P_grfmodeflags            2           // IY OFFSET VALUE
#define TI83P_grffuncm                4
#define TI83P_grfpolarm               5
#define TI83P_grfparamm               6
#define TI83P_grfrecurm               7
//
#define TI83P_graphflags              3           // IY OFFSET VALUE
#define TI83P_graphdraw               0
#define TI83P_graphcursor             2
//
#define TI83P_grfdbflags              4           // IY OFFSET VALUE
#define TI83P_grfdot                  0
#define TI83P_grfsimul                1
#define TI83P_grfgrid                 2
#define TI83P_grfpolar                3
#define TI83P_grfnocoord              4
#define TI83P_grfnoaxis               5
#define TI83P_grflabel                6
//
#define TI83P_textflags               5           // IY OFFSET VALUE
#define TI83P_textEraseBelow          1
#define TI83P_textScrolled            2
#define TI83P_textInverse             3
//
#define TI83P_onflags                 9           // IY OFFSET VALUE
#define TI83P_onRunning               3
#define TI83P_onInterrupt             4
//
#define TI83P_statflags               9           // IY OFFSET VALUE
#define TI83P_statsvalid              6
//
#define TI83P_fmtflags                10          // IY OFFSET VALUE
#define TI83P_fmtExponent             0
#define TI83P_fmtEng                  1
//
#define TI83P_nummode                 10          // IY OFFSET VALUE
#define TI83P_FMTREAL                 5
#define TI83P_FMTRECT                 6
#define TI83P_FMTPOLAR                7
//
#define TI83P_curflags                12          // IY OFFSET VALUE
#define TI83P_curAble                 2
#define TI83P_curOn                   3
#define TI83P_curLock                 4
//
#define TI83P_appflags                13          // IY OFFSET VALUE
#define TI83P_appTextSave             1
#define TI83P_appAutoScroll           2
//
#define TI83P_PLOTFLAG2               17          // IY OFFSET VALUE
#define TI83P_EXPR_PARAM              3
#define TI83P_EXPR_WRITING            4
//
#define TI83P_indicflags              18          // IY OFFSET VALUE
#define TI83P_indicRun                0
#define TI83P_indicOnly               2
//
#define TI83P_shiftflags              18          // IY OFFSET VALUE
#define TI83P_shift2nd                3
#define TI83P_shiftAlpha              4
#define TI83P_shiftALock              6
//
#define TI83P_tblflags                19          // IY OFFSET VALUE
#define TI83P_AutoFill                4
#define TI83P_AutoCalc                5
//
#define TI83P_sgrflags                20          // IY OFFSET VALUE
#define TI83P_grfSplit                0
#define TI83P_VertSplit               1
#define TI83P_WRITE_ON_GRAPH          4
#define TI83P_textwrite               7
//
#define TI83P_asm_flag1               33          // IY OFFSET VALUE
#define TI83P_asm_flag1_0             0
#define TI83P_asm_flag1_1             1
#define TI83P_asm_flag1_2             2
#define TI83P_asm_flag1_3             3
#define TI83P_asm_flag1_4             4
#define TI83P_asm_flag1_5             5
#define TI83P_asm_flag1_6             6
#define TI83P_asm_flag1_7             7
//
#define TI83P_asm_flag2               34          // IY OFFSET VALUE
#define TI83P_asm_flag2_0             0
#define TI83P_asm_flag2_1             1
#define TI83P_asm_flag2_2             2
#define TI83P_asm_flag2_3             3
#define TI83P_asm_flag2_4             4
#define TI83P_asm_flag2_5             5
#define TI83P_asm_flag2_6             6
#define TI83P_asm_flag2_7             7
//
#define TI83P_asm_flag3               35          // IY OFFSET VALUE
#define TI83P_asm_flag3_0             0
#define TI83P_asm_flag3_1             1
#define TI83P_asm_flag3_2             2
#define TI83P_asm_flag3_3             3
#define TI83P_asm_flag3_4             4
#define TI83P_asm_flag3_5             5
#define TI83P_asm_flag3_6             6
#define TI83P_asm_flag3_7             7


