| vim:filetype=asm68k:smartindent:foldmethod=marker:foldmarker={{{,}}}
| TI-83+ Ion library functions.
|
| Copyright (C) 2006 Nick Tarleton.
| Licensed under the GNU General Public License; see COPYING.txt.

.include "asm.inc"
.include "ti83plus.inc"
.include "ion.inc"

.text
.even

| returns Ion version number in h.l, Ion compatibility in a, 
| library compatibility in d, # routines in e
| in this case: 1.6, compatibility 0, libCompatibility 0, 8 routines
.globl TI83P_func_ionVersion
TI83P_func_ionVersion: |{{{
	move.w	#0x0106,%d2
	moveq	#0x0008,%d1
	moveq	#0x00,%d3
	rts
|}}}

| returns random number from [0,b) in a
.globl TI83P_func_ionRandom
TI83P_func_ionRandom: |{{{
	move.l	%d0,-(%sp)
	movem.l	%d1-%d2/%a0-%a1,-(%sp)
	bsr	rand 	| returns signed short random number
	movem.l	(%sp)+,%d1-%d2/%a0-%a1
	moveq	#0,%d6
	move.b	%d0,%d6
	move.l	(%sp),%d0
	lsr.w	#8,%d0
	and.w	#0xff,%d0
	moveq	#0,%d7
	subq	#1,%d0
1:	add.w	%d6,%d7
	dbra	%d0,1b
	lsr.w	#8,%d7
	move.b	%d7,%d3
	move.l	(%sp)+,%d0
	rts
|}}}

| for pixel at (a,e), get address in hl and mask in a
.globl TI83P_func_ionGetPixel
TI83P_func_ionGetPixel: |{{{
	| hl = gbuf + (x + y * 96) / 8
	|    = gbuf + y * 12 + x / 8
	moveq	#0,%d2
	move.b	%d3,%d2	| x
	lsr.b	#3,%d2	| x / 8
	moveq	#0,%d6
	move.b	%d1,%d6	| y
	add.b	%d1,%d6	| y * 2
	add.b	%d1,%d6	| y * 3
	add.w	%d6,%d6	| y * 6
	add.w	%d6,%d6	| y * 12
	add.w	%d6,%d2	| x/8 + y*12
	add.w	#gbuf,%d2
	| a  = 1 << (x % 8)
	move.b	%d3,%d6
	moveq	#7,%d7
	and.b	%d7,%d6
	moveq	#-0x80,%d3
	lsr.b	%d6,%d3
	rts
|}}}

| put sprite at ix with height b at (a,l)
.globl TI83P_func_ionPutSprite
TI83P_func_ionPutSprite: |{{{
	movem.l	%d0-%d4/%a0-%a1,-(%sp)
	rol.w	#8,%d0	| h
	move.b	%d0,%d6
	move.b	%d3,%d0	| x
	ext.w	%d0	| in any non-seriously-bugged context, this zero-extends
	move.b	%d2,%d1	| y
	ext.w	%d1
	move.b	%d6,%d2	| h
	ext.w	%d2
	moveq	#(VIEWPORT_W/8),%d3	| screen_w_in_bytes
	lea	gbuf-0x8000(%a1),%a2	| buffer
	lea	(%a0,%d4.l),%a3		| sprite
	moveq	#SPRT_XOR,%d4		| mode
	bsr	multi_Sprite8		| put!
	movem.l	(%sp)+,%d0-%d4/%a0-%a1
	rts
|}}}
