| vim:filetype=asm68k:smartindent:foldmethod=marker:foldmarker={{{,}}}
| TI-83+ target: functions having to do with the OP variables
|
| Copyright (C) 2006 Nick Tarleton.
| Licensed under the GNU General Public License; see COPYING.txt.
|
| FIXME: Floating point is not supported at all. Values are stored as integers.
| Programs that use the OPs only through _setxxop1, _dispop1a, etc. will be
| fine, but not those that manipulate them directly.

.include "asm.inc"
.include "ti83plus.inc"
.include "ion.inc"

| A -> op1
.globl TI83P_func_setxxop1
TI83P_func_setxxop1:
	and.w	#0xff,%d3
	move.w	%d3,op1-0x8000(%a1)
	rts

| HL -> op2
.globl TI83P_func_setxxxxop2
TI83P_func_setxxxxop2:
	move.b	%d2,op2-0x8000+1(%a1)	| lsb
	rol.w	#8,%d2
	move.b	%d2,op2-0x8000(%a1)	| msb
	ror.w	#8,%d2
	rts

| display up to A characters of OP1 in decimal in small font
| XXX: ignores A
.globl TI83P_func_dispop1a
TI83P_func_dispop1a: |{{{
	| first do sprintf
	movem.l	%d0-%d2/%a0-%a1,-(%sp)
	move.w	op1-0x8000(%a1),-(%sp)	| number
	pea	op_format_str(%pc)	| format
	pea	op6-0x8000(%a1)		| buf
	movea.l	0xC8,%a0
	movea.l	4*sprintf(%a0),%a0
	jsr	(%a0)
	lea	10(%sp),%sp
	movem.l	(%sp)+,%d0-%d2/%a0-%a1
	| now print
	move.w	#op6,%d2
	bra	TI83P_func_vputs
|}}}

op_format_str:
	.asciz "%hu"
	.even

.globl TI83P_func_mov9toop1 |{{{
TI83P_func_mov9toop1:
	lea	(%a0,%d2.l),%a2
	lea	op1-0x8000(%a1),%a3
	bra	move9
|}}}
.globl TI83P_func_op2toop1 |{{{
TI83P_func_op2toop1:
	lea	op2-0x8000(%a1),%a2
	lea	op1-0x8000(%a1),%a3
	bra	move9 |}}}
.globl TI83P_func_op1toop2 |{{{
TI83P_func_op1toop2:
	lea	op1-0x8000(%a1),%a2
	lea	op2-0x8000(%a1),%a3
|}}}

| copy 9 bytes from (a2) to (a3)
move9:
	moveq	#8,%d6
1:	move.b	(%a2)+,(%a3)+
	dbra	%d6,1b
	rts
