//= ()=====================================================================
// Include File for the TI-83 Plus
// Last Updated 10/27/1999 
//
// Copyright (c) 1999 Texas Instruments: The Licensed Materials are
// copyrighted by TI. LICENSEE agrees that it will 
// not delete the copyright notice, trademarks or
// protective notices from any copy made by LICENSEE.
//
// Warranty: TI does not warrant that the Licensed Materials will
// be free from errors or will meet your specific requirements.
// The Licensed Materials are made available "AS IS" to LICENSEE.
//
// Limitations: TI MAKES NO WARRANTY OR CONDITION, EITHER EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO ANY IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE,
// REGARDING THE LICENSED MATERIALS.  IN NO EVENT SHALL
// TI OR ITS SUPPLIERS BE LIABLE FOR ANY INDIRECT, INCIDENTAL
// OR CONSEQUENTIAL DAMAGES, LOSS OF PROFITS, LOSS OF USE OR DATA,)
// OR INTERRUPTION OF BUSINESS, WHETHER THE ALLEGED DAMAGES ARE
// LABELED IN TORT, CONTRACT OR INDEMNITY.
//
//
//= ()=====================================================================
//           System Variable Equates
//= ()=====================================================================
//       Entry Points : RclSysTok, StoSysTok
//
#define TI83P_XSCLt		  (2)
#define TI83P_YSCLt		  (3)
#define TI83P_XMINt		  (0x0A)
#define TI83P_XMAXt		  (0x0B)
#define TI83P_YMINt		  (0x0C)
#define TI83P_YMAXt		  (0x0D)
#define TI83P_TMINt		  (0x0E)
#define TI83P_TMAXt		  (0x0F)
#define TI83P_THETMINt	  (0x10)
#define TI83P_THETMAXt	  (0x11)
#define TI83P_TBLMINt		  (0x1A)
#define TI83P_PLOTSTARTt	  (0x1B)
#define TI83P_NMAXt		  (0x1D)
#define TI83P_NMINt		  (0x1F)
#define TI83P_TBLSTEPt	  (0x21)
#define TI83P_TSTEPt		  (0x22)
#define TI83P_THETSTEPt	  (0x23)
#define TI83P_DELTAXt		  (0x26)
#define TI83P_DELTAYt		  (0x27)
#define TI83P_XFACTt		  (0x28)
#define TI83P_YFACTt		  (0x29)
#define TI83P_FINNt		  (0x2B)
#define TI83P_FINIt		  (0x2C)
#define TI83P_FINPVt		  (0x2D)
#define TI83P_FINPMTt		  (0x2E)
#define TI83P_FINFVt		  (0x2F)
#define TI83P_FINPYt		  (0x30)
#define TI83P_FINCYt		  (0x31)
#define TI83P_PLOTSTEPt	  (0x34)
#define TI83P_XRESt		  (0x36)
//

//= ()=====================================================================
//           Run indicators
//= ()=====================================================================
//
//TI83P_busyPause	= (10101010b)
//TI83P_busyNormal	= (11110000b)
//
//= ()=====================================================================
// Macro to call base code from an app,
//= ()=====================================================================
//
//#define TI83P_rBR_CALL	  (0x28)// NEEDED FOR APPS
//#define TI83P_BRT_JUMP0	  (0x50)
//

//= ()=====================================================================
//           Common subroutine RST numbers  
//= ()=====================================================================
//
#define TI83P_rOP1TOOP2	  (0x08)
#define TI83P_rFINDSYM	  (0x10)
#define TI83P_rPUSHREALO1	  (0x18)
#define TI83P_rMOV9TOOP1	  (0x20)
#define TI83P_rFPADD		  (0x30)
//

//SYMBOLIC_DEBUG_START
//= ()=====================================================================
//           Entry points  
//= ()=====================================================================
//
#define TI83P_AbsO1O2Cp	  (0x410E)
#define TI83P_AbsO1PAbsO2	  (0x405A)
#define TI83P_ACos		  (0x40DE)
#define TI83P_ACosH		  (0x40F0)
#define TI83P_ACosRad	  (0x40D2)
#define TI83P_AdrLEle	  (0x462D)
#define TI83P_AdrMEle	  (0x4609)
#define TI83P_AdrMRow	  (0x4606)
#define TI83P_AllEq		  (0x4876)
#define TI83P_AllocFPS	  (0x43A5)
#define TI83P_AllocFPS1	  (0x43A8)
#define TI83P_Angle		  (0x4102)
#define TI83P_AnsName	  (0x4B52)
#define TI83P_ApdSetup	  (0x4C93)
#define TI83P_AppGetCalc	  (0x4C78)
#define TI83P_AppGetCbl	  (0x4C75)
#define TI83P_Arc_Unarc	  (0x4FD8)
#define TI83P_ASin		  (0x40E4)
#define TI83P_ASinH		  (0x40ED)
#define TI83P_ASinRad	  (0x40DB)
#define TI83P_ATan		  (0x40E1)
#define TI83P_ATan2		  (0x40E7)
#define TI83P_ATan2Rad	  (0x40D8)
#define TI83P_ATanH		  (0x40EA)
#define TI83P_ATanRad	  (0x40D5)

#define TI83P_BinOPExec	  (0x4663)
#define TI83P_Bit_VertSplit	  (0x4FA8)
#define TI83P_BufClr		  (0x5074)
#define TI83P_BufCpy		  (0x5071)

#define TI83P_CAbs		  (0x4E97)
#define TI83P_CAdd		  (0x4E88)
#define TI83P_CanAlphIns	  (0x4C69)
#define TI83P_CDiv		  (0x4E94)
#define TI83P_CDivByReal	  (0x4EBB)
#define TI83P_CEtoX		  (0x4EA9)
#define TI83P_CFrac		  (0x4EC1)
#define TI83P_CheckSplitFlag	  (0x49F0)
#define TI83P_ChkFindSym	  (0x42F1)
#define TI83P_CIntgr		  (0x4EC4)
#define TI83P_CircCmd	  (0x47D4)
#define TI83P_CkInt		  (0x4234)
#define TI83P_CkOdd		  (0x4237)
#define TI83P_CkOP1C0	  (0x4225)
#define TI83P_CkOP1Cplx	  (0x40FC)
#define TI83P_CkOP1FP0	  (0x4228)
#define TI83P_CkOP1Pos	  (0x4258)
#define TI83P_CkOP1Real	  (0x40FF)
#define TI83P_CkOP2FP0	  (0x422B)
#define TI83P_CkOP2Pos	  (0x4255)
#define TI83P_CkOP2Real	  (0x42DF)
#define TI83P_CkPosInt	  (0x4231)
#define TI83P_CkValidNum	  (0x4270)
#define TI83P_CleanAll	  (0x4A50)
#define TI83P_ClearRect	  (0x4D5C)
#define TI83P_ClearRow	  (0x4CED)
#define TI83P_CLine		  (0x4798)
#define TI83P_CLineS		  (0x479B)
#define TI83P_CLN		  (0x4EA0)
#define TI83P_CLog		  (0x4EA3)
#define TI83P_CloseEditBufNoR	  (0x476E)
#define TI83P_CloseProg	  (0x4A35)
#define TI83P_ClrGraphRef	  (0x4A38)
#define TI83P_ClrLCD		  (0x4543)
#define TI83P_ClrLCDFull	  (0x4540)
#define TI83P_ClrLp		  (0x41D1)
#define TI83P_ClrOP1S	  (0x425E)
#define TI83P_ClrOP2S	  (0x425B)
#define TI83P_ClrScrn	  (0x4549)
#define TI83P_ClrScrnFull	  (0x4546)
#define TI83P_ClrTxtShd	  (0x454C)
#define TI83P_CMltByReal	  (0x4EB8)
#define TI83P_CmpSyms	  (0x4A4A)
#define TI83P_CMult		  (0x4E8E)
#define TI83P_Conj		  (0x4EB5)
#define TI83P_ConvDim	  (0x4B43)
#define TI83P_ConvDim00	  (0x4B46)
#define TI83P_ConvLcToLr	  (0x4A23)
#define TI83P_ConvLrToLc	  (0x4A56)
#define TI83P_ConvOP1	  (0x4AEF)
#define TI83P_COP1Set0	  (0x4105)
#define TI83P_Cos		  (0x40C0)
#define TI83P_CosH		  (0x40CC)
#define TI83P_CpHLDE		  (0x400C)
#define TI83P_CPoint		  (0x4DC8)
#define TI83P_CPointS	  (0x47F5)
#define TI83P_CpOP1OP2	  (0x4111)
#define TI83P_CpOP4OP3	  (0x4108)
#define TI83P_CpyO1ToFPS1	  (0x445C)
#define TI83P_CpyO1ToFPS2	  (0x446B)
#define TI83P_CpyO1ToFPS3	  (0x4477)
#define TI83P_CpyO1ToFPS4	  (0x4489)
#define TI83P_CpyO1ToFPS5	  (0x4483)
#define TI83P_CpyO1ToFPS6	  (0x447D)
#define TI83P_CpyO1ToFPS7	  (0x4480)
#define TI83P_CpyO1ToFPST	  (0x444A)
#define TI83P_CpyO2ToFPS1	  (0x4459)
#define TI83P_CpyO2ToFPS2	  (0x4462)
#define TI83P_CpyO2ToFPS3	  (0x4474)
#define TI83P_CpyO2ToFPS4	  (0x4486)
#define TI83P_CpyO2ToFPST	  (0x4444)
#define TI83P_CpyO3ToFPS1	  (0x4453)
#define TI83P_CpyO3ToFPS2	  (0x4465)
#define TI83P_CpyO3ToFPST	  (0x4441)
#define TI83P_CpyO5ToFPS1	  (0x4456)
#define TI83P_CpyO5ToFPS3	  (0x4471)
#define TI83P_CpyO6ToFPS2	  (0x4468)
#define TI83P_CpyO6ToFPST	  (0x4447)
#define TI83P_CpyStack	  (0x4429)
#define TI83P_CpyTo1FPS1	  (0x4432)
#define TI83P_CpyTo1FPS10	  (0x43F3)
#define TI83P_CpyTo1FPS11	  (0x43D8)
#define TI83P_CpyTo1FPS2	  (0x443B)
#define TI83P_CpyTo1FPS3	  (0x4408)
#define TI83P_CpyTo1FPS4	  (0x440E)
#define TI83P_CpyTo1FPS5	  (0x43DE)
#define TI83P_CpyTo1FPS6	  (0x43E4)
#define TI83P_CpyTo1FPS7	  (0x43EA)
#define TI83P_CpyTo1FPS8	  (0x43ED)
#define TI83P_CpyTo1FPS9	  (0x43F6)
#define TI83P_CpyTo1FPST	  (0x4423)
#define TI83P_CpyTo2FPS1	  (0x442F)
#define TI83P_CpyTo2FPS2	  (0x4438)
#define TI83P_CpyTo2FPS3	  (0x4402)
#define TI83P_CpyTo2FPS4	  (0x43F9)
#define TI83P_CpyTo2FPS5	  (0x43DB)
#define TI83P_CpyTo2FPS6	  (0x43E1)
#define TI83P_CpyTo2FPS7	  (0x43E7)
#define TI83P_CpyTo2FPS8	  (0x43F0)
#define TI83P_CpyTo2FPST	  (0x4420)
#define TI83P_CpyTo3FPS1	  (0x442C)
#define TI83P_CpyTo3FPS2	  (0x4411)
#define TI83P_CpyTo3FPST	  (0x441D)
#define TI83P_CpyTo4FPST	  (0x441A)
#define TI83P_CpyTo5FPST	  (0x4414)
#define TI83P_CpyTo6FPS2	  (0x43FF)
#define TI83P_CpyTo6FPS3	  (0x43FC)
#define TI83P_CpyTo6FPST	  (0x4417)
#define TI83P_CpyToFPS1	  (0x445F)
#define TI83P_CpyToFPS2	  (0x446E)
#define TI83P_CpyToFPS3	  (0x447A)
#define TI83P_CpyToFPST	  (0x444D)
#define TI83P_CpyToStack	  (0x4450)
#define TI83P_Create0Equ	  (0x432A)
#define TI83P_CreateAppVar	  (0x4E6A)
#define TI83P_CreateCList	  (0x431B)
#define TI83P_CreateCplx	  (0x430C)
#define TI83P_CreateEqu	  (0x4330)
#define TI83P_CreatePair	  (0x4B0D)
#define TI83P_CreatePict	  (0x4333)
#define TI83P_CreateProg	  (0x4339)
#define TI83P_CreateProtProg	  (0x4E6D)
#define TI83P_CreateReal	  (0x430F)
#define TI83P_CreateRList	  (0x4315)
#define TI83P_CreateRMat	  (0x4321)
#define TI83P_CreateStrng	  (0x4327)
#define TI83P_CRecip		  (0x4E91)
#define TI83P_CSqRoot	  (0x4E9D)
#define TI83P_CSquare	  (0x4E8B)
#define TI83P_CSub		  (0x4E85)
#define TI83P_CTenX		  (0x4EA6)
#define TI83P_CTrunc		  (0x4EBE)
#define TI83P_Cube		  (0x407B)
#define TI83P_CursorOff	  (0x45BE)
#define TI83P_CursorOn	  (0x45C4)
#define TI83P_CXrootY	  (0x4EAC)
#define TI83P_CYtoX		  (0x4EB2)

#define TI83P_DarkLine	  (0x47DD)
#define TI83P_DarkPnt	  (0x47F2)
#define TI83P_DataSize	  (0x436C)
#define TI83P_DataSizeA	  (0x4369)
#define TI83P_DeallocFPS	  (0x439F)
#define TI83P_DeallocFPS1	  (0x43A2)
#define TI83P_DecO1Exp	  (0x4267)
#define TI83P_DelListEl	  (0x4A2F)
#define TI83P_DelMem		  (0x4357)
#define TI83P_DelRes		  (0x4A20)
#define TI83P_DelVar		  (0x4351)
#define TI83P_DelVarArc	  (0x4FC6)
#define TI83P_DelVarNoArc	  (0x4FC9)
#define TI83P_DisableApd	  (0x4C84)
#define TI83P_Disp		  (0x4F45)
#define TI83P_DispDone	  (0x45B5)
#define TI83P_DispEOL	  (0x45A6)
#define TI83P_DispHL		  (0x4507)
#define TI83P_DisplayImage	  (0x4D9B)
#define TI83P_DispOP1A	  (0x4BF7)
#define TI83P_DivHLBy10	  (0x400F)
#define TI83P_DivHLByA	  (0x4012)
#define TI83P_DrawCirc2	  (0x4C66)
#define TI83P_DrawCmd	  (0x48C1)
#define TI83P_DrawRectBorder	  (0x4D7D)
#define TI83P_DrawRectBorderClear	  (0x4D8C)
#define TI83P_DToR		  (0x4075)

#define TI83P_EditProg	  (0x4A32)
#define TI83P_EnableApd	  (0x4C87)
#define TI83P_EnoughMem	  (0x42FD)
#define TI83P_EOP1NotReal	  (0x4279)
#define TI83P_Equ_or_NewEqu	  (0x42C4)
#define TI83P_EraseEOL	  (0x4552)
#define TI83P_EraseRectBorder	  (0x4D86)
#define TI83P_ErrArgument	  (0x44AD)
#define TI83P_ErrBadGuess	  (0x44CB)
#define TI83P_ErrBreak	  (0x44BF)
#define TI83P_ErrD_OP1_0	  (0x42D3)
#define TI83P_ErrD_OP1_LE_0	  (0x42D0)
#define TI83P_ErrD_OP1Not_R	  (0x42CA)
#define TI83P_ErrD_OP1NotPos	  (0x42C7)
#define TI83P_ErrD_OP1NotPosInt	  (0x42CD)


#define TI83P_ErrDataType	  (0x44AA)
#define TI83P_ErrDimension	  (0x44B3)
#define TI83P_ErrDimMismatch	  (0x44B0)
#define TI83P_ErrDivBy0	  (0x4498)
#define TI83P_ErrDomain	  (0x449E)
#define TI83P_ErrIncrement	  (0x44A1)
#define TI83P_ErrInvalid	  (0x44BC)
#define TI83P_ErrIterations	  (0x44C8)
#define TI83P_ErrLinkXmit	  (0x44D4)
#define TI83P_ErrMemory	  (0x44B9)
#define TI83P_ErrNon_Real	  (0x44A4)
#define TI83P_ErrNonReal	  (0x4A8C)
#define TI83P_ErrNotEnoughMem	  (0x448C)
#define TI83P_ErrOverflow	  (0x4495)
#define TI83P_ErrSignChange	  (0x44C5)
#define TI83P_ErrSingularMat	  (0x449B)
#define TI83P_ErrStat	  (0x44C2)
#define TI83P_ErrStatPlot	  (0x44D1)
#define TI83P_ErrSyntax	  (0x44A7)
#define TI83P_ErrTolTooSmall	  (0x44CE)
#define TI83P_ErrUndefined	  (0x44B6)
#define TI83P_EToX		  (0x40B4)
#define TI83P_Exch9		  (0x43D5)
#define TI83P_ExLp		  (0x4222)
#define TI83P_ExpToHex	  (0x424F)

#define TI83P_Factorial	  (0x4B85)
#define TI83P_FillRect	  (0x4D62)
#define TI83P_FillRectPattern	  (0x4D89)
#define TI83P_Find_Parse_Formula	  (0x4AF2)
#define TI83P_FindAlphaDn	  (0x4A47)
#define TI83P_FindAlphaUp	  (0x4A44)
#define TI83P_FindApp		  (0x4C4E)
#define TI83P_FindAppDn		  (0x4C4B)
#define TI83P_FindAppNumPages	  (0x509B)
#define TI83P_FindAppUp		  (0x4C48)
#define TI83P_FindSym	  (0x42F4)
#define TI83P_FiveExec	  (0x467E)
#define TI83P_FixTempCnt	  (0x4A3B)
#define TI83P_FlashToRam	  (0x5017)
#define TI83P_ForceFullScreen	  (0x508F)
#define TI83P_FormBase	  (0x50AA)
#define TI83P_FormDCplx	  (0x4996)
#define TI83P_FormEReal	  (0x4990)
#define TI83P_FormReal	  (0x4999)
#define TI83P_FourExec	  (0x467B)
#define TI83P_FPAdd		  (0x4072)
#define TI83P_FPDiv		  (0x4099)
#define TI83P_FPMult		  (0x4084)
#define TI83P_FPRecip	  (0x4096)
#define TI83P_FPSquare	  (0x4081)
#define TI83P_FPSub		  (0x406F)
#define TI83P_Frac		  (0x4093)

#define TI83P_GetBaseVer	  (0x4C6F)
#define TI83P_GetCSC		  (0x4018)
#define TI83P_GetKey		  (0x4972)
#define TI83P_GetLToOP1	  (0x4636)
#define TI83P_GetMToOP1	  (0x4615)
#define TI83P_GetTokLen	  (0x4591)
#define TI83P_GrBufClr	  (0x4BD0)
#define TI83P_GrBufCpy	  (0x486A)
#define TI83P_GrphCirc	  (0x47D7)

#define TI83P_HLTimes9	  (0x40F9)
#define TI83P_HorizCmd	  (0x48A6)
#define TI83P_HTimesL	  (0x4276)

#define TI83P_IBounds	  (0x4C60)
#define TI83P_IBoundsFull	  (0x4D98)
#define TI83P_ILine		  (0x47E0)
#define TI83P_IncLstSize	  (0x4A29)
#define TI83P_InsertList	  (0x4A2C)
#define TI83P_InsertMem	  (0x42F7)
#define TI83P_Int		  (0x40A5)
#define TI83P_Intgr		  (0x405D)
#define TI83P_InvCmd		  (0x48C7)
#define TI83P_InvertRect	  (0x4D5F)
#define TI83P_InvOP1S	  (0x408D)
#define TI83P_InvOP1SC	  (0x408A)
#define TI83P_InvOP2S	  (0x4090)
#define TI83P_InvSub		  (0x4063)
#define TI83P_IOffset	  (0x4C63)
#define TI83P_IPoint		  (0x47E3)

#define TI83P_JError		  (0x44D7)
#define TI83P_JErrorNo	  (0x4000)
#define TI83P_JForceCmdNoChar	  (0x4027)
#define TI83P_JForceGraphKey	  (0x5005)
#define TI83P_JForceGraphNoKey	  (0x5002)

#define TI83P_KeyToString	  (0x45CA)

#define TI83P_LineCmd	  (0x48AC)
#define TI83P_LnX		  (0x40AB)
#define TI83P_Load_SFont	  (0x4783)
#define TI83P_LoadCIndPaged	  (0x501D)
#define TI83P_LoadDEIndPaged	  (0x501A)
#define TI83P_LoadPattern	  (0x4CB1)
#define TI83P_LogX		  (0x40AE)

#define TI83P_Max		  (0x4057)
#define TI83P_MemChk		  (0x42E5)
#define TI83P_MemClear	  (0x4C30)
#define TI83P_MemSet		  (0x4C33)
#define TI83P_Min		  (0x4054)
#define TI83P_Minus1		  (0x406C)
#define TI83P_Mov10B		  (0x415C)
#define TI83P_Mov18B		  (0x47DA)
#define TI83P_Mov7B		  (0x4168)
#define TI83P_Mov8B		  (0x4165)
#define TI83P_Mov9B		  (0x415F)
#define TI83P_Mov9OP1OP2	  (0x417D)
#define TI83P_Mov9OP2Cp	  (0x410B)
#define TI83P_Mov9ToOP1	  (0x417A)
#define TI83P_Mov9ToOP2	  (0x4180)
#define TI83P_MovFrOP1	  (0x4183)

#define TI83P_OneVar		  (0x4BA3)
#define TI83P_OP1ExOP2	  (0x421F)
#define TI83P_OP1ExOP3	  (0x4219)
#define TI83P_OP1ExOP4	  (0x421C)
#define TI83P_OP1ExOP5	  (0x420D)
#define TI83P_OP1ExOP6	  (0x4210)
#define TI83P_OP1ExpToDec	  (0x4252)
#define TI83P_OP1Set0	  (0x41BF)
#define TI83P_OP1Set1	  (0x419B)
#define TI83P_OP1Set2	  (0x41A7)
#define TI83P_OP1Set3	  (0x41A1)
#define TI83P_OP1Set4	  (0x419E)
#define TI83P_OP1ToOP2	  (0x412F)
#define TI83P_OP1ToOP3	  (0x4123)
#define TI83P_OP1ToOP4	  (0x4117)
#define TI83P_OP1ToOP5	  (0x4153)
#define TI83P_OP1ToOP6	  (0x4150)
#define TI83P_OP2ExOP4	  (0x4213)
#define TI83P_OP2ExOP5	  (0x4216)
#define TI83P_OP2ExOP6	  (0x4207)
#define TI83P_OP2Set0	  (0x41BC)
#define TI83P_OP2Set1	  (0x41AD)
#define TI83P_OP2Set2	  (0x41AA)
#define TI83P_OP2Set3	  (0x4198)
#define TI83P_OP2Set4	  (0x4195)
#define TI83P_OP2Set5	  (0x418F)
#define TI83P_OP2Set60	  (0x4AB0)
#define TI83P_OP2Set8	  (0x418C)
#define TI83P_OP2SetA	  (0x4192)
#define TI83P_OP2ToOP1	  (0x4156)
#define TI83P_OP2ToOP3	  (0x416E)
#define TI83P_OP2ToOP4	  (0x411A)
#define TI83P_OP2ToOP5	  (0x414A)
#define TI83P_OP2ToOP6	  (0x414D)
#define TI83P_OP3Set0	  (0x41B9)
#define TI83P_OP3Set1	  (0x4189)
#define TI83P_OP3Set2	  (0x41A4)
#define TI83P_OP3ToOP1	  (0x413E)
#define TI83P_OP3ToOP2	  (0x4120)
#define TI83P_OP3ToOP4	  (0x4114)
#define TI83P_OP3ToOP5	  (0x4147)
#define TI83P_OP4Set0	  (0x41B6)
#define TI83P_OP4Set1	  (0x4186)
#define TI83P_OP4ToOP1	  (0x4138)
#define TI83P_OP4ToOP2	  (0x411D)
#define TI83P_OP4ToOP3	  (0x4171)
#define TI83P_OP4ToOP5	  (0x4144)
#define TI83P_OP4ToOP6	  (0x4177)
#define TI83P_OP5ExOP6	  (0x420A)
#define TI83P_OP5Set0	  (0x41B3)
#define TI83P_OP5ToOP1	  (0x413B)
#define TI83P_OP5ToOP2	  (0x4126)
#define TI83P_OP5ToOP3	  (0x4174)
#define TI83P_OP5ToOP4	  (0x412C)
#define TI83P_OP5ToOP6	  (0x4129)
#define TI83P_OP6ToOP1	  (0x4135)
#define TI83P_OP6ToOP2	  (0x4132)
#define TI83P_OP6ToOP5	  (0x4141)
#define TI83P_OutputExpr	  (0x4BB2)

#define TI83P_PagedGet	  (0x5023)
#define TI83P_ParseInp	  (0x4A9B)
#define TI83P_PDspGrph	  (0x48A3)
#define TI83P_PixelTest	  (0x48B5)
#define TI83P_Plus1		  (0x4069)
#define TI83P_PointCmd	  (0x48B2)
#define TI83P_PointOn	  (0x4C39)
#define TI83P_PopOP1		  (0x437E)
#define TI83P_PopOP3		  (0x437B)
#define TI83P_PopOP5		  (0x4378)
#define TI83P_PopReal	  (0x4393)
#define TI83P_PopRealO1	  (0x4390)
#define TI83P_PopRealO2	  (0x438D)
#define TI83P_PopRealO3	  (0x438A)
#define TI83P_PopRealO4	  (0x4387)
#define TI83P_PopRealO5	  (0x4384)
#define TI83P_PopRealO6	  (0x4381)
#define TI83P_PosNo0Int	  (0x422E)
#define TI83P_PtoR		  (0x40F3)
#define TI83P_PushOP1	  (0x43C9)
#define TI83P_PushOP3	  (0x43C3)
#define TI83P_PushOP5	  (0x43C0)
#define TI83P_PushReal	  (0x43BD)
#define TI83P_PushRealO1	  (0x43BA)
#define TI83P_PushRealO2	  (0x43B7)
#define TI83P_PushRealO3	  (0x43B4)
#define TI83P_PushRealO4	  (0x43B1)
#define TI83P_PushRealO5	  (0x43AE)
#define TI83P_PushRealO6	  (0x43AB)
#define TI83P_PutC		  (0x4504)
#define TI83P_PutMap		  (0x4501)
#define TI83P_PutPS		  (0x4510)
#define TI83P_PutS		  (0x450A)
#define TI83P_PutTokString	  (0x4960)
#define TI83P_PutToL		  (0x4645)
#define TI83P_PutToMat	  (0x461E)

#define TI83P_RandInit	  (0x4B7F)
#define TI83P_Random		  (0x4B79)
#define TI83P_Rcl_StatVar	  (0x42DC)
#define TI83P_RclAns		  (0x4AD7)
#define TI83P_RclGDB2	  (0x47D1)
#define TI83P_RclN		  (0x4ADD)
#define TI83P_RclSysTok	  (0x4AE6)
#define TI83P_RclVarSym	  (0x4AE3)
#define TI83P_RclX		  (0x4AE0)
#define TI83P_RclY		  (0x4ADA)
#define TI83P_Rec1stByte	  (0x4EFA)
#define TI83P_Rec1stByteNC	  (0x4EFD)
#define TI83P_RecAByteIO	  (0x4F03)
#define TI83P_RedimMat	  (0x4A26)
#define TI83P_Regraph	  (0x488E)
#define TI83P_ReloadAppEntryVecs	  (0x4C36)
#define TI83P_RestoreDisp	  (0x4870)
#define TI83P_RName		  (0x427F)
#define TI83P_RndGuard	  (0x409F)
#define TI83P_RnFx		  (0x40A2)
#define TI83P_Round		  (0x40A8)
#define TI83P_RToD		  (0x4078)
#define TI83P_RToP		  (0x40F6)
#define TI83P_RunIndicOff	  (0x4570)
#define TI83P_RunIndicOn	  (0x456D)

#define TI83P_SaveDisp	  (0x4C7B)
#define TI83P_SendAByte	  (0x4EE5)
#define TI83P_SetAllPlots	  (0x4FCC)
#define TI83P_SetFuncM	  (0x4840)
#define TI83P_SetNorm_Vals	  (0x49FC)
#define TI83P_SetParM	  (0x4849)
#define TI83P_SetPolM	  (0x4846)
#define TI83P_SetSeqM	  (0x4843)
#define TI83P_SetTblGraphDraw	  (0x4C00)
#define TI83P_SetupPagedPtr	  (0x5020)
#define TI83P_SetXXOP1	  (0x478C)
#define TI83P_SetXXOP2	  (0x478F)
#define TI83P_SetXXXXOP2	  (0x4792)
#define TI83P_SFont_Len	  (0x4786)
#define TI83P_Sin		  (0x40BD)
#define TI83P_SinCosRad	  (0x40BA)
#define TI83P_SinH		  (0x40CF)
#define TI83P_SinHCosH	  (0x40C6)
#define TI83P_SqRoot		  (0x409C)
#define TI83P_SrchVLstDn	  (0x4F12)
#define TI83P_SrchVLstUp	  (0x4F0F)
#define TI83P_SStringLength	  (0x4CB4)
#define TI83P_StMatEl	  (0x4AE9)
#define TI83P_StoAns		  (0x4ABF)
#define TI83P_StoGDB2	  (0x47CE)
#define TI83P_StoN		  (0x4ACB)
#define TI83P_StoOther	  (0x4AD4)
#define TI83P_StoR		  (0x4AC5)
#define TI83P_StoRand	  (0x4B7C)
#define TI83P_StoSysTok	  (0x4ABC)
#define TI83P_StoT		  (0x4ACE)
#define TI83P_StoTheta	  (0x4AC2)
#define TI83P_StoX		  (0x4AD1)
#define TI83P_StoY		  (0x4AC8)
#define TI83P_StrCopy	  (0x44E3)
#define TI83P_StrLength	  (0x4C3F)

#define TI83P_Tan		  (0x40C3)
#define TI83P_TanH		  (0x40C9)
#define TI83P_TanLnF		  (0x48BB)
#define TI83P_TenX		  (0x40B7)
#define TI83P_ThetaName	  (0x427C)
#define TI83P_ThreeExec	  (0x4675)
#define TI83P_Times2		  (0x4066)
#define TI83P_TimesPt5	  (0x407E)
#define TI83P_TName		  (0x428E)
#define TI83P_ToFrac		  (0x4657)
#define TI83P_Trunc		  (0x4060)

#define TI83P_UCLineS	  (0x4795)
#define TI83P_UnLineCmd	  (0x48AF)
#define TI83P_UnOPExec	  (0x4672)

#define TI83P_VertCmd	  (0x48A9)
#define TI83P_VPutMap	  (0x455E)
#define TI83P_VPutS		  (0x4561)
#define TI83P_VPutSN		  (0x4564)
#define TI83P_VtoWHLDE	  (0x47FB)


#define TI83P_XftoI		  (0x4804)
#define TI83P_Xitof		  (0x47FE)
#define TI83P_XName		  (0x4288)
#define TI83P_XRootY		  (0x479E)

#define TI83P_YftoI		  (0x4801)
#define TI83P_YName		  (0x428B)
#define TI83P_YToX		  (0x47A1)

#define TI83P_Zero16D	  (0x41B0)
#define TI83P_ZeroOP		  (0x41CE)
#define TI83P_ZeroOP1	  (0x41C5)
#define TI83P_ZeroOP2	  (0x41C8)
#define TI83P_ZeroOP3	  (0x41CB)
#define TI83P_ZmDecml	  (0x484F)
#define TI83P_ZmFit		  (0x485B)
#define TI83P_ZmInt		  (0x484C)
#define TI83P_ZmPrev		  (0x4852)
#define TI83P_ZmSquare	  (0x485E)
#define TI83P_ZmStats	  (0x47A4)
#define TI83P_ZmTrig		  (0x4861)
#define TI83P_ZmUsr		  (0x4855)
#define TI83P_ZooDefault	  (0x4867)
//
//= ()=====================================================================
//           System-defined RAM Variable Address Equates
//= ()=====================================================================
//

#define TI83P_ramStart               (0x8000)
#define TI83P_appData                (0x8000)
#define TI83P_ramCode                (0x8100)
#define TI83P_ramCodeEnd             (0x822F)
#define TI83P_baseAppBrTab           (0x8230)
#define TI83P_bootTemp               (0x8251)
#define TI83P_appSearchPage          (0x82A3)
#define TI83P_tempSwapArea           (0x82A5)
#define TI83P_appID                  (0x838D)
#define TI83P_ramReturnData          (0x83ED)
#define TI83P_arcInfo                (0x83EE)
#define TI83P_savedArcInfo           (0x8406)
#define TI83P_appInfo                (0x8432)
#define TI83P_appBank_jump           (0x843C)
#define TI83P_appPage                (0x843E)
#define TI83P_kbdScanCode            (0x843F)
#define TI83P_kbdKey                 (0x8444)
#define TI83P_kbdGetKy               (0x8445)
#define TI83P_keyExtend              (0x8446)
#define TI83P_contrast               (0x8447)
#define TI83P_apdSubTimer            (0x8448)
#define TI83P_apdTimer               (0x8449)
#define TI83P_curTime                (0x844A)
#define TI83P_curRow                 (0x844B)
#define TI83P_curCol                 (0x844C)
#define TI83P_curOffset              (0x844D)
#define TI83P_curUnder               (0x844E)
#define TI83P_curY                   (0x844F)
#define TI83P_curType                (0x8450)
#define TI83P_curXRow                (0x8451)
#define TI83P_prevDData              (0x8452)
#define TI83P_lFont_record           (0x845A)
#define TI83P_sFont_record           (0x8462)
#define TI83P_tokVarPtr              (0x846A)
#define TI83P_tokLen                 (0x846C)
#define TI83P_indicMem               (0x846E)
#define TI83P_indicCounter           (0x8476)
#define TI83P_indicBusy              (0x8477)
#define TI83P_OP1                    (0x8478)
#define TI83P_OP1M                   (0x847A)
#define TI83P_OP2                    (0x8483)
#define TI83P_OP2M                   (0x8485)
#define TI83P_OP2EXT                 (0x848C)
#define TI83P_OP3                    (0x848E)
#define TI83P_OP3M                   (0x8490)
#define TI83P_OP4                    (0x8499)
#define TI83P_OP4M                   (0x849B)
#define TI83P_OP5                    (0x84A4)
#define TI83P_OP5M                   (0x84A6)
#define TI83P_OP6                    (0x84AF)
#define TI83P_OP6M                   (0x84B1)
#define TI83P_OP6EXT                 (0x84B8)
#define TI83P_progToEdit             (0x84BF)
#define TI83P_nameBuff               (0x84C7)
#define TI83P_equ_edit_save          (0x84D2)
#define TI83P_iMathPtr1              (0x84D3)
#define TI83P_iMathPtr2              (0x84D5)
#define TI83P_iMathPtr3              (0x84D7)
#define TI83P_iMathPtr4              (0x84D9)
#define TI83P_iMathPtr5              (0x84DB)
#define TI83P_chkDelPtr1             (0x84DD)
#define TI83P_chkDelPtr2             (0x84DF)
#define TI83P_insDelPtr              (0x84E1)
#define TI83P_upDownPtr              (0x84E3)
#define TI83P_fOutDat                (0x84E5)
#define TI83P_asm_data_ptr1          (0x84EB)
#define TI83P_asm_data_ptr2          (0x84ED)
#define TI83P_asm_sym_ptr1           (0x84EF)
#define TI83P_asm_sym_ptr2           (0x84F1)
#define TI83P_asm_ram                (0x84F3)
#define TI83P_asm_ind_call           (0x8507)
#define TI83P_textShadow             (0x8508)
#define TI83P_textShadCur            (0x8588)
#define TI83P_textShadTop            (0x858A)
#define TI83P_textShadAlph           (0x858B)
#define TI83P_textShadIns            (0x858C)
#define TI83P_cxMain                 (0x858D)
#define TI83P_cxPPutAway             (0x858F)
#define TI83P_cxPutAway              (0x8591)
#define TI83P_cxRedisp               (0x8593)
#define TI83P_cxErrorEP              (0x8595)
#define TI83P_cxSizeWind             (0x8597)
#define TI83P_cxPage                 (0x8599)
#define TI83P_cxCurApp               (0x859A)
#define TI83P_cxPrev                 (0x859B)
#define TI83P_monQH                  (0x85AA)
#define TI83P_monQT                  (0x85AB)
#define TI83P_monQueue               (0x85AC)
#define TI83P_onSP                   (0x85BC)
#define TI83P_promptRow              (0x85C0)
#define TI83P_promptCol              (0x85C1)
#define TI83P_promptIns              (0x85C2)
#define TI83P_promptShift            (0x85C3)
#define TI83P_promptRet              (0x85C4)
#define TI83P_promptValid            (0x85C6)
#define TI83P_promptTop              (0x85C8)
#define TI83P_promptCursor           (0x85CA)
#define TI83P_promptTail             (0x85CC)
#define TI83P_promptBtm              (0x85CE)
#define TI83P_varType                (0x85D0)
#define TI83P_varCurrent             (0x85D1)
#define TI83P_varClass               (0x85D9)
#define TI83P_menuActive             (0x85DC)
#define TI83P_menuAppDepth           (0x85DD)
#define TI83P_MenuCurrent            (0x85DE)
#define TI83P_ProgCurrent            (0x85E8)
#define TI83P_userMenuSA             (0x85FE)
#define TI83P_ioPrompt               (0x865F)
#define TI83P_dImageWidth            (0x8660)
#define TI83P_ioFlag                 (0x8670)
#define TI83P_sndRecState            (0x8672)
#define TI83P_ioErrState             (0x8673)
#define TI83P_header                 (0x8674)
#define TI83P_ioData                 (0x867D)
#define TI83P_ioNewData              (0x8689)
#define TI83P_bakHeader              (0x868B)
#define TI83P_penCol                 (0x86D7)
#define TI83P_penRow                 (0x86D8)
#define TI83P_rclQueue               (0x86D9)
#define TI83P_rclQueueEnd            (0x86DB)
#define TI83P_errNo                  (0x86DD)
#define TI83P_errSP                  (0x86DE)
#define TI83P_errOffset              (0x86E0)
#define TI83P_saveSScreen            (0x86EC)
#define TI83P_bstCounter             (0x89EE)
#define TI83P_flags                  (0x89F0)
#define TI83P_statVars               (0x8A3A)
#define TI83P_anovaf_vars            (0x8C17)
#define TI83P_infVars                (0x8C4D)
#define TI83P_curGStyle              (0x8D17)
#define TI83P_curGY                  (0x8D18)
#define TI83P_curGX                  (0x8D19)
#define TI83P_curGY2                 (0x8D1A)
#define TI83P_curGX2                 (0x8D1B)
#define TI83P_freeSaveY              (0x8D1C)
#define TI83P_freeSaveX              (0x8D1D)
#define TI83P_XOffset                (0x8DA1)
#define TI83P_YOffset                (0x8DA2)
#define TI83P_lcdTallP               (0x8DA3)
#define TI83P_pixWideP               (0x8DA4)
#define TI83P_pixWide_m_1            (0x8DA5)
#define TI83P_pixWide_m_2            (0x8DA6)
#define TI83P_lastEntryPTR           (0x8DA7)
#define TI83P_lastEntryStk           (0x8DA9)
#define TI83P_numLastEntries         (0x8E29)
#define TI83P_currLastEntry          (0x8E2A)
#define TI83P_curInc                 (0x8E67)
#define TI83P_uXmin                  (0x8E7E)
#define TI83P_uXmax                  (0x8E87)
#define TI83P_uXscl                  (0x8E90)
#define TI83P_uYmin                  (0x8E99)
#define TI83P_uYmax                  (0x8EA2)
#define TI83P_uYscl                  (0x8EAB)
#define TI83P_uThetMin               (0x8EB4)
#define TI83P_uThetMax               (0x8EBD)
#define TI83P_uThetStep              (0x8EC6)
#define TI83P_uTmin                  (0x8ECF)
#define TI83P_uTmax                  (0x8ED8)
#define TI83P_uTStep                 (0x8EE1)
#define TI83P_uPlotStart             (0x8EEA)
#define TI83P_unMax                  (0x8EF3)
#define TI83P_uu0                    (0x8EFC)
#define TI83P_uv0                    (0x8F05)
#define TI83P_unMin                  (0x8F0E)
#define TI83P_uu02                   (0x8F17)
#define TI83P_uv02                   (0x8F20)
#define TI83P_uw0                    (0x8F29)
#define TI83P_uPlotStep              (0x8F32)
#define TI83P_uXres                  (0x8F3B)
#define TI83P_uw02                   (0x8F44)
#define TI83P_Xmin                   (0x8F50)
#define TI83P_Xmax                   (0x8F59)
#define TI83P_Xscl                   (0x8F62)
#define TI83P_Ymin                   (0x8F6B)
#define TI83P_Ymax                   (0x8F74)
#define TI83P_Yscl                   (0x8F7D)
#define TI83P_ThetaMin               (0x8F86)
#define TI83P_ThetaMax               (0x8F8F)
#define TI83P_ThetaStep              (0x8F98)
#define TI83P_TminPar                (0x8FA1)
#define TI83P_TmaxPar                (0x8FAA)
#define TI83P_Tstep                  (0x8FB3)
#define TI83P_PlotStart              (0x8FBC)
#define TI83P_nMax                   (0x8FC5)
#define TI83P_u0                     (0x8FCE)
#define TI83P_v0                     (0x8FD7)
#define TI83P_nMin                   (0x8FE0)
#define TI83P_u02                    (0x8FE9)
#define TI83P_v02                    (0x8FF2)
#define TI83P_w0                     (0x8FFB)
#define TI83P_PlotStep               (0x9004)
#define TI83P_XresO                  (0x900D)
#define TI83P_w02                    (0x9016)
#define TI83P_un1                    (0x901F)
#define TI83P_un2                    (0x9028)
#define TI83P_vn1                    (0x9031)
#define TI83P_vn2                    (0x903A)
#define TI83P_wn1                    (0x9043)
#define TI83P_wn2                    (0x904C)
#define TI83P_fin_N                  (0x9055)
#define TI83P_fin_I                  (0x905E)
#define TI83P_fin_PV                 (0x9067)
#define TI83P_fin_PMT                (0x9070)
#define TI83P_fin_FV                 (0x9079)
#define TI83P_fin_PY                 (0x9082)
#define TI83P_fin_CY                 (0x908B)
#define TI83P_cal_N                  (0x9094)
#define TI83P_cal_I                  (0x909D)
#define TI83P_cal_PV                 (0x90A6)
#define TI83P_cal_PMT                (0x90AF)
#define TI83P_cal_FV                 (0x90B8)
#define TI83P_cal_PY                 (0x90C1)
#define TI83P_smallEditRAM           (0x90D3)
#define TI83P_XFact                  (0x913F)
#define TI83P_YFact                  (0x9148)
#define TI83P_Xres_int               (0x9151)
#define TI83P_deltaX                 (0x9152)
#define TI83P_deltaY                 (0x915B)
#define TI83P_shortX                 (0x9164)
#define TI83P_shortY                 (0x916D)
#define TI83P_lower                  (0x9176)
#define TI83P_upper                  (0x917F)
#define TI83P_XOutSym                (0x918C)
#define TI83P_XOutDat                (0x918E)
#define TI83P_YOutSym                (0x9190)
#define TI83P_YOutDat                (0x9192)
#define TI83P_inputSym               (0x9194)
#define TI83P_inputDat               (0x9196)
#define TI83P_prevData               (0x9198)
#define TI83P_TblMin                 (0x92B3)
#define TI83P_TblStep                (0x92BC)
#define TI83P_plotSScreen            (0x9340)
#define TI83P_seed1                  (0x9640)
#define TI83P_seed2                  (0x9649)
#define TI83P_cmdShadow              (0x966E)
#define TI83P_cmdShadCur             (0x96EE)
#define TI83P_cmdShadAlph            (0x96F0)
#define TI83P_cmdShadIns             (0x96F1)
#define TI83P_cmdCursor              (0x96F2)
#define TI83P_editTop                (0x96F4)
#define TI83P_editCursor             (0x96F6)
#define TI83P_editTail               (0x96F8)
#define TI83P_editBtm                (0x96FA)
#define TI83P_editSym                (0x9706)
#define TI83P_editDat                (0x9708)
#define TI83P_winTop                 (0x97A5)
#define TI83P_winBtm                 (0x97A6)
#define TI83P_winLeftEdge            (0x97A7)
#define TI83P_winLeft                (0x97A8)
#define TI83P_winAbove               (0x97AA)
#define TI83P_winRow                 (0x97AC)
#define TI83P_winCol                 (0x97AE)
#define TI83P_fmtDigits              (0x97B0)
#define TI83P_fmtString              (0x97B1)
#define TI83P_fmtConv                (0x97F2)
#define TI83P_fmtLeft                (0x9804)
#define TI83P_fmtIndex               (0x9806)
#define TI83P_fmtMatSym              (0x9808)
#define TI83P_fmtMatMem              (0x980A)
#define TI83P_EQS                    (0x980C)
#define TI83P_tSymPtr1               (0x9818)
#define TI83P_tSymPtr2               (0x981A)
#define TI83P_chkDelPtr3             (0x981C)
#define TI83P_chkDelPtr4             (0x981E)
#define TI83P_tempMem                (0x9820)
#define TI83P_fpBase                 (0x9822)
#define TI83P_FPS                    (0x9824)
#define TI83P_OPBase                 (0x9826)
#define TI83P_OPS                    (0x9828)
#define TI83P_pTempCnt               (0x982A)
#define TI83P_cleanTmp               (0x982C)
#define TI83P_pTemp                  (0x982E)
#define TI83P_progPtr                (0x9830)
#define TI83P_newDataPtr             (0x9832)
#define TI83P_pagedCount             (0x9834)
#define TI83P_pagedPN                (0x9835)
#define TI83P_pagedGetPtr            (0x9836)
#define TI83P_pagedPutPtr            (0x9838)
#define TI83P_pagedBuf               (0x983A)
#define TI83P_appErr1                (0x984D)
#define TI83P_appErr2                (0x985A)
#define TI83P_flashByte1             (0x9867)
#define TI83P_flashByte2             (0x9868)
#define TI83P_freeArcBlock           (0x9869)
#define TI83P_arcPage                (0x986B)
#define TI83P_arcPtr                 (0x986C)
#define TI83P_appRawKeyHandle        (0x9870)
#define TI83P_appBackUpScreen        (0x9872)
#define TI83P_customHeight           (0x9B72)
#define TI83P_localLanguage          (0x9B73)
#define TI83P_cursorHookPtr          (0x9B7C)
#define TI83P_rawKeyHookPtr          (0x9B84)
#define TI83P_getKeyHookPtr          (0x9B88)
#define TI83P_fontHookPtr            (0x9B9C)
#define TI83P_restartClr             (0x9BD0)
#define TI83P_localTokStr            (0x9D65)
#define TI83P_keyForStr              (0x9D76)
#define TI83P_keyToStrRam            (0x9D77)
#define TI83P_sedMonSp               (0x9D88)
#define TI83P_bpSave                 (0x9D8A)
#define TI83P_userMem                (0x9D95)
#define TI83P_symTable               (0x0FE66)

//SYMBOLIC_DEBUG_END
//
//= ()=====================================================================
//           Error handler equates/macros 
//= ()=====================================================================
//
#define TI83P_APP_PUSH_ERRORH   (0x59)
#define TI83P_APP_POP_ERRORH	  (0x5C)
//
//
//= ()=====================================================================
//           System and State Flags
//= ()=====================================================================
//

#define TI83P_trigFlags	  (0)//Trigonometry mode settings
#define TI83P_trigDeg 	  (2)// 1= TI83P_degrees, 0=radians

#define TI83P_kbdFlags	  (0)//Keyboard scan
#define TI83P_kbdSCR		  (3)// 1= TI83P_scan code ready
#define TI83P_kbdKeyPress	  (4)// 1= TI83P_key has been pressed

#define TI83P_doneFlags	  (0)//display "Done"
#define TI83P_donePrgm	  (5)// 1= TI83P_display "Done" after prgm

#define TI83P_ioDelFlag	  (0)
#define TI83P_inDelete	  (0)//1 = TI83P_DELETE SCREEN 

//----------------------------------------------------------------------
#define TI83P_editFlags	  (1)
#define TI83P_editOpen	  (2)// 1= TI83P_edit buffer is open

#define TI83P_monFlags	  (1)//monitor flags
#define TI83P_monAbandon	  (4)// 1= TI83P_don''t start any long process
//----------------------------------------------------------------------
#define TI83P_plotFlags	  (2)//plot generation flags
#define TI83P_plotLoc 	  (1)// 0= TI83P_bkup & display, 1=display only
#define TI83P_plotDisp	  (2)// 1= TI83P_plot is in display, 0=text in display


#define TI83P_grfModeFlags	  (2)//graph mode settings
#define TI83P_grfFuncM	  (4)// 1= TI83P_function graph
#define TI83P_grfPolarM	  (5)// 1= TI83P_polar graph
#define TI83P_grfParamM	  (6)// 1= TI83P_parametric graph
#define TI83P_grfRecurM         (7)// 1= TI83P_RECURSION graph

#define TI83P_graphFlags	  (3)
#define TI83P_graphDraw	  (0)// 0= TI83P_graph is valid, 1=redraw graph

#define TI83P_grfDBFlags	  (4)
#define TI83P_grfDot		  (0)// 0= TI83P_line, 1=dot
#define TI83P_grfSimul	  (1)// 0= TI83P_sequential, 1=simultaneous
#define TI83P_grfGrid 	  (2)// 0= TI83P_no grid, 1=grid
#define TI83P_grfPolar	  (3)// 0= TI83P_rectangular, 1=polar coordinates
#define TI83P_grfNoCoord	  (4)// 0= TI83P_display coordinates, 1=off
#define TI83P_grfNoAxis	  (5)// 0= TI83P_axis, 1=no axis
#define TI83P_grfLabel	  (6)// 0= TI83P_off, 1=axis label

#define TI83P_textFlags	  (5)//Text output flags
#define TI83P_textEraseBelow	  (1)// 1= TI83P_erase line below small char
#define TI83P_textScrolled	  (2)// 1= TI83P_screen scrolled
#define TI83P_textInverse	  (3)// 1= TI83P_display inverse bit-map
#define TI83P_textInsMode	  (4)// 0= TI83P_overstrike, 1=insert mode

#define TI83P_ParsFlag2	  (7)//PARSER flags
#define TI83P_numOP1		  (0)// 1= TI83P_RESULT IN OP1, 0=NO RESULT

#define TI83P_newDispF          (8)//Derivative mode flags
#define TI83P_preClrForMode     (0)// 1= TI83P_HELP BLINK ON MODE SCREEN

#define TI83P_apdFlags	  (8)//Automatic power-down
#define TI83P_apdAble 	  (2)// 1= TI83P_APD enabled
#define TI83P_apdRunning	  (3)// 1= TI83P_APD clock running


#define TI83P_web_err_mask      (0x60)

#define TI83P_onFlags 	  (9)//on key flags
#define TI83P_onInterrupt	  (4)// 1= TI83P_on key interrupt request

#define TI83P_statFlags	  (9)//statistics flags
#define TI83P_statsValid	  (6)// 1= TI83P_stats are valid

#define TI83P_fmtFlags	  (10)//numeric format flags
#define TI83P_fmtExponent	  (0)// 1= TI83P_show exponent, 0=no exponent
#define TI83P_fmtEng		  (1)// 1= TI83P_engineering notion, 0=scientific
#define TI83P_fmtHex		  (2)// 1= TI83P_hexadecimal
#define TI83P_fmtOct		  (3)// 1= TI83P_octal
#define TI83P_fmtBin		  (4)// 1= TI83P_binary
//
#define TI83P_numMode           (10)
#define TI83P_fmtReal           (5)
#define TI83P_fmtRect           (6)
#define TI83P_fmtPolar          (7)

#define TI83P_realMode          (5)
#define TI83P_rectMode          (6)
#define TI83P_polarMode         (7)
//					;   if Hex and Oct both = (1)
//					;   then Bin= (0 means >Frac)
//					;	 Bin= (1 means >DMS)
//TI83P_fmtBaseMask     = (00011100B)| mask to base flags
#define TI83P_fmtBaseShift      (2)// offset to base flags
//
//       CHECK IF THESE ARE USED BY NUMFORM,
//

#define TI83P_fmtOverride	  (11)//copy of fmtFlags with conversion override

#define TI83P_fmtEditFlags	  (12) //numeric editing flags
#define TI83P_fmtEdit 	  (0) // 1= TI83P_format number for editing

#define TI83P_curFlags	  (12)//Cursor
#define TI83P_curAble 	  (2)// 1= TI83P_cursor flash is enabled
#define TI83P_curOn		  (3)// 1= TI83P_cursor is showing
#define TI83P_curLock 	  (4)// 1= TI83P_cursor is locked off

#define TI83P_appFlags	  (13)//application flags
#define TI83P_appWantIntrpt	  (0)// 1= TI83P_want ON key interrupts
#define TI83P_appTextSave	  (1)// 1= TI83P_save characters in textShadow
#define TI83P_appAutoScroll	  (2)// 1= TI83P_auto-scroll text on last line
#define TI83P_appMenus	  (3)// 1= TI83P_process keys that bring up menus
#define TI83P_appLockMenus	  (4)// 1= TI83P_ignore menu keys
//TI83P_					| 0= (TI83P_switch to home screen and bring up menu)
#define TI83P_appCurGraphic	  (5)// 1= TI83P_graphic cursor
#define TI83P_appCurWord	  (6)// 1= TI83P_text cursor covers entire word
#define TI83P_appExit 	  (7)// 1= TI83P_application handles [EXIT] key itself



#define TI83P_seqFlags          (15)// Sequential Graph flags
#define TI83P_webMode           (0)// 0 = TI83P_NORMAL SEQ MODE, 1 = WEB MODE
#define TI83P_webVert           (1)//
#define TI83P_sequv             (2)// U vs V
#define TI83P_seqvw             (3)// V vs W
#define TI83P_sequw             (4)// U vs W


#define TI83P_promptFlags	  (17)//prompt line flags
#define TI83P_promptEdit	  (0)// 1= TI83P_editing in prompt buffer

#define TI83P_indicFlags	  (18)//Indicator flags
#define TI83P_indicRun	  (0)// 1= TI83P_run indicator ON
#define TI83P_indicInUse	  (1)// indicator save area in use=1, free=0
#define TI83P_indicOnly	  (2)// interrupt handler only checks run indicator

#define TI83P_shiftFlags	  (18)//[2nd] and [ALPHA] flags
#define TI83P_shift2nd	  (3)// 1= TI83P_[2nd] has been pressed
#define TI83P_shiftAlpha	  (4)// 1= TI83P_[ALPHA] has been pressed
#define TI83P_shiftLwrAlph	  (5)// 1= TI83P_lower case, 0=upper case
#define TI83P_shiftALock	  (6)// 1= TI83P_alpha lock has been pressed
#define TI83P_shiftKeepAlph	  (7)// 1= TI83P_cannot cancel alpha shift


#define TI83P_tblFlags          (19)//table flags.
#define TI83P_autoFill          (4)// 1= TI83P_prompt, 0=fillAuto
#define TI83P_autoCalc          (5)// 1= TI83P_prompt, 0=CalcAuto
#define TI83P_reTable           (6)// 0= TI83P_table is ok, 1=must recompute table.

#define TI83P_sGrFlags	  (20)
#define TI83P_grfSplit          (0)// 1= TI83P_Split Graph, 0=Normal
#define TI83P_vertSplit         (1)// 1= TI83P_Vertical (left-right) Split
#define TI83P_grfSChanged       (2)// 1= TI83P_Graph just changed Split <-> normal
#define TI83P_grfSplitOverride   (3)// 1 = TI83P_ignore graph split flag if set
#define TI83P_write_on_graph    (4)// 1 = TI83P_TEXT OR EQU WRITING TO GRAPH SCREEN
#define TI83P_g_style_active    (5)// 1 = TI83P_GRAPH STYLES ARE ENABLED, USE THEM
#define TI83P_cmp_mod_box       (6)// 1 = TI83P_DOING MOD BOX PLOT COMPUTATION
#define TI83P_textWrite         (7)
//

#define TI83P_newIndicFlags     (21)
#define TI83P_extraIndic        (0)
#define TI83P_saIndic           (1)

#define TI83P_smartFlags        (23)
//
//----------------------------------------------------------------------
// Note: Fix these Equates if smartFlags are moved                            
//----------------------------------------------------------------------
//
#define TI83P_smarter_mask      (3)
#define TI83P_smarter_test      (1)
#define TI83P_smartGraph        (0)
#define TI83P_smartGraph_inv    (1)

//----------------------------------------------------------------------
//           Available for ASM programming
//----------------------------------------------------------------------

#define TI83P_asm_Flag1         (33)// ASM CODING
#define TI83P_asm_Flag2         (34)// ASM CODING
#define TI83P_asm_Flag3         (35)// ASM CODING

//----------------------------------------------------------------------
//
#define TI83P_getSendFlg	  (36)
#define TI83P_comFailed	  (1)// 1 = TI83P_Get/Send Communication Failed
//
#define TI83P_appLwrCaseFlag    (36)
#define TI83P_lwrCaseActive     (3)
//
#define TI83P_apiFlg3		  (42)
//
#define TI83P_apiFlg4		  (43)
#define TI83P_fullScrnDraw	  (2)// DRAW INTO LAST ROW/COL OF SCREEN

#define TI83P_groupFlags	  (38)
#define TI83P_inGroup		  (1)//1 = TI83P_IN GROUP CONTEXT


#define TI83P_xapFlag0          (46)// external app flags
#define TI83P_xapFlag1          (47)
#define TI83P_xapFlag2          (48)
#define TI83P_xapFlag3          (49)

#define TI83P_fontFlags	  (50)
#define TI83P_fracDrawLFont	  (2)
#define TI83P_fracTallLFont	  (3)
#define TI83P_customFont	  (7)

#define TI83P_plotFlag3	  (60)
#define TI83P_bufferOnly	  (0)
#define TI83P_useFastCirc	  (4)

//
#define TI83P_varTypeMask	  (0x1F)
#define TI83P_varGraphRef	  (6)

//
//= ()=====================================================================
//           Character Font equates  
//= ()=====================================================================
//
#define TI83P_LrecurN           (0x001)
#define TI83P_LrecurU 	  (0x002)
#define TI83P_LrecurV 	  (0x003)
#define TI83P_LrecurW		  (0x004)
#define TI83P_Lconvert	  (0x005)
#define TI83P_LsqUp		  (0x006)
#define TI83P_LsqDown		  (0x007)
#define TI83P_Lintegral	  (0x008)
#define TI83P_Lcross		  (0x009)
#define TI83P_LboxIcon 	  (0x00A)
#define TI83P_LcrossIcon 	  (0x00B)
#define TI83P_LdotIcon 	  (0x00C)
#define TI83P_LsubT   	  (0x00D)//small capital T for parametric mode.
#define TI83P_LcubeR  	  (0x00E)//slightly different 3 for cubed root.
#define TI83P_LhexF		  (0x00F)
#define TI83P_Lroot		  (0x010)
#define TI83P_Linverse	  (0x011)
#define TI83P_Lsquare		  (0x012)
#define TI83P_Langle		  (0x013)
#define TI83P_Ldegree		  (0x014)
#define TI83P_Lradian		  (0x015)
#define TI83P_Ltranspose	  (0x016)
#define TI83P_LLE		  (0x017)
#define TI83P_LNE		  (0x018)
#define TI83P_LGE		  (0x019)
#define TI83P_Lneg		  (0x01A)
#define TI83P_Lexponent	  (0x01B)
#define TI83P_Lstore		  (0x01C)
#define TI83P_Lten		  (0x01D)
#define TI83P_LupArrow	  (0x01E)
#define TI83P_LdownArrow	  (0x01F)
#define TI83P_Lspace		  (0x020)
#define TI83P_Lexclam		  (0x021)
#define TI83P_Lquote		  (0x022)
#define TI83P_Lpound		  (0x023)
#define TI83P_Lfourth		  (0x024)
#define TI83P_Lpercent	  (0x025)
#define TI83P_Lampersand	  (0x026)
#define TI83P_Lapostrophe	  (0x027)
#define TI83P_LlParen		  (0x028)
#define TI83P_LrParen		  (0x029)
#define TI83P_Lasterisk	  (0x02A)
#define TI83P_LplusSign	  (0x02B)
#define TI83P_Lcomma		  (0x02C)
#define TI83P_Ldash		  (0x02D)
#define TI83P_Lperiod		  (0x02E)
#define TI83P_Lslash		  (0x02F)
#define TI83P_L0		  (0x030)
#define TI83P_L1		  (0x031)
#define TI83P_L2		  (0x032)
#define TI83P_L3		  (0x033)
#define TI83P_L4		  (0x034)
#define TI83P_L5		  (0x035)
#define TI83P_L6		  (0x036)
#define TI83P_L7		  (0x037)
#define TI83P_L8		  (0x038)
#define TI83P_L9		  (0x039)
#define TI83P_Lcolon		  (0x03A)
#define TI83P_Lsemicolon	  (0x03B)
#define TI83P_LLT		  (0x03C)
#define TI83P_LEQ		  (0x03D)
#define TI83P_LGT		  (0x03E)
#define TI83P_Lquestion	  (0x03F)
#define TI83P_LatSign		  (0x040)
#define TI83P_LcapA	  (0x041)
#define TI83P_LcapB	  (0x042)
#define TI83P_LcapC	  (0x043)
#define TI83P_LcapD	  (0x044)
#define TI83P_LcapE	  (0x045)
#define TI83P_LcapF	  (0x046)
#define TI83P_LcapG	  (0x047)
#define TI83P_LcapH	  (0x048)
#define TI83P_LcapI	  (0x049)
#define TI83P_LcapJ	  (0x04A)
#define TI83P_LcapK	  (0x04B)
#define TI83P_LcapL	  (0x04C)
#define TI83P_LcapM	  (0x04D)
#define TI83P_LcapN	  (0x04E)
#define TI83P_LcapO	  (0x04F)
#define TI83P_LcapP	  (0x050)
#define TI83P_LcapQ	  (0x051)
#define TI83P_LcapR	  (0x052)
#define TI83P_LcapS	  (0x053)
#define TI83P_LcapT	  (0x054)
#define TI83P_LcapU	  (0x055)
#define TI83P_LcapV	  (0x056)
#define TI83P_LcapW	  (0x057)
#define TI83P_LcapX	  (0x058)
#define TI83P_LcapY	  (0x059)
#define TI83P_LcapZ	  (0x05A)
#define TI83P_Ltheta    (0x05B)
#define TI83P_Lbackslash	  (0x05C)
#define TI83P_LrBrack		  (0x05D)
#define TI83P_Lcaret		  (0x05E)
#define TI83P_Lunderscore	  (0x05F)
#define TI83P_Lbackquote	  (0x060)
#define TI83P_La	  (0x061)
#define TI83P_Lb	  (0x062)
#define TI83P_Lc	  (0x063)
#define TI83P_Ld	  (0x064)
#define TI83P_Le	  (0x065)
#define TI83P_Lf	  (0x066)
#define TI83P_Lg	  (0x067)
#define TI83P_Lh	  (0x068)
#define TI83P_Li	  (0x069)
#define TI83P_Lj	  (0x06A)
#define TI83P_Lk	  (0x06B)
#define TI83P_Ll	  (0x06C)
#define TI83P_Lm	  (0x06D)
#define TI83P_Ln	  (0x06E)
#define TI83P_Lo	  (0x06F)
#define TI83P_Lp	  (0x070)
#define TI83P_Lq	  (0x071)
#define TI83P_Lr	  (0x072)
#define TI83P_Ls	  (0x073)
#define TI83P_Lt	  (0x074)
#define TI83P_Lu	  (0x075)
#define TI83P_Lv	  (0x076)
#define TI83P_Lw	  (0x077)
#define TI83P_Lx	  (0x078)
#define TI83P_Ly	  (0x079)
#define TI83P_Lz	  (0x07A)
#define TI83P_LlBrace	  (0x07B)
#define TI83P_Lbar	  (0x07C)
#define TI83P_LrBrace	  (0x07D)
#define TI83P_Ltilde	  (0x07E)
#define TI83P_LinvEQ	  (0x07F)
#define TI83P_Lsub0	  (0x080)
#define TI83P_Lsub1	  (0x081)
#define TI83P_Lsub2	  (0x082)
#define TI83P_Lsub3	  (0x083)
#define TI83P_Lsub4	  (0x084)
#define TI83P_Lsub5	  (0x085)
#define TI83P_Lsub6	  (0x086)
#define TI83P_Lsub7	  (0x087)
#define TI83P_Lsub8	  (0x088)
#define TI83P_Lsub9	  (0x089)
#define TI83P_LcapAAcute	  (0x08A)
#define TI83P_LcapAGrave	  (0x08B)
#define TI83P_LcapACaret	  (0x08C)
#define TI83P_LcapADier	  (0x08D)
#define TI83P_LaAcute		  (0x08E)
#define TI83P_LaGrave		  (0x08F)
#define TI83P_LaCaret		  (0x090)
#define TI83P_LaDier		  (0x091)
#define TI83P_LcapEAcute	  (0x092)
#define TI83P_LcapEGrave	  (0x093)
#define TI83P_LcapECaret	  (0x094)
#define TI83P_LcapEDier	  (0x095)
#define TI83P_LeAcute		  (0x096)
#define TI83P_LeGrave		  (0x097)
#define TI83P_LeCaret		  (0x098)
#define TI83P_LeDier		  (0x099)
#define TI83P_LcapIAcute	  (0x09A)
#define TI83P_LcapIGrave	  (0x09B)
#define TI83P_LcapICaret	  (0x09C)
#define TI83P_LcapIDier	  (0x09D)
#define TI83P_LiAcute		  (0x09E)
#define TI83P_LiGrave		  (0x09F)
#define TI83P_LiCaret		  (0x0A0)
#define TI83P_LiDier		  (0x0A1)
#define TI83P_LcapOAcute	  (0x0A2)
#define TI83P_LcapOGrave	  (0x0A3)
#define TI83P_LcapOCaret	  (0x0A4)
#define TI83P_LcapODier	  (0x0A5)
#define TI83P_LoAcute		  (0x0A6)
#define TI83P_LoGrave		  (0x0A7)
#define TI83P_LoCaret		  (0x0A8)
#define TI83P_LoDier		  (0x0A9)
#define TI83P_LcapUAcute	  (0x0AA)
#define TI83P_LcapUGrave	  (0x0AB)
#define TI83P_LcapUCaret	  (0x0AC)
#define TI83P_LcapUDier	  (0x0AD)
#define TI83P_LuAcute		  (0x0AE)
#define TI83P_LuGrave		  (0x0AF)
#define TI83P_LuCaret		  (0x0B0)
#define TI83P_LuDier		  (0x0B1)
#define TI83P_LcapCCed	  (0x0B2)
#define TI83P_LcCed		  (0x0B3)
#define TI83P_LcapNTilde	  (0x0B4)
#define TI83P_LnTilde		  (0x0B5)
#define TI83P_Laccent		  (0x0B6)
#define TI83P_Lgrave		  (0x0B7)
#define TI83P_Ldieresis	  (0x0B8)
#define TI83P_LquesDown	  (0x0B9)
#define TI83P_LexclamDown	  (0x0BA)
#define TI83P_Lalpha		  (0x0BB)
#define TI83P_Lbeta		  (0x0BC)
#define TI83P_Lgamma		  (0x0BD)
#define TI83P_LcapDelta	  (0x0BE)
#define TI83P_Ldelta		  (0x0BF)
#define TI83P_Lepsilon	  (0x0C0)
#define TI83P_LlBrack 	  (0x0C1)
#define TI83P_Llambda		  (0x0C2)
#define TI83P_Lmu		  (0x0C3)
#define TI83P_Lpi		  (0x0C4)
#define TI83P_Lrho		  (0x0C5)
#define TI83P_LcapSigma	  (0x0C6)
#define TI83P_Lsigma		  (0x0C7)
#define TI83P_Ltau		  (0x0C8)
#define TI83P_Lphi		  (0x0C9)
#define TI83P_LcapOmega	  (0x0CA)
#define TI83P_LxMean		  (0x0CB)
#define TI83P_LyMean		  (0x0CC)
#define TI83P_LsupX		  (0x0CD)
#define TI83P_Lellipsis	  (0x0CE)
#define TI83P_Lleft		  (0x0CF)
#define TI83P_Lblock		  (0x0D0)
#define TI83P_Lper		  (0x0D1)
#define TI83P_Lhyphen		  (0x0D2)
#define TI83P_Larea		  (0x0D3)
#define TI83P_Ltemp		  (0x0D4)
#define TI83P_Lcube		  (0x0D5)
#define TI83P_Lenter		  (0x0D6)
#define TI83P_LimagI		  (0x0D7)
#define TI83P_Lphat		  (0x0D8)
#define TI83P_Lchi		  (0x0D9)
#define TI83P_LstatF		  (0x0DA)
#define TI83P_Llne		  (0x0DB)
#define TI83P_LlistL		  (0x0DC)
#define TI83P_LfinanN 	  (0x0DD)
#define TI83P_L2_r_paren 	  (0x0DE)
#define TI83P_LblockArrow       (0x0DF)
#define TI83P_LcurO   	  (0x0E0)
#define TI83P_LcurO2  	  (0x0E1)
#define TI83P_LcurOcapA         (0x0E2)
#define TI83P_LcurOa  	  (0x0E3)
#define TI83P_LcurI   	  (0x0E4)
#define TI83P_LcurI2  	  (0x0E5)
#define TI83P_LcurIcapA         (0x0E6)
#define TI83P_LcurIa  	  (0x0E7)
#define TI83P_LGline            (0x0E8)// = 0
#define TI83P_LGthick           (0x0E9)// = 1
#define TI83P_LGabove           (0x0EA)// = 2
#define TI83P_LGbelow           (0x0EB)// = 3
#define TI83P_LGpath            (0x0EC)// = 4
#define TI83P_LGanimate         (0x0ED)// = 5
#define TI83P_LGdot             (0x0EE)// = 6
#define TI83P_LUpBlk            (0x0EF)//Up arrow and Block in solver
#define TI83P_LDnBlk            (0x0F0)//Down arrow and Block in solver
#define TI83P_LcurFull          (0x0F1)//note: must be last char (PutMap checks)
//
//= ()=====================================================================
//           Keypress Equates
//= ()=====================================================================
//           Keyboard key names
//
//
#define TI83P_kRight            (0x001)
#define TI83P_kLeft             (0x002)
#define TI83P_kUp               (0x003)
#define TI83P_kDown             (0x004)
#define TI83P_kEnter            (0x005)
#define TI83P_kAlphaEnter       (0x006)
#define TI83P_kAlphaUp          (0x007)
#define TI83P_kAlphaDown        (0x008)
#define TI83P_kClear            (0x009)
#define TI83P_kDel              (0x00A)
#define TI83P_kIns              (0x00B)
#define TI83P_kRecall           (0x00C)
#define TI83P_kLastEnt          (0x00D)
#define TI83P_kBOL              (0x00E)
#define TI83P_kEOL              (0x00F)
//
#define TI83P_kSelAll           (0x010)
#define TI83P_kUnselAll         (0x011)
#define TI83P_kLtoTI82          (0x012)
#define TI83P_kBackup           (0x013)
#define TI83P_kRecieve          (0x014)
#define TI83P_kLnkQuit          (0x015)
#define TI83P_kTrans            (0x016)
#define TI83P_kRename           (0x017)
#define TI83P_kOverw            (0x018)
#define TI83P_kOmit             (0x019)
#define TI83P_kCont             (0x01A)
#define TI83P_kSendID           (0x01B)
#define TI83P_kSendSW           (0x01C)
#define TI83P_kYes              (0x01D)
#define TI83P_kNoWay            (0x01E)
#define TI83P_kvSendType        (0x01F)
#define TI83P_kOverWAll         (0x020)
//
#define TI83P_kNo               (0x025)
#define TI83P_kKReset           (0x026)
#define TI83P_kApp              (0x027)
//
#define TI83P_kDoug             (0x028)
#define TI83P_kListflag         (0x029)
#define TI83P_menuStart         (0x02B)
//
#define TI83P_kAreYouSure       (0x02B)
#define TI83P_kAppsMenu         (0x02C)
#define TI83P_kPrgm             (0x02D)
#define TI83P_kZoom             (0x02E)
#define TI83P_kDraw             (0x02F)
#define TI83P_kSPlot            (0x030)
#define TI83P_kStat             (0x031)
#define TI83P_kMath             (0x032)
#define TI83P_kTest             (0x033)
#define TI83P_kChar             (0x034)
#define TI83P_kVars             (0x035)
#define TI83P_kMem              (0x036)
#define TI83P_kMatrix           (0x037)
#define TI83P_kDist             (0x038)
#define TI83P_kAngle            (0x039)
#define TI83P_kList             (0x03A)
#define TI83P_kCalc             (0x03B)
#define TI83P_kFin              (0x03C)
//
#define TI83P_menuEnd           (TI83P_kFin)
//
#define TI83P_kCatalog          (0x03E)
#define TI83P_kInputDone        (0x03F)
#define TI83P_kOff              (TI83P_kInputDone)
//
#define TI83P_kQuit             (0x040)
#define TI83P_appStart          (TI83P_kQuit)

//
#define TI83P_kLinkIO           (0x041)
#define TI83P_kMatrixEd         (0x042)
#define TI83P_kStatEd           (0x043)
#define TI83P_kGraph            (0x044)
#define TI83P_kMode             (0x045)
#define TI83P_kPrgmEd           (0x046)// PROGRAM EDIT
#define TI83P_kPrgmCr           (0x047)// PROGRAM CREATE
#define TI83P_kWindow           (0x048)// RANGE EDITOR
#define TI83P_kYequ             (0x049)// EQUATION EDITOR
#define TI83P_kTable            (0x04A)// TABLE EDITOR
#define TI83P_kTblSet           (0x04B)// TABLE SET
#define TI83P_kChkRAM           (0x04C)// CHECK RAM
#define TI83P_kDelMem           (0x04D)// DELETE MEM
#define TI83P_kResetMem         (0x04E)// RESET MEM
#define TI83P_kResetDef	  ( 0x04F)// RESET DEFAULT
#define TI83P_kPrgmInput        (0x050)// PROGRAM INPUT
#define TI83P_kZFactEd          (0x051)// ZOOM FACTOR EDITOR
#define TI83P_kError            (0x052)// ERROR
#define TI83P_kSolveTVM         (0x053)// TVM SOLVER
#define TI83P_kSolveRoot	  ( 0x054)// SOLVE EDITOR
#define TI83P_kStatP            (0x055)// stat plot
#define TI83P_kInfStat 	  ( 0x056)// Inferential Statistic
#define TI83P_kFormat           (0x057)// FORMAT
#define TI83P_kExtApps          (0x058)// External Applications.     NEW
#define TI83P_kNewApps          (0x059)// New Apps for Cerberus.
//
#define TI83P_append            (TI83P_kNewApps)
//
#define TI83P_echoStart1        (0x05A)
//
#define TI83P_kTrace            (0x05A)
#define TI83P_kZFit             (0x05B)
#define TI83P_kZIn              (0x05C)
#define TI83P_kZOut             (0x05D)
#define TI83P_kZPrev            (0x05E)
#define TI83P_kBox              (0x05F)
#define TI83P_kDecml            (0x060)
#define TI83P_kSetZm            (0x061)
#define TI83P_kSquar            (0x062)
#define TI83P_kStd              (0x063)
#define TI83P_kTrig             (0x064)
#define TI83P_kUsrZm            (0x065)
#define TI83P_kZSto             (0x066)
#define TI83P_kZInt             (0x067)
#define TI83P_kZStat            (0x068)
//
#define TI83P_echoStart2        (0x069)
//
#define TI83P_kSelect           (0x069)
#define TI83P_kCircl            (0x06A)
#define TI83P_kClDrw            (0x06B)
#define TI83P_kLine             (0x06C)
#define TI83P_kPen              (0x06D)
#define TI83P_kPtChg            (0x06E)
#define TI83P_kPtOff            (0x06F)
#define TI83P_kPtOn             (0x070)
#define TI83P_kVert             (0x071)
#define TI83P_kHoriz            (0x072)
#define TI83P_kText             (0x073)
#define TI83P_kTanLn            (0x074)
//
#define TI83P_kEval             (0x075)
#define TI83P_kInters           (0x076)
#define TI83P_kDYDX             (0x077)
#define TI83P_kFnIntg           (0x078)
#define TI83P_kRootG            (0x079)
#define TI83P_kDYDT             (0x07A)
#define TI83P_kDXDT             (0x07B)
#define TI83P_kDRDo             (0x07C)
#define TI83P_KGFMin            (0x07D)
#define TI83P_KGFMax            (0x07E)
//
//
#define TI83P_EchoStart         (0x07F)
//
#define TI83P_kListName         (0x07F)
#define TI83P_kAdd              (0x080)
#define TI83P_kSub              (0x081)
#define TI83P_kMul              (0x082)
#define TI83P_kDiv              (0x083)
#define TI83P_kExpon            (0x084)
#define TI83P_kLParen           (0x085)
#define TI83P_kRParen           (0x086)
#define TI83P_kLBrack           (0x087)
#define TI83P_kRBrack           (0x088)
#define TI83P_kShade            (0x089)
#define TI83P_kStore            (0x08A)
#define TI83P_kComma            (0x08B)
#define TI83P_kChs              (0x08C)
#define TI83P_kDecPnt           (0x08D)
#define TI83P_k0                (0x08E)
#define TI83P_k1                (0x08F)
#define TI83P_k2                (0x090)
#define TI83P_k3                (0x091)
#define TI83P_k4                (0x092)
#define TI83P_k5                (0x093)
#define TI83P_k6                (0x094)
#define TI83P_k7                (0x095)
#define TI83P_k8                (0x096)
#define TI83P_k9                (0x097)
#define TI83P_kEE               (0x098)
#define TI83P_kSpace            (0x099)
#define TI83P_kCapA             (0x09A)
#define TI83P_kCapB             (0x09B)
#define TI83P_kCapC             (0x09C)
#define TI83P_kCapD             (0x09D)
#define TI83P_kCapE             (0x09E)
#define TI83P_kCapF             (0x09F)
#define TI83P_kCapG             (0x0A0)
#define TI83P_kCapH             (0x0A1)
#define TI83P_kCapI             (0x0A2)
#define TI83P_kCapJ             (0x0A3)
#define TI83P_kCapK             (0x0A4)
#define TI83P_kCapL             (0x0A5)
#define TI83P_kCapM             (0x0A6)
#define TI83P_kCapN             (0x0A7)
#define TI83P_kCapO             (0x0A8)
#define TI83P_kCapP             (0x0A9)
#define TI83P_kCapQ             (0x0AA)
#define TI83P_kCapR             (0x0AB)
#define TI83P_kCapS             (0x0AC)
#define TI83P_kCapT             (0x0AD)
#define TI83P_kCapU             (0x0AE)
#define TI83P_kCapV             (0x0AF)
#define TI83P_kCapW             (0x0B0)
#define TI83P_kCapX             (0x0B1)
#define TI83P_kCapY             (0x0B2)
#define TI83P_kCapZ             (0x0B3)
#define TI83P_kVarx             (0x0B4)
#define TI83P_kPi               (0x0B5)
#define TI83P_kInv              (0x0B6)
#define TI83P_kSin              (0x0B7)
#define TI83P_kASin             (0x0B8)
#define TI83P_kCos              (0x0B9)
#define TI83P_kACos             (0x0BA)
#define TI83P_kTan              (0x0BB)
#define TI83P_kATan             (0x0BC)
#define TI83P_kSquare           (0x0BD)
#define TI83P_kSqrt             (0x0BE)
#define TI83P_kLn               (0x0BF)
#define TI83P_kExp              (0x0C0)
#define TI83P_kLog              (0x0C1)
#define TI83P_kALog             (0x0C2)
#define TI83P_kToABC            (0x0C3)
//
#define TI83P_kClrTbl           (0x0C4)
//
#define TI83P_kAns              (0x0C5)
#define TI83P_kColon            (0x0C6)
//
#define TI83P_kNDeriv           (0x0C7)
#define TI83P_kFnInt            (0x0C8)
#define TI83P_kRoot             (0x0C9)
//
#define TI83P_kQuest            (0x0CA)
#define TI83P_kQuote            (0x0CB)
#define TI83P_kTheta            (0x0CC)
#define TI83P_kIf               (0x0CD)
#define TI83P_kThen             (0x0CE)
#define TI83P_kElse             (0x0CF)
#define TI83P_kFor              (0x0D0)
#define TI83P_kWhile            (0x0D1)
#define TI83P_kRepeat           (0x0D2)
#define TI83P_kEnd              (0x0D3)
#define TI83P_kPause            (0x0D4)
#define TI83P_kLbl              (0x0D5)
#define TI83P_kGoto             (0x0D6)
#define TI83P_kISG              (0x0D7)
#define TI83P_kDSL              (0x0D8)
#define TI83P_kMenu             (0x0D9)
#define TI83P_kExec             (0x0DA)
#define TI83P_kReturn           (0x0DB)
#define TI83P_kStop             (0x0DC)
#define TI83P_kInput            (0x0DD)
#define TI83P_kPrompt           (0x0DE)
#define TI83P_kDisp             (0x0DF)
#define TI83P_kDispG            (0x0E0)
#define TI83P_kDispT            (0x0E1)
#define TI83P_kOutput           (0x0E2)
#define TI83P_kGetKey           (0x0E3)
#define TI83P_kClrHome          (0x0E4)
#define TI83P_kPrtScr           (0x0E5)
#define TI83P_kSinH             (0x0E6)
#define TI83P_kCosH             (0x0E7)
#define TI83P_kTanH             (0x0E8)
#define TI83P_kASinH            (0x0E9)
#define TI83P_kACosH            (0x0EA)
#define TI83P_kATanH            (0x0EB)
#define TI83P_kLBrace           (0x0EC)
#define TI83P_kRBrace           (0x0ED)
#define TI83P_kI                (0x0EE)
#define TI83P_kCONSTeA          (0x0EF)
#define TI83P_kPlot3            (0x0F0)
#define TI83P_kFMin             (0x0F1)
#define TI83P_kFMax             (0x0F2)
#define TI83P_kL1A              (0x0F3)
#define TI83P_kL2A              (0x0F4)
#define TI83P_kL3A              (0x0F5)
#define TI83P_kL4A              (0x0F6)
#define TI83P_kL5A              (0x0F7)
#define TI83P_kL6A              (0x0F8)
#define TI83P_kunA              (0x0F9)
#define TI83P_kvnA              (0x0FA)
#define TI83P_kwnA              (0x0FB)
//
//= ()=====================================================================
//       THIS KEY MEANS THAT IT IS A 2 BYTE KEYCODE
//       THERE ARE 2 OF THESE KEYS; BE CAREFUL WITH USAGE
//= ()=====================================================================
//
#define TI83P_kExtendEcho2      (0x0FC)
//
//= ()===================================================================== TI83P_;
//       THIS KEY MEANS THAT THE KEY PRESS IS ONE THAT ECHOS
//       INTO A BUFFER, AND IT IS A 2 BYTE KEY CODE, GO LOOK AT
//       (EXTECHO) FOR THE KEY VALUE 
//= ()=====================================================================
//
#define TI83P_kExtendEcho       (0x0FE)
//

#define TI83P_kE1BT             (0)

#define TI83P_kDrawInv          (TI83P_kE1BT)
#define TI83P_kDrawF            (TI83P_kE1BT+1)
#define TI83P_kPixelOn          (TI83P_kE1BT+2)
#define TI83P_kPixelOff         (TI83P_kE1BT+3)
#define TI83P_kPxlTest          (TI83P_kE1BT+4)
#define TI83P_kRCGDB            (TI83P_kE1BT+5)
#define TI83P_kRCPic            (TI83P_kE1BT+6)
#define TI83P_kSTGDB            (TI83P_kE1BT+7)
#define TI83P_kSTPic            (TI83P_kE1BT+8)
#define TI83P_kAbs              (TI83P_kE1BT+9)
#define TI83P_kTEqu             (TI83P_kE1BT+10)// ==
#define TI83P_kTNoteQ           (TI83P_kE1BT+11)// <>
#define TI83P_kTGT              (TI83P_kE1BT+12)// >
#define TI83P_kTGTE             (TI83P_kE1BT+13)// > =
#define TI83P_kTLT              (TI83P_kE1BT+14)// <
#define TI83P_kTLTE             (TI83P_kE1BT+15)// < =

#define TI83P_kAnd              (TI83P_kE1BT+16)
#define TI83P_kOr               (TI83P_kE1BT+17)
#define TI83P_kXor              (TI83P_kE1BT+18)
#define TI83P_kNot              (TI83P_kE1BT+19)

#define TI83P_kLR1              (TI83P_kE1BT+20)

#define TI83P_kXRoot            (TI83P_kE1BT+21)
#define TI83P_kCube             (TI83P_kE1BT+22)
#define TI83P_kCbRt             (TI83P_kE1BT+23)// Cube ROOT
#define TI83P_kToDec            (TI83P_kE1BT+24)
//
#define TI83P_kCubicR           (TI83P_kE1BT+25)
#define TI83P_kQuartR           (TI83P_kE1BT+26)
//
#define TI83P_kPlot1            (TI83P_kE1BT+27)
#define TI83P_kPlot2            (TI83P_kE1BT+28)
//

#define TI83P_kRound            (TI83P_kE1BT+29)
#define TI83P_kIPart            (TI83P_kE1BT+30)
#define TI83P_kFPart            (TI83P_kE1BT+31)
#define TI83P_kInt              (TI83P_kE1BT+32)

#define TI83P_kRand             (TI83P_kE1BT+33)
#define TI83P_kNPR              (TI83P_kE1BT+34)
#define TI83P_kNCR              (TI83P_kE1BT+35)
#define TI83P_kXFactorial       (TI83P_kE1BT+36)

#define TI83P_kRad              (TI83P_kE1BT+37)
#define TI83P_kDegr             (TI83P_kE1BT+38)// DEGREES CONV
#define TI83P_kAPost            (TI83P_kE1BT+39)
#define TI83P_kToDMS            (TI83P_kE1BT+40)
#define TI83P_kRToPo            (TI83P_kE1BT+41)// R
#define TI83P_kRToPr            (TI83P_kE1BT+42)
#define TI83P_kPToRx            (TI83P_kE1BT+43)
#define TI83P_kPToRy            (TI83P_kE1BT+44)

#define TI83P_kRowSwap          (TI83P_kE1BT+45)
#define TI83P_kRowPlus          (TI83P_kE1BT+46)
#define TI83P_kTimRow           (TI83P_kE1BT+47)
#define TI83P_kTRowP            (TI83P_kE1BT+48)

#define TI83P_kSortA            (TI83P_kE1BT+49)
#define TI83P_kSortD            (TI83P_kE1BT+50)
#define TI83P_kSeq              (TI83P_kE1BT+51)

#define TI83P_kMin              (TI83P_kE1BT+52)
#define TI83P_kMax              (TI83P_kE1BT+53)
#define TI83P_kMean             (TI83P_kE1BT+54)
#define TI83P_kMedian           (TI83P_kE1BT+55)
#define TI83P_kSum              (TI83P_kE1BT+56)
#define TI83P_kProd             (TI83P_kE1BT+57)

#define TI83P_kDet              (TI83P_kE1BT+58)
#define TI83P_kTransp           (TI83P_kE1BT+59)
#define TI83P_kDim              (TI83P_kE1BT+60)
#define TI83P_kFill             (TI83P_kE1BT+61)
#define TI83P_kIdent            (TI83P_kE1BT+62)
#define TI83P_kRandm            (TI83P_kE1BT+63)
#define TI83P_kAug              (TI83P_kE1BT+64)

#define TI83P_kOneVar           (TI83P_kE1BT+65)
#define TI83P_kTwoVar           (TI83P_kE1BT+66)
#define TI83P_kLR               (TI83P_kE1BT+67)
#define TI83P_kLRExp            (TI83P_kE1BT+68)
#define TI83P_kLRLn             (TI83P_kE1BT+69)
#define TI83P_kLRPwr            (TI83P_kE1BT+70)
#define TI83P_kMedMed           (TI83P_kE1BT+71)
#define TI83P_kQuad             (TI83P_kE1BT+72)
#define TI83P_kClrLst           (TI83P_kE1BT+73)
#define TI83P_kHist             (TI83P_kE1BT+74)
#define TI83P_kxyLine           (TI83P_kE1BT+75)
#define TI83P_kScatter          (TI83P_kE1BT+76)

#define TI83P_kmRad             (TI83P_kE1BT+77)
#define TI83P_kmDeg             (TI83P_kE1BT+78)
#define TI83P_kmNormF           (TI83P_kE1BT+79)
#define TI83P_kmSci             (TI83P_kE1BT+80)
#define TI83P_kmEng             (TI83P_kE1BT+81)
#define TI83P_kmFloat           (TI83P_kE1BT+82)

#define TI83P_kFix              (TI83P_kE1BT+83)
#define TI83P_kSplitOn          (TI83P_kE1BT+84)
#define TI83P_kFullScreen       (TI83P_kE1BT+85)
#define TI83P_kStndrd           (TI83P_kE1BT+86)
#define TI83P_kParam            (TI83P_kE1BT+87)
#define TI83P_kPolar            (TI83P_kE1BT+88)
#define TI83P_kSeqG             (TI83P_kE1BT+89)
#define TI83P_kAFillOn          (TI83P_kE1BT+90)
#define TI83P_kAFillOff         (TI83P_kE1BT+91)
#define TI83P_kACalcOn          (TI83P_kE1BT+92)
#define TI83P_kACalcOff         (TI83P_kE1BT+93)
#define TI83P_kFNOn             (TI83P_kE1BT+94)
#define TI83P_kFNOff            (TI83P_kE1BT+95)

#define TI83P_kPlotsOn          (TI83P_kE1BT+96)
#define TI83P_kPlotsOff         (TI83P_kE1BT+97)

#define TI83P_kPixelChg         (TI83P_kE1BT+98)

#define TI83P_kSendMBL          (TI83P_kE1BT+99)
#define TI83P_kRecvMBL          (TI83P_kE1BT+100)

#define TI83P_kBoxPlot          (TI83P_kE1BT+101)
#define TI83P_kBoxIcon          (TI83P_kE1BT+102)
#define TI83P_kCrossIcon        (TI83P_kE1BT+103)
#define TI83P_kDotIcon          (TI83P_kE1BT+104)

#define TI83P_kE2BT             (TI83P_kE1BT+105)

#define TI83P_kSeqential        (TI83P_kE2BT)
#define TI83P_kSimulG           (TI83P_kE2BT+1)
#define TI83P_kPolarG           (TI83P_kE2BT+2)
#define TI83P_kRectG            (TI83P_kE2BT+3)
#define TI83P_kCoordOn          (TI83P_kE2BT+4)
#define TI83P_kCoordOff         (TI83P_kE2BT+5)
#define TI83P_kDrawLine         (TI83P_kE2BT+6)
#define TI83P_kDrawDot          (TI83P_kE2BT+7)
#define TI83P_kAxisOn           (TI83P_kE2BT+8)
#define TI83P_kAxisOff          (TI83P_kE2BT+9)
#define TI83P_kGridOn           (TI83P_kE2BT+10)
#define TI83P_kGridOff          (TI83P_kE2BT+11)
#define TI83P_kLblOn            (TI83P_kE2BT+12)
#define TI83P_kLblOff           (TI83P_kE2BT+13)

#define TI83P_kL1               (TI83P_kE2BT+14)
#define TI83P_kL2               (TI83P_kE2BT+15)
#define TI83P_kL3               (TI83P_kE2BT+16)
#define TI83P_kL4               (TI83P_kE2BT+17)
#define TI83P_kL5               (TI83P_kE2BT+18)
#define TI83P_kL6               (TI83P_kE2BT+19)

//
//= ()=====================================================================
//           These keys are layed on top of existing keys to
//           enable localization in the inferential stats editor
//= ()=====================================================================
//
#define TI83P_kinfData          (TI83P_kL1)
#define TI83P_kinfStats         (TI83P_kL1+1)
#define TI83P_kinfYes           (TI83P_kL1+2)
#define TI83P_kinfNo            (TI83P_kL1+3)
#define TI83P_kinfCalc          (TI83P_kL1+4)
#define TI83P_kinfDraw          (TI83P_kL1+5)
#define TI83P_kinfAlt1ne        (TI83P_kL1+6)
#define TI83P_kinfAlt1lt        (TI83P_kL1+7)
#define TI83P_kinfAlt1gt        (TI83P_kL1+8)
#define TI83P_kinfAlt2ne        (TI83P_kL1+9)
#define TI83P_kinfAlt2lt        (TI83P_kL1+10)
#define TI83P_kinfAlt2gt        (TI83P_kL1+11)
#define TI83P_kinfAlt3ne        (TI83P_kL1+12)
#define TI83P_kinfAlt3lt        (TI83P_kL1+13)
#define TI83P_kinfAlt3gt        (TI83P_kL1+14)
#define TI83P_kinfAlt4ne        (TI83P_kL1+15)
#define TI83P_kinfAlt4lt        (TI83P_kL1+16)
#define TI83P_kinfAlt4gt        (TI83P_kL1+17)
#define TI83P_kinfAlt5ne        (TI83P_kL1+18)
#define TI83P_kinfAlt5lt        (TI83P_kL1+19)
#define TI83P_kinfAlt5gt        (TI83P_kL1+20)
#define TI83P_kinfAlt6ne        (TI83P_kL1+21)
#define TI83P_kinfAlt6lt        (TI83P_kL1+22)
#define TI83P_kinfAlt6gt        (TI83P_kL1+23)
//
//
#define TI83P_kMatA             (TI83P_kE2BT+20)
#define TI83P_kMatB             (TI83P_kE2BT+21)
#define TI83P_kMatC             (TI83P_kE2BT+22)
#define TI83P_kMatD             (TI83P_kE2BT+23)
#define TI83P_kMatE             (TI83P_kE2BT+24)

#define TI83P_kXmin             (TI83P_kE2BT+25)
#define TI83P_kXmax             (TI83P_kE2BT+26)
#define TI83P_kXscl             (TI83P_kE2BT+27)
#define TI83P_kYmin             (TI83P_kE2BT+28)
#define TI83P_kYmax             (TI83P_kE2BT+29)
#define TI83P_kYscl             (TI83P_kE2BT+30)
#define TI83P_kTmin             (TI83P_kE2BT+31)
#define TI83P_kTmax             (TI83P_kE2BT+32)
#define TI83P_kTStep            (TI83P_kE2BT+33)
#define TI83P_kOmin             (TI83P_kE2BT+34)
#define TI83P_kOmax             (TI83P_kE2BT+35)
#define TI83P_kOStep            (TI83P_kE2BT+36)
#define TI83P_ku0               (TI83P_kE2BT+37)
#define TI83P_kv0               (TI83P_kE2BT+38)
#define TI83P_knMin             (TI83P_kE2BT+39)
#define TI83P_knMax             (TI83P_kE2BT+40)
#define TI83P_kDeltaY           (TI83P_kE2BT+41)
#define TI83P_kDeltaX           (TI83P_kE2BT+42)

#define TI83P_kZXmin            (TI83P_kE2BT+43)
#define TI83P_kZXmax            (TI83P_kE2BT+44)
#define TI83P_kZXscl            (TI83P_kE2BT+45)
#define TI83P_kZYmin            (TI83P_kE2BT+46)
#define TI83P_kZYmax            (TI83P_kE2BT+47)
#define TI83P_kZYscl            (TI83P_kE2BT+48)
#define TI83P_kZTmin            (TI83P_kE2BT+49)
#define TI83P_kZTmax            (TI83P_kE2BT+50)
#define TI83P_kZTStep           (TI83P_kE2BT+51)
#define TI83P_kZOmin            (TI83P_kE2BT+52)
#define TI83P_kZOmax            (TI83P_kE2BT+53)
#define TI83P_kZOStep           (TI83P_kE2BT+54)
#define TI83P_kZu0              (TI83P_kE2BT+55)
#define TI83P_kZv0              (TI83P_kE2BT+56)
#define TI83P_kZnMin            (TI83P_kE2BT+57)
#define TI83P_kZnMax            (TI83P_kE2BT+58)

#define TI83P_kDelLast          (TI83P_kE2BT+59)
#define TI83P_kSinReg           (TI83P_kE2BT+60)
#define TI83P_kConstE           (TI83P_kE2BT+61)

#define TI83P_kPic1             (TI83P_kE2BT+62)
#define TI83P_kPic2             (TI83P_kE2BT+63)
#define TI83P_kPic3             (TI83P_kE2BT+64)

#define TI83P_kDelVar           (TI83P_kE2BT+65)
#define TI83P_kGetCalc          (TI83P_kE2BT+66)
#define TI83P_kRealM            (TI83P_kE2BT+67)
#define TI83P_kPolarM           (TI83P_kE2BT+68)
#define TI83P_kRectM            (TI83P_kE2BT+69)
#define TI83P_kuv               (TI83P_kE2BT+70)// U vs V
#define TI83P_kvw               (TI83P_kE2BT+71)// V vs W
#define TI83P_kuw               (TI83P_kE2BT+72)// U vs W
#define TI83P_kFinPMTend        (TI83P_kE2BT+73)
#define TI83P_kFinPMTbeg        (TI83P_kE2BT+74)
//
#define TI83P_kGraphStyle       (TI83P_kE2BT+75)
//
#define TI83P_kExprOn           (TI83P_kE2BT+76)
#define TI83P_kExprOff          (TI83P_kE2BT+77)
#define TI83P_kStatA            (TI83P_kE2BT+78)
#define TI83P_kStatB            (TI83P_kE2BT+79)
#define TI83P_kStatC            (TI83P_kE2BT+80)
#define TI83P_kCorr             (TI83P_kE2BT+81)
#define TI83P_kStatD            (TI83P_kE2BT+82)
#define TI83P_kStatE            (TI83P_kE2BT+83)
#define TI83P_kRegEq            (TI83P_kE2BT+84)
#define TI83P_kMinX             (TI83P_kE2BT+85)
#define TI83P_kQ1               (TI83P_kE2BT+86)
#define TI83P_kMD               (TI83P_kE2BT+87)
#define TI83P_kQ3               (TI83P_kE2BT+88)
#define TI83P_kMaxX             (TI83P_kE2BT+89)
#define TI83P_kStatX1           (TI83P_kE2BT+90)
#define TI83P_kStatY1           (TI83P_kE2BT+91)
#define TI83P_kStatX2           (TI83P_kE2BT+92)
#define TI83P_kStatY2           (TI83P_kE2BT+93)
#define TI83P_kStatX3           (TI83P_kE2BT+94)
#define TI83P_kStatY3           (TI83P_kE2BT+95)
#define TI83P_kTblMin           (TI83P_kE2BT+96)
#define TI83P_kTblStep          (TI83P_kE2BT+97)
#define TI83P_kSetupLst         (TI83P_kE2BT+98)
#define TI83P_kClrAllLst        (TI83P_kE2BT+99)
#define TI83P_kLogistic         (TI83P_kE2BT+100)
#define TI83P_kZTest            (TI83P_kE2BT+101)
#define TI83P_kTTest            (TI83P_kE2BT+102)
#define TI83P_k2SampZTest       (TI83P_kE2BT+103)
#define TI83P_k2SampTTest       (TI83P_kE2BT+104)
#define TI83P_k1PropZTest       (TI83P_kE2BT+105)
#define TI83P_k2PropZTest       (TI83P_kE2BT+106)
#define TI83P_kChiTest          (TI83P_kE2BT+107)
#define TI83P_k2SampFTest       (TI83P_kE2BT+108)
#define TI83P_kZIntVal          (TI83P_kE2BT+109)
#define TI83P_kTIntVal          (TI83P_kE2BT+110)
#define TI83P_k2SampTInt        (TI83P_kE2BT+111)
#define TI83P_k2SampZInt        (TI83P_kE2BT+112)
#define TI83P_k1PropZInt        (TI83P_kE2BT+113)
#define TI83P_k2PropZInt        (TI83P_kE2BT+114)
#define TI83P_kDNormal          (TI83P_kE2BT+115)
#define TI83P_kInvNorm          (TI83P_kE2BT+116)
#define TI83P_kDT               (TI83P_kE2BT+117)
#define TI83P_kChi              (TI83P_kE2BT+118)
#define TI83P_kDF               (TI83P_kE2BT+119)
#define TI83P_kBinPDF           (TI83P_kE2BT+120)
#define TI83P_kBinCDF           (TI83P_kE2BT+121)
#define TI83P_kPoiPDF           (TI83P_kE2BT+122)
#define TI83P_kPoiCDF           (TI83P_kE2BT+123)
#define TI83P_kun               (TI83P_kE2BT+124)
#define TI83P_kvn               (TI83P_kE2BT+125)
#define TI83P_kwn               (TI83P_kE2BT+126)
#define TI83P_kRecn             (TI83P_kE2BT+127)
#define TI83P_kPlotStart        (TI83P_kE2BT+128)
#define TI83P_kZPlotStart       (TI83P_kE2BT+129)// recursion n
#define TI83P_kXFact            (TI83P_kE2BT+130)// PlotStart
#define TI83P_kYFact            (TI83P_kE2BT+131)// ZPlotStart
#define TI83P_kANOVA            (TI83P_kE2BT+132)// XFact
#define TI83P_kMaxY             (TI83P_kE2BT+133)// YFact
#define TI83P_kWebOn            (TI83P_kE2BT+134)// MinY
#define TI83P_kWebOff           (TI83P_kE2BT+135)// MaxY
#define TI83P_kTblInput         (TI83P_kE2BT+136)// WEB ON
#define TI83P_kGeoPDF           (TI83P_kE2BT+137)// WEB OFF
#define TI83P_kGeoCDF           (TI83P_kE2BT+138)// WEB OFF
#define TI83P_kShadeNorm        (TI83P_kE2BT+139)
#define TI83P_kShadeT           (TI83P_kE2BT+140)
#define TI83P_kShadeChi         (TI83P_kE2BT+141)
#define TI83P_kShadeF           (TI83P_kE2BT+142)
#define TI83P_kPlotStep         (TI83P_kE2BT+143)
#define TI83P_kZPlotStep        (TI83P_kE2BT+144)
#define TI83P_kLinRegtTest      (TI83P_kE2BT+145)
#define TI83P_KMGT		  (TI83P_kE2BT+146)// VERT SPLIT
#define TI83P_kSelectA          (TI83P_kE2BT+147)
#define TI83P_kZFitA            (TI83P_kE2BT+148)
#define TI83P_kE2BT_End         (TI83P_kZFitA)
//
//
//= ()=====================================================================
//           More 2 Byte Keys 
//= ()=====================================================================

#define TI83P_kE2BT2		  (0)

#define TI83P_kGDB1		  (TI83P_kE2BT2)
#define TI83P_kGDB2		  (TI83P_kE2BT2+1)
#define TI83P_kGDB3		  (TI83P_kE2BT2+2)
#define TI83P_kY1		  (TI83P_kE2BT2+3)
#define TI83P_kY2		  (TI83P_kE2BT2+4)
#define TI83P_kY3		  (TI83P_kE2BT2+5)
#define TI83P_kY4		  (TI83P_kE2BT2+6)
#define TI83P_kY5		  (TI83P_kE2BT2+7)
#define TI83P_kY6		  (TI83P_kE2BT2+8)
#define TI83P_kY7		  (TI83P_kE2BT2+9)
#define TI83P_kY8		  (TI83P_kE2BT2+10)
#define TI83P_kY9		  (TI83P_kE2BT2+11)
#define TI83P_kY0		  (TI83P_kE2BT2+12)
#define TI83P_kX1T		  (TI83P_kE2BT2+13)
#define TI83P_kY1T		  (TI83P_kE2BT2+14)
#define TI83P_kX2T		  (TI83P_kE2BT2+15)
#define TI83P_kY2T		  (TI83P_kE2BT2+16)
#define TI83P_kX3T		  (TI83P_kE2BT2+17)
#define TI83P_kY3T		  (TI83P_kE2BT2+18)
#define TI83P_kX4T		  (TI83P_kE2BT2+19)
#define TI83P_kY4T		  (TI83P_kE2BT2+20)
#define TI83P_kX5T		  (TI83P_kE2BT2+21)
#define TI83P_kY5T		  (TI83P_kE2BT2+22)
#define TI83P_kX6T		  (TI83P_kE2BT2+23)
#define TI83P_kY6T		  (TI83P_kE2BT2+24)
#define TI83P_kR1		  (TI83P_kE2BT2+25)
#define TI83P_kR2		  (TI83P_kE2BT2+26)
#define TI83P_kR3		  (TI83P_kE2BT2+27)
#define TI83P_kR4		  (TI83P_kE2BT2+28)
#define TI83P_kR5		  (TI83P_kE2BT2+29)
#define TI83P_kR6		  (TI83P_kE2BT2+30)
#define TI83P_kGDB4		  (TI83P_kE2BT2+31)
#define TI83P_kGDB5		  (TI83P_kE2BT2+32)
#define TI83P_kGDB6		  (TI83P_kE2BT2+33)
#define TI83P_kPic4		  (TI83P_kE2BT2+34)
#define TI83P_kPic5		  (TI83P_kE2BT2+35)
#define TI83P_kPic6		  (TI83P_kE2BT2+36)
#define TI83P_kGDB7		  (TI83P_kE2BT2+37)
#define TI83P_kGDB8		  (TI83P_kE2BT2+38)
#define TI83P_kGDB9		  (TI83P_kE2BT2+39)
#define TI83P_kGDB0		  (TI83P_kE2BT2+40)
#define TI83P_kPic7		  (TI83P_kE2BT2+41)
#define TI83P_kPic8		  (TI83P_kE2BT2+42)
#define TI83P_kPic9		  (TI83P_kE2BT2+43)
#define TI83P_kPic0		  (TI83P_kE2BT2+44)
#define TI83P_kStatN		  (TI83P_kE2BT2+45)
#define TI83P_kXMean		  (TI83P_kE2BT2+46)
#define TI83P_kConj		  (TI83P_kE2BT2+47)
#define TI83P_kReal		  (TI83P_kE2BT2+48)
#define TI83P_kFAngle		  (TI83P_kE2BT2+49)
#define TI83P_kLCM		  (TI83P_kE2BT2+50)
#define TI83P_kGCD		  (TI83P_kE2BT2+51)
#define TI83P_kRandInt	  (TI83P_kE2BT2+52)
#define TI83P_kRandNorm	  (TI83P_kE2BT2+53)
#define TI83P_kToPolar	  (TI83P_kE2BT2+54)
#define TI83P_kToRect		  (TI83P_kE2BT2+55)
#define TI83P_kYMean		  (TI83P_kE2BT2+56)
#define TI83P_kStdX		  (TI83P_kE2BT2+57)
#define TI83P_kStdX1		  (TI83P_kE2BT2+58)
#define TI83P_kw0		  (TI83P_kE2BT2+59)
#define TI83P_kMatF		  (TI83P_kE2BT2+60)
#define TI83P_kMatG		  (TI83P_kE2BT2+61)
#define TI83P_kMatRH		  (TI83P_kE2BT2+62)
#define TI83P_kMatI		  (TI83P_kE2BT2+63)
#define TI83P_kMatJ		  (TI83P_kE2BT2+64)
#define TI83P_kYMean1		  (TI83P_kE2BT2+65)
#define TI83P_kStdY		  (TI83P_kE2BT2+66)
#define TI83P_kStdY1		  (TI83P_kE2BT2+67)
#define TI83P_kMatToLst	  (TI83P_kE2BT2+68)
#define TI83P_kLstToMat	  (TI83P_kE2BT2+69)
#define TI83P_kCumSum		  (TI83P_kE2BT2+70)
#define TI83P_kDeltaLst	  (TI83P_kE2BT2+71)
#define TI83P_kStdDev		  (TI83P_kE2BT2+72)
#define TI83P_kVariance	  (TI83P_kE2BT2+73)
#define TI83P_kLength		  (TI83P_kE2BT2+74)
#define TI83P_kEquToStrng	  (TI83P_kE2BT2+75)
#define TI83P_kStrngToEqu	  (TI83P_kE2BT2+76)
#define TI83P_kExpr		  (TI83P_kE2BT2+77)
#define TI83P_kSubStrng	  (TI83P_kE2BT2+78)
#define TI83P_kInStrng	  (TI83P_kE2BT2+79)
#define TI83P_kStr1		  (TI83P_kE2BT2+80)
#define TI83P_kStr2		  (TI83P_kE2BT2+81)
#define TI83P_kStr3		  (TI83P_kE2BT2+82)
#define TI83P_kStr4             (TI83P_kE2BT2+83)
#define TI83P_kStr5             (TI83P_kE2BT2+84)
#define TI83P_kStr6             (TI83P_kE2BT2+85)
#define TI83P_kStr7             (TI83P_kE2BT2+86)
#define TI83P_kStr8             (TI83P_kE2BT2+87)
#define TI83P_kStr9             (TI83P_kE2BT2+88)
#define TI83P_kStr0             (TI83P_kE2BT2+89)
#define TI83P_kFinN             (TI83P_kE2BT2+90)
#define TI83P_kFinI             (TI83P_kE2BT2+91)
#define TI83P_kFinPV            (TI83P_kE2BT2+92)
#define TI83P_kFinPMT           (TI83P_kE2BT2+93)
#define TI83P_kFinFV            (TI83P_kE2BT2+94)
#define TI83P_kFinPY            (TI83P_kE2BT2+95)
#define TI83P_kFinCY            (TI83P_kE2BT2+96)
#define TI83P_kFinFPMT          (TI83P_kE2BT2+97)
#define TI83P_kFinFI            (TI83P_kE2BT2+98)
#define TI83P_kFinFPV           (TI83P_kE2BT2+99)
#define TI83P_kFinFN            (TI83P_kE2BT2+100)
#define TI83P_kFinFFV           (TI83P_kE2BT2+101)
#define TI83P_kFinNPV           (TI83P_kE2BT2+102)
#define TI83P_kFinIRR           (TI83P_kE2BT2+103)
#define TI83P_kFinBAL           (TI83P_kE2BT2+104)
#define TI83P_kFinPRN           (TI83P_kE2BT2+105)
#define TI83P_kFinINT           (TI83P_kE2BT2+106)
#define TI83P_kSumX             (TI83P_kE2BT2+107)
#define TI83P_kSumX2            (TI83P_kE2BT2+108)
#define TI83P_kFinToNom         (TI83P_kE2BT2+109)
#define TI83P_kFinToEff         (TI83P_kE2BT2+110)
#define TI83P_kFinDBD           (TI83P_kE2BT2+111)
#define TI83P_kStatVP           (TI83P_kE2BT2+112)
#define TI83P_kStatZ            (TI83P_kE2BT2+113)
#define TI83P_kStatT            (TI83P_kE2BT2+114)
#define TI83P_kStatChi          (TI83P_kE2BT2+115)
#define TI83P_kStatF            (TI83P_kE2BT2+116)
#define TI83P_kStatDF           (TI83P_kE2BT2+117)
#define TI83P_kStatPhat         (TI83P_kE2BT2+118)
#define TI83P_kStatPhat1        (TI83P_kE2BT2+119)
#define TI83P_kStatPhat2        (TI83P_kE2BT2+120)
#define TI83P_kStatMeanX1       (TI83P_kE2BT2+121)
#define TI83P_kStatMeanX2       (TI83P_kE2BT2+122)
#define TI83P_kStatStdX1        (TI83P_kE2BT2+123)
#define TI83P_kStatStdX2        (TI83P_kE2BT2+124)
#define TI83P_kStatStdXP        (TI83P_kE2BT2+125)
#define TI83P_kStatN1           (TI83P_kE2BT2+126)
#define TI83P_kStatN2           (TI83P_kE2BT2+127)
#define TI83P_kStatLower        (TI83P_kE2BT2+128)
#define TI83P_kStatUpper        (TI83P_kE2BT2+129)
#define TI83P_kuw0              (TI83P_kE2BT2+130)
#define TI83P_kImag             (TI83P_kE2BT2+131)
#define TI83P_kSumY             (TI83P_kE2BT2+132)
#define TI83P_kXres             (TI83P_kE2BT2+133)
#define TI83P_kStat_s           (TI83P_kE2BT2+134)
#define TI83P_kSumY2            (TI83P_kE2BT2+135)
#define TI83P_kSumXY            (TI83P_kE2BT2+136)
#define TI83P_kuXres            (TI83P_kE2BT2+137)
#define TI83P_kModBox		  (TI83P_kE2BT2+138)
#define TI83P_kNormProb	  (TI83P_kE2BT2+139)
#define TI83P_kNormalPDF        (TI83P_kE2BT2+140)
#define TI83P_kTPDF             (TI83P_kE2BT2+141)
#define TI83P_kChiPDF           (TI83P_kE2BT2+142)
#define TI83P_kFPDF             (TI83P_kE2BT2+143)
#define TI83P_kMinY             (TI83P_kE2BT2+144)// MinY
#define TI83P_kRandBin          (TI83P_kE2BT2+145)
#define TI83P_kRef              (TI83P_kE2BT2+146)
#define TI83P_kRRef             (TI83P_kE2BT2+147)
#define TI83P_kLRSqr            (TI83P_kE2BT2+148)
#define TI83P_kBRSqr            (TI83P_kE2BT2+149)
#define TI83P_kDiagOn           (TI83P_kE2BT2+150)
#define TI83P_kDiagOff          (TI83P_kE2BT2+151)
#define TI83P_kun1              (TI83P_kE2BT2+152)// FOR RCL USE WHEN GOTTEN FROM 82
#define TI83P_kvn1              (TI83P_kE2BT2+153)// FOR RCL USE WHEN GOTTEN FROM 82
//
#define TI83P_k83_00End         (TI83P_kvn1)//end of original keys...
#define TI83P_kArchive          (TI83P_k83_00End + 1)
#define TI83P_kUnarchive        (TI83P_k83_00End + 2)
#define TI83P_kAsm              (TI83P_k83_00End + 3)// Asm(
#define TI83P_kAsmPrgm          (TI83P_k83_00End + 4)// AsmPrgm
#define TI83P_kAsmComp          (TI83P_k83_00End + 5)// AsmComp(
//
#define TI83P_kcapAAcute	  (TI83P_k83_00End + 6)
#define TI83P_kcapAGrave	  (TI83P_k83_00End + 7)
#define TI83P_kcapACaret	  (TI83P_k83_00End + 8)
#define TI83P_kcapADier	  (TI83P_k83_00End + 9)
#define TI83P_kaAcute		  (TI83P_k83_00End + 10)
#define TI83P_kaGrave		  (TI83P_k83_00End + 11)
#define TI83P_kaCaret		  (TI83P_k83_00End + 12)
#define TI83P_kaDier		  (TI83P_k83_00End + 13)
#define TI83P_kcapEAcute	  (TI83P_k83_00End + 14)
#define TI83P_kcapEGrave	  (TI83P_k83_00End + 15)
#define TI83P_kcapECaret	  (TI83P_k83_00End + 16)
#define TI83P_kcapEDier	  (TI83P_k83_00End + 17)
#define TI83P_keAcute		  (TI83P_k83_00End + 18)
#define TI83P_keGrave		  (TI83P_k83_00End + 19)
#define TI83P_keCaret		  (TI83P_k83_00End + 20)
#define TI83P_keDier		  (TI83P_k83_00End + 21)
#define TI83P_kcapIAcute	  (TI83P_k83_00End + 22)
#define TI83P_kcapIGrave	  (TI83P_k83_00End + 23)
#define TI83P_kcapICaret	  (TI83P_k83_00End + 24)
#define TI83P_kcapIDier	  (TI83P_k83_00End + 25)
#define TI83P_kiAcute		  (TI83P_k83_00End + 26)
#define TI83P_kiGrave		  (TI83P_k83_00End + 27)
#define TI83P_kiCaret		  (TI83P_k83_00End + 28)
#define TI83P_kiDier		  (TI83P_k83_00End + 29)
#define TI83P_kcapOAcute	  (TI83P_k83_00End + 30)
#define TI83P_kcapOGrave	  (TI83P_k83_00End + 31)
#define TI83P_kcapOCaret	  (TI83P_k83_00End + 32)
#define TI83P_kcapODier	  (TI83P_k83_00End + 33)
#define TI83P_koAcute		  (TI83P_k83_00End + 34)
#define TI83P_koGrave		  (TI83P_k83_00End + 35)
#define TI83P_koCaret		  (TI83P_k83_00End + 36)
#define TI83P_koDier		  (TI83P_k83_00End + 37)
#define TI83P_kcapUAcute	  (TI83P_k83_00End + 38)
#define TI83P_kcapUGrave	  (TI83P_k83_00End + 39)
#define TI83P_kcapUCaret	  (TI83P_k83_00End + 40)
#define TI83P_kcapUDier	  (TI83P_k83_00End + 41)
#define TI83P_kuAcute		  (TI83P_k83_00End + 42)
#define TI83P_kuGrave		  (TI83P_k83_00End + 43)
#define TI83P_kuCaret		  (TI83P_k83_00End + 44)
#define TI83P_kuDier		  (TI83P_k83_00End + 45)
#define TI83P_kcapCCed	  (TI83P_k83_00End + 46)
#define TI83P_kcCed		  (TI83P_k83_00End + 47)
#define TI83P_kcapNTilde	  (TI83P_k83_00End + 48)
#define TI83P_knTilde		  (TI83P_k83_00End + 49)
#define TI83P_kaccent		  (TI83P_k83_00End + 50)
#define TI83P_kgrave		  (TI83P_k83_00End + 51)
#define TI83P_kdieresis	  (TI83P_k83_00End + 52)
#define TI83P_kquesDown	  (TI83P_k83_00End + 53)
#define TI83P_kexclamDown       (TI83P_k83_00End + 54)
#define TI83P_kalpha            (TI83P_k83_00End + 55)
#define TI83P_kbeta             (TI83P_k83_00End +  56)
#define TI83P_kgamma            (TI83P_k83_00End +  57)
#define TI83P_kcapDelta         (TI83P_k83_00End +  58)
#define TI83P_kdelta            (TI83P_k83_00End +  59)
#define TI83P_kepsilon          (TI83P_k83_00End +  60)
#define TI83P_klambda           (TI83P_k83_00End +  61)
#define TI83P_kmu               (TI83P_k83_00End +  62)
#define TI83P_kpi2              (TI83P_k83_00End +  63)
#define TI83P_krho              (TI83P_k83_00End +  64)
#define TI83P_kcapSigma         (TI83P_k83_00End +  65)
#define TI83P_ksigma            (TI83P_k83_00End +  66)
#define TI83P_ktau              (TI83P_k83_00End +  67)
#define TI83P_kphi              (TI83P_k83_00End +  68)
#define TI83P_kcapOmega         (TI83P_k83_00End +  69)
#define TI83P_kphat             (TI83P_k83_00End +  70)
#define TI83P_kchi2             (TI83P_k83_00End +  71)
#define TI83P_kstatF2           (TI83P_k83_00End +  72)
#define TI83P_kLa		  (TI83P_k83_00End + 73)
#define TI83P_kLb		  (TI83P_k83_00End + 74)
#define TI83P_kLc		  (TI83P_k83_00End + 75)
#define TI83P_kLd		  (TI83P_k83_00End + 76)
#define TI83P_kLe		  (TI83P_k83_00End + 77)
#define TI83P_kLf		  (TI83P_k83_00End + 78)
#define TI83P_kLg		  (TI83P_k83_00End + 79)
#define TI83P_kLh		  (TI83P_k83_00End + 80)
#define TI83P_kLi		  (TI83P_k83_00End + 81)
#define TI83P_kLj		  (TI83P_k83_00End + 82)
#define TI83P_kLk		  (TI83P_k83_00End + 83)
#define TI83P_kLl		  (TI83P_k83_00End + 84)
#define TI83P_kLm		  (TI83P_k83_00End + 85)
#define TI83P_kLsmalln	  (TI83P_k83_00End +  86)
#define TI83P_kLo		  (TI83P_k83_00End +  87)
#define TI83P_kLp		  (TI83P_k83_00End +  88)
#define TI83P_kLq		  (TI83P_k83_00End +  89)
#define TI83P_kLsmallr	  (TI83P_k83_00End +  90)
#define TI83P_kLs		  (TI83P_k83_00End +  91)
#define TI83P_kLt		  (TI83P_k83_00End +  92)
#define TI83P_kLu		  (TI83P_k83_00End +  93)
#define TI83P_kLv		  (TI83P_k83_00End +  94)
#define TI83P_kLw		  (TI83P_k83_00End +  95)
#define TI83P_kLx		  (TI83P_k83_00End +  96)
#define TI83P_kLy		  (TI83P_k83_00End +  97)
#define TI83P_kLz		  (TI83P_k83_00End +  98)
#define TI83P_kGarbageC	  (TI83P_k83_00End +  99)// GarbageCollect
//
#define TI83P_kE2BT2_End	  (TI83P_kGarbageC)
//
//= ()=====================================================================
//           TI-83 Plus Context Equates
//= ()=====================================================================
//
#define TI83P_cxCmd             (TI83P_kQuit)//home screen
#define TI83P_cxMatEdit         (TI83P_kMatrixEd)//matrix editor
#define TI83P_cxPrgmEdit        (TI83P_kPrgmEd)//program editor
#define TI83P_cxEquEdit         (TI83P_kYequ)//equation editor
#define TI83P_cxGrRange         (TI83P_kWindow)//graph range editor
#define TI83P_cxGrZfact         (TI83P_kZFactEd)//graph zoom factors editor
#define TI83P_cxGraph           (TI83P_kGraph)//graph mode
#define TI83P_cxStatEdit        (TI83P_kStatEd)//statistics list editor
#define TI83P_cxPrgmInput       (TI83P_kPrgmInput)//programmed input
#define TI83P_cxError           (TI83P_kError)//error handler
#define TI83P_cxLinkIO          (TI83P_kLinkIO)//LINK I/O interface
#define TI83P_cxMem             (TI83P_kResetMem)//reset memory
#define TI83P_cxDefMem          (TI83P_kResetDef)//reset default
#define TI83P_cxRAMApp          (TI83P_kChkRAM)//RAM usage screen
#define TI83P_cxMode            (TI83P_kMode)//mode settings screen
#define TI83P_cxErase           (TI83P_kDelMem)//memory erase
#define TI83P_cxPrgmCreate      (TI83P_kPrgmCr)//PROGRAM CREATE
#define TI83P_cxTableEditor     (TI83P_kTable)//TABLE EDITOR
#define TI83P_cxTableSet        (TI83P_kTblSet)//TABLE SET UP
#define TI83P_cxStatPlot        (TI83P_kStatP)//STAT PLOTS
#define TI83P_cxInfStat	  (TI83P_kInfStat)//Inferential Statistic
#define TI83P_cxFormat          (TI83P_kFormat)//FORMAT CONTEXT
#define TI83P_cxSolveTVM        (TI83P_kSolveTVM)//Solve TVM
#define TI83P_cxSolveRoot       (TI83P_kSolveRoot)//Solve Root
#define TI83P_lastOldApp        (TI83P_kExtApps)//external applications
#define TI83P_cxextapps         (TI83P_kExtApps)
#define TI83P_cxNewApps         (TI83P_kNewApps)//new cerberus applications
#define TI83P_cxGroup           (TI83P_cxNewApps+0)//1st new app.
#define TI83P_cxUnGroup         (TI83P_cxNewApps+1)//2nd new app.
#define TI83P_lastNewApp        (TI83P_cxUnGroup)//last new app for this ver

//
//= ()=====================================================================
//           Scan Code Equates
//= ()===================================================================== TI83P_;
#define TI83P_skDown            (0x01)
#define TI83P_skLeft            (0x02)
#define TI83P_skRight           (0x03)
#define TI83P_skUp              (0x04)
#define TI83P_skEnter           (0x09)
#define TI83P_skAdd             (0x0A)
#define TI83P_skSub             (0x0B)
#define TI83P_skMul             (0x0C)
#define TI83P_skDiv             (0x0D)
#define TI83P_skPower           (0x0E)
#define TI83P_skClear           (0x0F)
#define TI83P_skChs             (0x11)
#define TI83P_sk3               (0x12)
#define TI83P_sk6               (0x13)
#define TI83P_sk9               (0x14)
#define TI83P_skRParen          (0x15)
#define TI83P_skTan             (0x16)
#define TI83P_skVars            (0x17)
#define TI83P_skDecPnt          (0x19)
#define TI83P_sk2               (0x1A)
#define TI83P_sk5               (0x1B)
#define TI83P_sk8               (0x1C)
#define TI83P_skLParen          (0x1D)
#define TI83P_skCos             (0x1E)
#define TI83P_skPrgm            (0x1F)
#define TI83P_skStat            (0x20)
#define TI83P_sk0               (0x21)
#define TI83P_sk1               (0x22)
#define TI83P_sk4               (0x23)
#define TI83P_sk7               (0x24)
#define TI83P_skComma           (0x25)
#define TI83P_skSin             (0x26)
#define TI83P_skMatrix          (0x27)
#define TI83P_skGraphvar        (0x28)
#define TI83P_skStore           (0x2A)
#define TI83P_skLn              (0x2B)
#define TI83P_skLog             (0x2C)
#define TI83P_skSquare          (0x2D)
#define TI83P_skRecip           (0x2E)
#define TI83P_skMath            (0x2F)
#define TI83P_skAlpha           (0x30)
#define TI83P_skGraph           (0x31)
#define TI83P_skTrace           (0x32)
#define TI83P_skZoom            (0x33)
#define TI83P_skWindow          (0x34)
#define TI83P_skYEqu            (0x35)
#define TI83P_sk2nd             (0x36)
#define TI83P_skMode            (0x37)
#define TI83P_skDel             (0x38)
//
//= ()=====================================================================
//           Tokens
//= ()=====================================================================
//
#define TI83P_EOSSTART          (0)
//
//
//   DISPLAY CONVERSIONS COME IMMEDIATELY BEFORE 'TSTORE'
//
#define TI83P_DCONV     (0x01)
//
#define TI83P_tToDMS            (TI83P_DCONV)//0x01
#define TI83P_tToDEC            (TI83P_DCONV+1)//0x02
#define TI83P_tToAbc            (TI83P_DCONV+2)//0x03   > A b/c
//
#define TI83P_tStore            (TI83P_DCONV+3)//0x04Lstore                01
//
#define TI83P_tBoxPlot          (0x05)
//
#define TI83P_BRACKS            (0x06)
//
#define TI83P_tLBrack           (TI83P_BRACKS)//0x06'['
#define TI83P_tRBrack           (TI83P_BRACKS+1)//0x07']'
#define TI83P_tLBrace           (TI83P_BRACKS+2)//0x08'{'
#define TI83P_tRBrace           (TI83P_BRACKS+3)//0x09'}'
//
#define TI83P_tPOST1            (TI83P_BRACKS+4)
//
#define TI83P_tFromRad          (TI83P_tPOST1)//0x0ALradian
#define TI83P_tFromDeg          (TI83P_tPOST1+1)//0x0BLdegree
#define TI83P_tRecip            (TI83P_tPOST1+2)//0x0CLinverse
#define TI83P_tSqr              (TI83P_tPOST1+3)//0x0DLsquare
#define TI83P_tTrnspos          (TI83P_tPOST1+4)//0x0ELtranspose
#define TI83P_tCube             (TI83P_tPOST1+5)//0x0F'^3'
//
#define TI83P_tLParen           (0x10)// 10h '('
#define TI83P_tRParen           (0x11)// 11h ')'
//
//
#define TI83P_IMUN              (0x12)
//
#define TI83P_tRound            (TI83P_IMUN)//0x12'round'
#define TI83P_tPxTst            (TI83P_IMUN+1)//0x13'PXL-TEST'
#define TI83P_tAug              (TI83P_IMUN+2)//0x14'aug'
#define TI83P_tRowSwap          (TI83P_IMUN+3)//0x15'rSwap'
#define TI83P_tRowPlus          (TI83P_IMUN+4)//0x16'rAdd'
#define TI83P_tmRow             (TI83P_IMUN+5)//0x17'multR'
#define TI83P_tmRowPlus         (TI83P_IMUN+6)//0x18'mRAdd'
#define TI83P_tMax              (TI83P_IMUN+7)//0x19'max'
#define TI83P_tMin              (TI83P_IMUN+8)//0x1A'min'
#define TI83P_tRToPr            (TI83P_IMUN+9)//0x1B'R>Pr'
#define TI83P_tRToPo            (TI83P_IMUN+10)//0x1C'R>Po'
#define TI83P_tPToRx            (TI83P_IMUN+11)//0x1D'P>Rx'
#define TI83P_tPToRy            (TI83P_IMUN+12)//0x1E'P>Ry'
#define TI83P_tMedian           (TI83P_IMUN+13)//0x1F'MEDIAN'
#define TI83P_tRandM            (TI83P_IMUN+14)//0x20'randM'
#define TI83P_tMean             (TI83P_IMUN+15)//0x21
#define TI83P_tRoot             (TI83P_IMUN+16)//0x22'ROOT'
#define TI83P_tSeries           (TI83P_IMUN+17)//0x23'seq'
#define TI83P_tFnInt            (TI83P_IMUN+18)//0x24'fnInt'
#define TI83P_tNDeriv           (TI83P_IMUN+19)//0x25'fnIr'
#define TI83P_tEvalF            (TI83P_IMUN+20)//0x26
#define TI83P_tFmin             (TI83P_IMUN+21)//0x27
#define TI83P_tFmax             (TI83P_IMUN+22)//0x28
//
#define TI83P_tEOSEL            (TI83P_IMUN+23)
//
#define TI83P_tSpace            (TI83P_tEOSEL)//0x29 ' '
#define TI83P_tString           (TI83P_tEOSEL+1)//0x2A '""'                                                                                      
#define TI83P_tComma            (TI83P_tEOSEL+2)//0x2B ','
//
//
#define TI83P_tii               (0x2C)// i
//
//= ()=====================================================================
//           Postfix Functions
//= ()=====================================================================
//
#define TI83P_tPost             (0x2D)
//
#define TI83P_tFact             (TI83P_tPost)//0x2D'!'
//
#define TI83P_tCubicR           (0x2E)
#define TI83P_tQuartR           (0x2F)

//= ()=====================================================================
//           Number Tokens 
//= ()=====================================================================
//
#define TI83P_NUMS              (0x30)
//
#define TI83P_t0                (TI83P_NUMS)//0x30
#define TI83P_t1                (TI83P_NUMS+1)//0x31
#define TI83P_t2                (TI83P_NUMS+2)//0x32
#define TI83P_t3                (TI83P_NUMS+3)//0x33
#define TI83P_t4                (TI83P_NUMS+4)//0x34
#define TI83P_t5                (TI83P_NUMS+5)//0x35
#define TI83P_t6                (TI83P_NUMS+6)//0x36
#define TI83P_t7                (TI83P_NUMS+7)//0x37
#define TI83P_t8                (TI83P_NUMS+8)//0x38
#define TI83P_t9                (TI83P_NUMS+9)//0x39
#define TI83P_tDecPt            (TI83P_NUMS+10)//0x3A
#define TI83P_tee               (TI83P_NUMS+11)//0x3B
//
//= ()=====================================================================
//            BINARY OP
//= ()=====================================================================
//
#define TI83P_tOr               (0x3C)// 3Ch  '_or_'
#define TI83P_tXor              (0x3D)//0x3D
//
#define TI83P_tColon            (0x3E)// 3Eh ':'
#define TI83P_tEnter            (0x3F)// 3Fh  Lenter
//
#define TI83P_tAnd              (0x40)// 40h  '_and_'       
//
//= ()=====================================================================
//            LETTER TOKENS   
//= ()=====================================================================

//
#define TI83P_LET               (0x41)
//
#define TI83P_tA                (TI83P_LET)//0x41
#define TI83P_tB                (TI83P_LET+1)//0x42
#define TI83P_tC                (TI83P_LET+2)//0x43
#define TI83P_tD                (TI83P_LET+3)//0x44
#define TI83P_tE                (TI83P_LET+4)//0x45
#define TI83P_tF                (TI83P_LET+5)//0x46
#define TI83P_tG                (TI83P_LET+6)//0x47
#define TI83P_tH                (TI83P_LET+7)//0x48
#define TI83P_tI                (TI83P_LET+8)//0x49
#define TI83P_tJ                (TI83P_LET+9)//0x4A
#define TI83P_tK                (TI83P_LET+10)//0x4B
#define TI83P_tL                (TI83P_LET+11)//0x4C
#define TI83P_tM                (TI83P_LET+12)//0x4D
#define TI83P_tN                (TI83P_LET+13)//0x4E
#define TI83P_tO                (TI83P_LET+14)//0x4F
#define TI83P_tP                (TI83P_LET+15)//0x50
#define TI83P_tQ                (TI83P_LET+16)//0x51
#define TI83P_tR                (TI83P_LET+17)//0x52
#define TI83P_tS                (TI83P_LET+18)//0x53
#define TI83P_tT                (TI83P_LET+19)//0x54
#define TI83P_tU                (TI83P_LET+20)//0x55
#define TI83P_tV                (TI83P_LET+21)//0x56
#define TI83P_tW                (TI83P_LET+22)//0x57
#define TI83P_tX                (TI83P_LET+23)//0x58
#define TI83P_tY                (TI83P_LET+24)//0x59
#define TI83P_tZ                (TI83P_LET+25)//0x5A
#define TI83P_tTheta            (TI83P_LET+26)//0x5B
//
//= ()=====================================================================
//   THESE VAR TOKENS ARE 1ST OF A DOUBLE TOKEN 
//= ()=====================================================================

//
#define TI83P_vToks     (TI83P_LET+27)//
//
//       USER MATRIX TOKEN, 2ND TOKEN NEEDED FOR NAME
//
#define TI83P_tVarMat           (TI83P_vToks)//0x5C
//
//       USER LIST TOKEN, 2ND TOKEN NEEDED FOR NAME
//
#define TI83P_tVarLst           (TI83P_vToks+1)//0x5D
//
//       USER = (TI83P_ATION TOKEN, 2ND TOKEN NEEDED FOR NAME)
//
#define TI83P_tVarEqu           (TI83P_vToks+2)//0x5E
#define TI83P_tProg             (TI83P_vToks+3)//0x5F
//
//       USER PICT TOKEN, 2ND TOKEN NEEDED FOR NAME
//
#define TI83P_tVarPict          (TI83P_vToks+4)//0x60
//
//       USER GDB TOKEN, 2ND TOKEN NEEDED FOR NAME
//
#define TI83P_tVarGDB           (TI83P_vToks+5)//0x61
#define TI83P_tVarOut           (TI83P_vToks+6)//0x62
#define TI83P_tVarSys           (TI83P_vToks+7)//0x63
//
//
//= ()=====================================================================
//            Mode Setting Commands
//= ()=====================================================================

//
#define TI83P_MODESA            (TI83P_vToks+8)//0x64
//
#define TI83P_tRad              (TI83P_MODESA)//0x64'Radian'
#define TI83P_tDeg              (TI83P_MODESA+1)//0x65'Degree'
#define TI83P_tNormF            (TI83P_MODESA+2)//0x66'Normal'
#define TI83P_tSci              (TI83P_MODESA+3)//0x67'Sci'
#define TI83P_tEng              (TI83P_MODESA+4)//0x68'Eng'
#define TI83P_tFloat            (TI83P_MODESA+5)//0x69'Float'
//
#define TI83P_CMPS              (0x6A)
//
#define TI83P_tEQ               (TI83P_CMPS)//0x6A'=='
#define TI83P_tLT               (TI83P_CMPS+1)//0x6B'<'
#define TI83P_tGT               (TI83P_CMPS+2)//0x6C'>'
#define TI83P_tLE               (TI83P_CMPS+3)//0x6DLLE
#define TI83P_tGE               (TI83P_CMPS+4)//0x6ELGE
#define TI83P_tNE               (TI83P_CMPS+5)//0x6FLNE
//
//= ()=====================================================================
//            BINARY OP
//= ()=====================================================================
//
#define TI83P_tAdd              (0x70)// 70h '+'
#define TI83P_tSub              (0x71)// 71h '-'
#define TI83P_tAns              (0x72)//0x72
//
//= ()=====================================================================
//            Mode Setting Commands
//= ()=====================================================================
//
#define TI83P_MODES             (0x73)
//
#define TI83P_tFix              (TI83P_MODES)//0x73'Fix_'
#define TI83P_tSplitOn          (TI83P_MODES+1)//0x74
#define TI83P_tFullScreen       (TI83P_MODES+2)//0x75
#define TI83P_tStndrd           (TI83P_MODES+3)//0x76'Func'
#define TI83P_tParam            (TI83P_MODES+4)//0x77'Param'
#define TI83P_tPolar            (TI83P_MODES+5)//0x78'Pol'
#define TI83P_tSeqG             (TI83P_MODES+6)//0x79
#define TI83P_tAFillOn          (TI83P_MODES+7)//0x7A'AUTO FILL ON'
#define TI83P_tAFillOff         (TI83P_MODES+8)//0x7B
#define TI83P_tACalcOn          (TI83P_MODES+9)//0x7C
#define TI83P_tACalcOff         (TI83P_MODES+10)//0x7D'AutoFill OFF'
//
//       GRAPH FORMAT TOKENS ARE 2 BYTE TOKENS
//
#define TI83P_tGFormat          (TI83P_MODES+11)//0x7E
//
#define TI83P_tBoxIcon          (0x7F)
#define TI83P_tCrossIcon        (0x80)
#define TI83P_tDotIcon          (0x81)
//
//= ()=====================================================================
//            (More) BINARY OP
//= ()=====================================================================
//
#define TI83P_tMul              (0x82)// 82h  '*'
#define TI83P_tDiv              (0x83)// 83h  '/'
//
//= ()=====================================================================
//            SOME GRAPH COMMANDS
//= ()=====================================================================
//
#define TI83P_GRCMDS            (0x84)
//
#define TI83P_tTrace            (TI83P_GRCMDS)//0x84'Trace'
#define TI83P_tClDrw            (TI83P_GRCMDS+1)//0x85'ClDrw'
#define TI83P_tZoomStd          (TI83P_GRCMDS+2)//0x86'ZStd'
#define TI83P_tZoomtrg          (TI83P_GRCMDS+3)//0x87'Ztrg'
#define TI83P_tZoomBox          (TI83P_GRCMDS+4)//0x88'ZBOX'
#define TI83P_tZoomIn           (TI83P_GRCMDS+5)//0x89'ZIn'
#define TI83P_tZoomOut          (TI83P_GRCMDS+6)//0x8A'ZOut'
#define TI83P_tZoomSqr          (TI83P_GRCMDS+7)//0x8B'ZSqr'
#define TI83P_tZoomInt          (TI83P_GRCMDS+8)//0x8C'ZInt'
#define TI83P_tZoomPrev         (TI83P_GRCMDS+9)//0x8D'ZPrev'
#define TI83P_tZoomDec          (TI83P_GRCMDS+10)//0x8E'ZDecm'
#define TI83P_tZoomStat         (TI83P_GRCMDS+11)//0x8F'ZStat'
#define TI83P_tUsrZm            (TI83P_GRCMDS+12)//0x90'ZRcl'
#define TI83P_tPrtScrn          (TI83P_GRCMDS+13)//0x91'PrtScrn'
#define TI83P_tZoomSto          (TI83P_GRCMDS+14)//0x92 ZOOM STORE
#define TI83P_tText             (TI83P_GRCMDS+15)//0x93
//
//= ()=====================================================================
//           BINARY OP  (Combination & Permutation)
//= ()=====================================================================
//
#define TI83P_tnPr              (TI83P_GRCMDS+16)//0x94'_nPr_'
#define TI83P_tnCr              (TI83P_GRCMDS+17)//0x95'_nCr_'
//
//= ()=====================================================================
//           MORE GRAPH COMMANDS
//= ()=====================================================================
//
#define TI83P_tYOn              (TI83P_GRCMDS+18)//0x96'FnOn_'
#define TI83P_tYOff             (TI83P_GRCMDS+19)//0x97'FnOff_'
#define TI83P_tStPic            (TI83P_GRCMDS+20)//0x98'StPic_'
#define TI83P_tRcPic            (TI83P_GRCMDS+21)//0x99'RcPic_'
#define TI83P_tStoDB            (TI83P_GRCMDS+22)//0x9A'StGDB_'
#define TI83P_tRclDB            (TI83P_GRCMDS+23)//0x9B'RcGDB_'
#define TI83P_tLine             (TI83P_GRCMDS+24)//0x9C'Line'
#define TI83P_tVert             (TI83P_GRCMDS+25)//0x9D'Vert_'
#define TI83P_tPtOn             (TI83P_GRCMDS+26)//0x9E'PtOn'
#define TI83P_tPtOff            (TI83P_GRCMDS+27)//0x9F'PtOff'
//
//= ()=====================================================================
//           TOKEN A0 CANNOT BE AN EOS FUNCTION
//           SINCE LOW MULT= (TI83P_A0 ALREADY)
//= ()=====================================================================
//
#define TI83P_tPtChg            (TI83P_GRCMDS+28)//0xA0'PtChg'
#define TI83P_tPXOn             (TI83P_GRCMDS+29)//0xA1
#define TI83P_tPXOff            (TI83P_GRCMDS+30)//0xA2
#define TI83P_tPXChg            (TI83P_GRCMDS+31)//0xA3
#define TI83P_tShade            (TI83P_GRCMDS+32)//0xA4'Shade'
#define TI83P_tCircl            (TI83P_GRCMDS+33)//0xA5'Circl'
#define TI83P_tHorz             (TI83P_GRCMDS+34)//0xA6'HORIZONTAL'
#define TI83P_tTanLn            (TI83P_GRCMDS+35)//0xA7'TanLn'
#define TI83P_tDrInv            (TI83P_GRCMDS+36)//0xA8'DrInv_'
#define TI83P_tDrawF            (TI83P_GRCMDS+37)//0xA9'DrawF_'
//
#define TI83P_tVarStrng         (0x0AA)
//
//= ()=====================================================================
//           Functions with No Arguments                                    
//= ()=====================================================================
//
#define TI83P_NOARG     (0x0AB)
//
#define TI83P_tRand             (TI83P_NOARG)//0xAB'rand'
#define TI83P_tPi               (TI83P_NOARG+1)//0xAC Lpi
#define TI83P_tGetKey           (TI83P_NOARG+2)//0xAD'getKy'
//
//
#define TI83P_tAPost            (TI83P_tGetKey+1)// APOSTROPHY
#define TI83P_tQuest            (TI83P_tAPost+1)// QUESTION MARK
//
//
#define TI83P_UNARY     (TI83P_tQuest+1)//0xB0
//
#define TI83P_tChs              (TI83P_UNARY)//0xB0
#define TI83P_tInt              (TI83P_UNARY+1)//0xB1
#define TI83P_tAbs              (TI83P_UNARY+2)//0xB2
#define TI83P_tDet              (TI83P_UNARY+3)//0xB3
#define TI83P_tIdent            (TI83P_UNARY+4)//0xB4
#define TI83P_tDim              (TI83P_UNARY+5)//0xB5
#define TI83P_tSum              (TI83P_UNARY+6)//0xB6
#define TI83P_tProd             (TI83P_UNARY+7)//0xB7
#define TI83P_tNot              (TI83P_UNARY+8)//0xB8
#define TI83P_tIPart            (TI83P_UNARY+9)//0xB9
#define TI83P_tFPart            (TI83P_UNARY+10)//0xBA
//
//
//= ()=====================================================================
//           NEW 2 BYTE TOKENS
//= ()=====================================================================
//
#define TI83P_t2ByteTok         (0x0BB)//
//
//
#define TI83P_UNARYLR   (TI83P_UNARY+12)
//
#define TI83P_tSqrt             (TI83P_UNARYLR)//0xBC
#define TI83P_tCubRt            (TI83P_UNARYLR+1)//0xBD
#define TI83P_tLn               (TI83P_UNARYLR+2)//0xBE
#define TI83P_tExp              (TI83P_UNARYLR+3)//0xBF
#define TI83P_tLog              (TI83P_UNARYLR+4)//0xC0
#define TI83P_tALog             (TI83P_UNARYLR+5)//0xC1
#define TI83P_tSin              (TI83P_UNARYLR+6)//0xC2
#define TI83P_tASin             (TI83P_UNARYLR+7)//0xC3
#define TI83P_tCos              (TI83P_UNARYLR+8)//0xC4
#define TI83P_tACos             (TI83P_UNARYLR+9)//0xC5
#define TI83P_tTan              (TI83P_UNARYLR+10)//0xC6
#define TI83P_tATan             (TI83P_UNARYLR+11)//0xC7
#define TI83P_tSinH             (TI83P_UNARYLR+12)//0xC8
#define TI83P_tASinH            (TI83P_UNARYLR+13)//0xC9
#define TI83P_tCoshH            (TI83P_UNARYLR+14)//0xCA
#define TI83P_tACosH            (TI83P_UNARYLR+15)//0xCB
#define TI83P_tTanH             (TI83P_UNARYLR+16)//0xCC
#define TI83P_tATanH            (TI83P_UNARYLR+17)//0xCD
// 
//= ()=====================================================================
//           SOME PROGRAMMING COMMANDS                                      
//= ()=====================================================================
//
#define TI83P_PROGTOK   (TI83P_UNARYLR+18)
//
#define TI83P_tIf               (TI83P_PROGTOK)//0xCE
#define TI83P_tThen             (TI83P_PROGTOK+1)//0xCF
#define TI83P_tElse             (TI83P_PROGTOK+2)//0xD0
#define TI83P_tWhile            (TI83P_PROGTOK+3)//0xD1
#define TI83P_tRepeat           (TI83P_PROGTOK+4)//0xD2
#define TI83P_tFor              (TI83P_PROGTOK+5)//0xD3
#define TI83P_tEnd              (TI83P_PROGTOK+6)//0xD4
#define TI83P_tReturn           (TI83P_PROGTOK+7)//0xD5
#define TI83P_tLbl              (TI83P_PROGTOK+8)//0xD6  'Lbl_'
#define TI83P_tGoto             (TI83P_PROGTOK+9)//0xD7  'Goto_'
#define TI83P_tPause            (TI83P_PROGTOK+10)//0xD8  'Pause_'
#define TI83P_tStop             (TI83P_PROGTOK+11)//0xD9  'Stop'
#define TI83P_tISG              (TI83P_PROGTOK+12)//0xDA  'IS>'
#define TI83P_tDSL              (TI83P_PROGTOK+13)//0xDB  'DS<'
#define TI83P_tInput            (TI83P_PROGTOK+14)//0xDC  'Input_'
#define TI83P_tPrompt           (TI83P_PROGTOK+15)//0xDD  'Prompt_'
#define TI83P_tDisp             (TI83P_PROGTOK+16)//0xDE  'Disp_'
#define TI83P_tDispG            (TI83P_PROGTOK+17)//0xDF  'DispG'
//
#define TI83P_tOutput           (TI83P_PROGTOK+18)//0xE0   'Outpt'
#define TI83P_tClLCD            (TI83P_PROGTOK+19)//0xE1   'ClLCD'
#define TI83P_tConst            (TI83P_PROGTOK+20)//0xE2   'Fill'
#define TI83P_tSortA            (TI83P_PROGTOK+21)//0xE3   'sortA_'
#define TI83P_tSortD            (TI83P_PROGTOK+22)//0xE4   'sortD_'
#define TI83P_tDispTab          (TI83P_PROGTOK+23)//0xE5   'Disp Table'
#define TI83P_tMenu             (TI83P_PROGTOK+24)//0xE6   'Menu'
#define TI83P_tSendMBL          (TI83P_PROGTOK+25)//0xE7   'SEND'
#define TI83P_tGetMBL           (TI83P_PROGTOK+26)//0xE8   'GET'
//
//= ()=====================================================================
//           STAT PLOT COMMANDS                                             
//= ()=====================================================================
//
#define TI83P_statPCmd          (TI83P_PROGTOK+27)
//
#define TI83P_tPlotOn           (TI83P_statPCmd)//0xE9    ' PLOTSON'
#define TI83P_tPlotOff          (TI83P_statPCmd+1)//0xEA    ' PLOTSOFF'
//
#define TI83P_tListName         (0x0EB)// LIST DESIGNATOR
//
#define TI83P_tPlot1            (0x0EC)
#define TI83P_tPlot2            (0x0ED)
#define TI83P_tPlot3            (0x0EE)
//
#define TI83P_tUnused01         (0x0EF)//        available?
//
#define TI83P_tPower            (0x0F0)//        '^'
#define TI83P_tXRoot            (0x0F1)//        LsupX,Lroot

#define TI83P_STATCMD           (0x0F2)
//
#define TI83P_tOneVar           (TI83P_STATCMD)//0xF2   'OneVar_'
#define TI83P_tTwoVar           (TI83P_STATCMD+1)//0xF3
#define TI83P_tLR               (TI83P_STATCMD+2)//0xF4   'LinR(A+BX'
#define TI83P_tLRExp            (TI83P_STATCMD+3)//0xF5   'ExpR_'
#define TI83P_tLRLn             (TI83P_STATCMD+4)//0xF6   'LnR_'
#define TI83P_tLRPwr            (TI83P_STATCMD+5)//0xF7   'PwrR_'
#define TI83P_tMedMed           (TI83P_STATCMD+6)//0xF8
#define TI83P_tQuad             (TI83P_STATCMD+7)//0xF9
#define TI83P_tClrLst           (TI83P_STATCMD+8)//0xFA   'CLEAR LIST'
#define TI83P_tClrTbl           (TI83P_STATCMD+9)//0xFB   CLEAR TABLE
#define TI83P_tHist             (TI83P_STATCMD+10)//0xFC   'Hist_'
#define TI83P_txyLine           (TI83P_STATCMD+11)//0xFD   'xyline_'
#define TI83P_tScatter          (TI83P_STATCMD+12)//0xFE   'Scatter_'
#define TI83P_tLR1              (TI83P_STATCMD+13)//0xFF   'LINR(AX+B'

//       
//= ()=====================================================================
//           2ND HALF OF GRAPH FORMAT TOKENS
//= ()=====================================================================
//           Format settings commands
//
#define TI83P_GFMT              (0)
//
#define TI83P_tSeq              (TI83P_GFMT)// 'SeqG'
#define TI83P_tSimulG           (TI83P_GFMT+1)// 'SimulG'
#define TI83P_tPolarG           (TI83P_GFMT+2)// 'PolarGC'
#define TI83P_tRectG            (TI83P_GFMT+3)// 'RectGC'
#define TI83P_tCoordOn          (TI83P_GFMT+4)// 'CoordOn'
#define TI83P_tCoordOff         (TI83P_GFMT+5)// 'CoordOff'
#define TI83P_tDrawLine         (TI83P_GFMT+6)// 'DrawLine'
#define TI83P_tDrawDot          (TI83P_GFMT+7)// 'DrawDot'
#define TI83P_tAxisOn           (TI83P_GFMT+8)// 'AxesOn'
#define TI83P_tAxisOff          (TI83P_GFMT+9)// 'AxesOff'
#define TI83P_tGridOn           (TI83P_GFMT+10)// 'GridOn'
#define TI83P_tGridOff          (TI83P_GFMT+11)// 'GridOff'
#define TI83P_tLblOn            (TI83P_GFMT+12)// 'LabelOn'
#define TI83P_tLblOff           (TI83P_GFMT+13)// 'LabelOff'
#define TI83P_tWebOn            (TI83P_GFMT+14)// 'WebOn'
#define TI83P_tWebOff           (TI83P_GFMT+15)// 'WebOFF'
#define TI83P_tuv               (TI83P_GFMT+16)// U vs V
#define TI83P_tvw               (TI83P_GFMT+17)// V vs W
#define TI83P_tuw               (TI83P_GFMT+18)// U vs W
//
//= ()=====================================================================
//           2ND HALF OF USER MATRIX TOKENS                                 
//= ()=====================================================================
//
#define TI83P_tMatA             (0x00)// MAT A
#define TI83P_tMatB             (0x01)// MAT B
#define TI83P_tMatC             (0x02)// MAT C
#define TI83P_tMatD             (0x03)// MAT D
#define TI83P_tMatE             (0x04)// MAT E
#define TI83P_tMatF             (0x05)// MAT F
#define TI83P_tMatG             (0x06)// MAT G
#define TI83P_tMatH             (0x07)// MAT H
#define TI83P_tMatI             (0x08)// MAT I
#define TI83P_tMatJ             (0x09)// MAT J
//      
//= ()=====================================================================
//           2ND HALF OF USER LIST TOKENS
//= ()=====================================================================
//
#define TI83P_tL1               (0x00)// LIST 1
#define TI83P_tL2               (0x01)// LIST 2
#define TI83P_tL3               (0x02)// LIST 3
#define TI83P_tL4               (0x03)// LIST 4
#define TI83P_tL5               (0x04)// LIST 5
#define TI83P_tL6               (0x05)// LIST 6

//
//= ()=====================================================================
//           2ND HALF OF USER = (TI83P_ATION TOKENS)
//= ()=====================================================================
//
//       "Y" = (TI83P_ATIONS HAVE BIT 4 SET)
//
#define TI83P_tY1               (0x10)// Y1
#define TI83P_tY2               (0x11)// Y2
#define TI83P_tY3               (0x12)// Y3
#define TI83P_tY4               (0x13)// Y4
#define TI83P_tY5               (0x14)// Y5
#define TI83P_tY6               (0x15)// Y6
#define TI83P_tY7               (0x16)// Y7
#define TI83P_tY8               (0x17)// Y8
#define TI83P_tY9               (0x18)// Y9
#define TI83P_tY0               (0x19)// Y0
//
//       PARAM = (TI83P_ATIONS HAVE BIT 5 SET)
//
#define TI83P_tX1T              (0x20)// X1t
#define TI83P_tY1T              (0x21)// Y1t
#define TI83P_tX2T              (0x22)// X2t
#define TI83P_tY2T              (0x23)// Y2t
#define TI83P_tX3T              (0x24)// X3t
#define TI83P_tY3T              (0x25)// Y3t
#define TI83P_tX4T              (0x26)// X4t
#define TI83P_tY4T              (0x27)// Y4t
#define TI83P_tX5T              (0x28)// X5t
#define TI83P_tY5T              (0x29)// Y5t
#define TI83P_tX6T              (0x2A)// X6t
#define TI83P_tY6T              (0x2B)// Y6t
//
//       POLAR = (TI83P_ATIONS HAVE BIT 6 SET)
//
#define TI83P_tR1               (0x40)// R1
#define TI83P_tR2               (0x41)// R2
#define TI83P_tR3               (0x42)// R3
#define TI83P_tR4               (0x43)// R4
#define TI83P_tR5               (0x44)// R5
#define TI83P_tR6               (0x45)// R6
//
//       RECURSION = (TI83P_ATIONS HAVE BIT 7 SET)
//
#define TI83P_tun               (0x80)// Un
#define TI83P_tvn               (0x81)// Vn
#define TI83P_twn               (0x82)// Wn
//
//= ()=====================================================================
//           2ND HALF OF USER PICTURE TOKENS                                
//= ()=====================================================================
//
#define TI83P_tPic1             (0x00)// PIC1
#define TI83P_tPic2             (0x01)// PIC2
#define TI83P_tPic3             (0x02)// PIC3
#define TI83P_tPic4             (0x03)// PIC4
#define TI83P_tPic5             (0x04)// PIC5
#define TI83P_tPic6             (0x05)// PIC6
#define TI83P_tPic7             (0x06)// PIC7
#define TI83P_tPic8             (0x07)// PIC8
#define TI83P_tPic9             (0x08)// PIC9
#define TI83P_tPic0             (0x09)// PIC0
// 
//= ()=====================================================================
//           2ND HALF OF USER GRAPH DATABASE TOKENS                         
//= ()=====================================================================
//
#define TI83P_tGDB1             (0x00)// GDB1
#define TI83P_tGDB2             (0x01)// GDB2
#define TI83P_tGDB3             (0x02)// GDB3
#define TI83P_tGDB4             (0x03)// GDB4
#define TI83P_tGDB5             (0x04)// GDB5
#define TI83P_tGDB6             (0x05)// GDB6
#define TI83P_tGDB7             (0x06)// GDB7
#define TI83P_tGDB8             (0x07)// GDB8
#define TI83P_tGDB9             (0x08)// GDB9
#define TI83P_tGDB0             (0x09)// GDB0
//  
//= ()=====================================================================
//           2ND HALF OF STRING VARS                                        
//= ()=====================================================================
//
#define TI83P_tStr1             (0x00)
#define TI83P_tStr2             (0x01)
#define TI83P_tStr3             (0x02)
#define TI83P_tStr4             (0x03)
#define TI83P_tStr5             (0x04)
#define TI83P_tStr6             (0x05)
#define TI83P_tStr7             (0x06)
#define TI83P_tStr8             (0x07)
#define TI83P_tStr9             (0x08)
#define TI83P_tStr0             (0x09)

// 
//= ()=====================================================================
//           2ND HALF OF SYSTEM OUTPUT ONLY VARIABLES                       
//= ()=====================================================================
//
//
//   OPEN        = (0x00)
//
#define TI83P_tRegEq            (0x01)// REGRESSION EQUATION
//
#define TI83P_tStatN            (0x02)// STATISTICS N
//
#define TI83P_tXMean            (0x03)// X MEAN
#define TI83P_tSumX             (0x04)// SUM(X)
#define TI83P_tSumXSqr          (0x05)// SUM(X^2)
#define TI83P_tStdX             (0x06)// STANDARD DEV X
#define TI83P_tStdPX            (0x07)// STANDARD DEV POP X
#define TI83P_tMinX             (0x08)// Min X VALUE
#define TI83P_tMaxX             (0x09)// Max X VALUE
//
#define TI83P_tMinY             (0x0A)// Min Y VALUE
#define TI83P_tMaxY             (0x0B)// Max Y VALUE
#define TI83P_tYmean            (0x0C)// Y MEAN
#define TI83P_tSumY             (0x0D)// SUM(Y)
#define TI83P_tSumYSqr          (0x0E)// SUM(Y^2)
#define TI83P_tStdY             (0x0F)// STANDARD DEV Y
#define TI83P_tStdPY            (0x10)// STANDARD DEV POP Y
//
#define TI83P_tSumXY            (0x11)// SUM(XY)
#define TI83P_tCorr             (0x12)// CORRELATION
#define TI83P_tMedX             (0x13)// MED(X)
#define TI83P_tQ1               (0x14)// 1ST QUADRANT OF X
#define TI83P_tQ3               (0x15)// 3RD QUADRANT OF X
#define TI83P_tQuadA            (0x16)// 1ST TERM OF QUAD POLY REG/ Y-INT
#define TI83P_tQuadB            (0x17)// 2ND TERM OF QUAD POLY REG/ SLOPE
#define TI83P_tQuadC            (0x18)// 3RD TERM OF QUAD POLY REG
#define TI83P_tCubeD            (0x19)// 4TH TERM OF CUBIC POLY REG
#define TI83P_tQuartE           (0x1A)// 5TH TERM OF QUART POLY REG
#define TI83P_tMedX1            (0x1B)// x1 FOR MED-MED
#define TI83P_tMedX2            (0x1C)// x2 FOR MED-MED
#define TI83P_tMedX3            (0x1D)// x3 FOR MED-MED
#define TI83P_tMedY1            (0x1E)// y1 FOR MED-MED
#define TI83P_tMedY2            (0x1F)// y2 FOR MED-MED
#define TI83P_tMedY3            (0x20)// y3 FOR MED-MED
//
#define TI83P_tRecurn		  (0x21)// RECURSION N
#define TI83P_tStatP            (0x22)
#define TI83P_tStatZ            (0x23)
#define TI83P_tStatT            (0x24)
#define TI83P_tStatChi          (0x25)
#define TI83P_tStatF            (0x26)
#define TI83P_tStatDF           (0x27)
#define TI83P_tStatPhat         (0x28)
#define TI83P_tStatPhat1        (0x29)
#define TI83P_tStatPhat2        (0x2A)
#define TI83P_tStatMeanX1       (0x2B)
#define TI83P_tStatStdX1        (0x2C)
#define TI83P_tStatN1           (0x2D)
#define TI83P_tStatMeanX2       (0x2E)
#define TI83P_tStatStdX2        (0x2F)
#define TI83P_tStatN2           (0x30)
#define TI83P_tStatStdXP        (0x31)
#define TI83P_tStatLower        (0x32)
#define TI83P_tStatUpper        (0x33)
#define TI83P_tStat_s           (0x34)
#define TI83P_tLRSqr            (0x35)// r^2
#define TI83P_tBRSqr            (0x36)// R^2
//
//= ()=====================================================================
//       These next tokens are only used to access the data
//       they are display only and the user cannot access them at all
//= ()=====================================================================
//
#define TI83P_tF_DF      (0x37)// ANOFAV FACTOR DF
#define TI83P_tF_SS      (0x38)// ANOFAV FACTOR SS
#define TI83P_tF_MS      (0x39)// ANOFAV FACTOR MS
#define TI83P_tE_DF      (0x3A)// ANOFAV ERROR DF
#define TI83P_tE_SS      (0x3B)// ANOFAV ERROR SS
#define TI83P_tE_MS      (0x3C)// ANOFAV ERROR MS
//
//
//= ()=====================================================================
//           2ND HALF OF SYSTEM INPUT/OUTPUT VARIABLES
//= ()=====================================================================
//      SYSTEM VARIABLE = (TI83P_ATES)
//
#define TI83P_tuXscl         (0)
#define TI83P_tuYscl         (1)
#define TI83P_tXscl          (2)
#define TI83P_tYscl          (3)
#define TI83P_tRecuru0       (4)// U 1ST INITIAL COND
#define TI83P_tRecurv0       (5)// V 1ST INITIAL COND
#define TI83P_tun1           (6)// U(N-1)    ; NOT USED
#define TI83P_tvn1           (7)// V(N-1)    ; NOT USED
#define TI83P_tuRecuru0      (8)//
#define TI83P_tuRecurv0      (9)//
//
#define TI83P_tXmin          (0x0A)
#define TI83P_tXmax          (0x0B)
#define TI83P_tYmin          (0x0C)
#define TI83P_tYmax          (0x0D)
#define TI83P_tTmin          (0x0E)
#define TI83P_tTmax          (0x0F)
#define TI83P_tThetaMin      (0x10)
#define TI83P_tThetaMax      (0x11)
#define TI83P_tuXmin         (0x12)
#define TI83P_tuXmax         (0x13)
#define TI83P_tuYmin         (0x14)
#define TI83P_tuYmax         (0x15)
#define TI83P_tuThetMin      (0x16)
#define TI83P_tuThetMax      (0x17)
#define TI83P_tuTmin         (0x18)
#define TI83P_tuTmax         (0x19)
#define TI83P_tTblMin        (0x1A)
#define TI83P_tPlotStart     (0x1B)
#define TI83P_tuPlotStart    (0x1C)
#define TI83P_tnMax          (0x1D)
#define TI83P_tunMax         (0x1E)
#define TI83P_tnMin          (0x1F)
#define TI83P_tunMin         (0x20)
//
#define TI83P_tTblStep	  (0x21)
#define TI83P_tTStep		  (0x22)
#define TI83P_tThetaStep	  (0x23)
#define TI83P_tuTStep		  (0x24)
#define TI83P_tuThetStep	  (0x25)
//
#define TI83P_tDeltaX		  (0x26)
#define TI83P_tDeltaY		  (0x27)
//
#define TI83P_tXFact		  (0x28)
#define TI83P_tYFact		  (0x29)
//
#define TI83P_tTblInput         (0x2A)
//
#define TI83P_tFinN             (0x2B)
#define TI83P_tFinI             (0x2C)
#define TI83P_tFinPV            (0x2D)
#define TI83P_tFinPMT           (0x2E)
#define TI83P_tFinFV            (0x2F)
#define TI83P_tFinPY            (0x30)
#define TI83P_tFinCY            (0x31)
//
#define TI83P_tRecurw0          (0x32)// w0(1)
#define TI83P_tuRecurw0         (0x33)
//
#define TI83P_tPlotStep         (0x34)
#define TI83P_tuPlotStep        (0x35)
//
#define TI83P_tXres             (0x36)
#define TI83P_tuXres            (0x37)
//
#define TI83P_tRecuru02         (0x38)// u0(2)
#define TI83P_tuRecuru02        (0x39)
#define TI83P_tRecurv02         (0x3C)// v0(2)
#define TI83P_tuRecurv02        (0x3D)
#define TI83P_tRecurw02         (0x3E)// w0(2)
#define TI83P_tuRecurw02        (0x3F)
//
//= ()=====================================================================
//           2nd byte of t2ByteTok tokens
//= ()=====================================================================
//
#define TI83P_tFinNPV           (0x00)//
#define TI83P_tFinIRR           (0x01)//
#define TI83P_tFinBAL           (0x02)//
#define TI83P_tFinPRN           (0x03)//
#define TI83P_tFinINT           (0x04)//
#define TI83P_tFinToNom         (0x05)//
#define TI83P_tFinToEff         (0x06)//
#define TI83P_tFinDBD           (0x07)//
#define TI83P_tLCM              (0x08)//
#define TI83P_tGCD              (0x09)//
#define TI83P_tRandInt          (0x0A)//
#define TI83P_tRandBin          (0x0B)//
#define TI83P_tSubStrng         (0x0C)//
#define TI83P_tStdDev           (0x0D)//
#define TI83P_tVariance         (0x0E)//
#define TI83P_tInStrng          (0x0F)//
#define TI83P_tDNormal          (0x10)//
#define TI83P_tInvNorm          (0x11)//
#define TI83P_tDT               (0x12)//
#define TI83P_tChI              (0x13)//
#define TI83P_tDF               (0x14)//
#define TI83P_tBINPDF           (0x15)//
#define TI83P_tBINCDF           (0x16)//
#define TI83P_tPOIPDF           (0x17)//
#define TI83P_tPOICDF           (0x18)//
#define TI83P_tGEOPDF           (0x19)//
#define TI83P_tGEOCDF           (0x1A)//
#define TI83P_tNormalPDF        (0x1B)//
#define TI83P_tTPDF             (0x1C)//
#define TI83P_tChiPDF           (0x1D)//
#define TI83P_tFPDF             (0x1E)//
#define TI83P_tRandNorm         (0x1F)//
#define TI83P_tFinFPMT          (0x20)//
#define TI83P_tFinFI            (0x21)//
#define TI83P_tFinFPV           (0x22)//
#define TI83P_tFinFN            (0x23)//
#define TI83P_tFinFFV           (0x24)//
#define TI83P_tConj             (0x25)//
#define TI83P_tReal             (0x26)//
#define TI83P_tImag             (0x27)//
#define TI83P_tAngle            (0x28)//
#define TI83P_tCumSum           (0x29)//
#define TI83P_tExpr             (0x2A)//
#define TI83P_tLength           (0x2B)//
#define TI83P_tDeltaLst         (0x2C)//
#define TI83P_tRef              (0x2D)//
#define TI83P_tRRef             (0x2E)//
#define TI83P_tToRect           (0x2F)//
#define TI83P_tToPolar          (0x30)//
#define TI83P_tConste           (0x31)//
#define TI83P_tSinReg           (0x32)//
#define TI83P_tLogistic         (0x33)//
#define TI83P_tLinRegTTest      (0x34)//
#define TI83P_tShadeNorm        (0x35)//
#define TI83P_tShadeT           (0x36)//
#define TI83P_tShadeChi         (0x37)//
#define TI83P_tShadeF           (0x38)//
#define TI83P_tMatToLst         (0x39)//
#define TI83P_tLstToMat         (0x3A)//
#define TI83P_tZTest            (0x3B)//
#define TI83P_tTTest            (0x3C)//
#define TI83P_t2SampZTest       (0x3D)//
#define TI83P_t1PropZTest       (0x3E)//
#define TI83P_t2PropZTest       (0x3F)//
#define TI83P_tChiTest          (0x40)//
#define TI83P_tZIntVal          (0x41)//
#define TI83P_t2SampZInt        (0x42)//
#define TI83P_t1PropZInt        (0x43)//
#define TI83P_t2PropZInt        (0x44)//
#define TI83P_tGraphStyle       (0x45)//
#define TI83P_t2SampTTest       (0x46)//
#define TI83P_t2SampFTest       (0x47)//
#define TI83P_tTIntVal          (0x48)//
#define TI83P_t2SampTInt        (0x49)//
#define TI83P_tSetupLst         (0x4A)//
#define TI83P_tFinPMTend        (0x4B)//
#define TI83P_tFinPMTbeg        (0x4C)//
#define TI83P_tRealM            (0x4D)//
#define TI83P_tPolarM           (0x4E)//
#define TI83P_tRectM            (0x4F)//
#define TI83P_tExprOn           (0x50)//
#define TI83P_tExprOff          (0x51)//
#define TI83P_tClrAllLst        (0x52)//
#define TI83P_tGetCalc          (0x53)//
#define TI83P_tDelVar           (0x54)//
#define TI83P_tEquToStrng       (0x55)//
#define TI83P_tStrngToEqu       (0x56)//
#define TI83P_tDelLast          (0x57)//
#define TI83P_tSelect           (0x58)//
#define TI83P_tANOVA            (0x59)//
#define TI83P_tModBox           (0x5A)//
#define TI83P_tNormProb         (0x5B)//
//
//
#define TI83P_tMGT              (0x64)// VERTICAL SPLIT
#define TI83P_tZFit             (0x65)// ZOOM FIT
#define TI83P_tDiag_on          (0x66)// DIANOSTIC DISPLAY ON
#define TI83P_tDiag_off         (0x67)// DIANOSTIC DISPLAY OFF
#define TI83P_tOkEnd2v0         (0x67)//end of 2byte tokens for version 0.
#define TI83P_tArchive          (0x68)//archive
#define TI83P_tUnarchive        (0x69)//unarchive
#define TI83P_tasm		  ( 0x6A)
#define TI83P_tasmComp	  ( 0x6B)// asm compile
#define TI83P_tasmPrgm	  ( 0x6C)// signifies a program is asm
#define TI83P_tasmCmp 	  ( 0x6D)// asm program is compiled
//
#define TI83P_tLcapAAcute       (0x6E)
#define TI83P_tLcapAGrave       (0x6F)
#define TI83P_tLcapACaret       (0x70)
#define TI83P_tLcapADier        (0x71)
#define TI83P_tLaAcute          (0x72)
#define TI83P_tLaGrave          (0x73)
#define TI83P_tLaCaret          (0x74)
#define TI83P_tLaDier           (0x75)
#define TI83P_tLcapEAcute       (0x76)
#define TI83P_tLcapEGrave       (0x77)
#define TI83P_tLcapECaret       (0x78)
#define TI83P_tLcapEDier        (0x79)
#define TI83P_tLeAcute          (0x7A)
#define TI83P_tLeGrave          (0x7B)
#define TI83P_tLeCaret          (0x7C)
#define TI83P_tLeDier           (0x7D)
//
#define TI83P_tLcapIGrave       (0x7F)
#define TI83P_tLcapICaret       (0x80)
#define TI83P_tLcapIDier        (0x81)
#define TI83P_tLiAcute          (0x82)
#define TI83P_tLiGrave          (0x83)
#define TI83P_tLiCaret          (0x84)
#define TI83P_tLiDier           (0x85)
#define TI83P_tLcapOAcute       (0x86)
#define TI83P_tLcapOGrave       (0x87)
#define TI83P_tLcapOCaret       (0x88)
#define TI83P_tLcapODier        (0x89)
#define TI83P_tLoAcute          (0x8A)
#define TI83P_tLoGrave          (0x8B)
#define TI83P_tLoCaret          (0x8C)
#define TI83P_tLoDier           (0x8D)
#define TI83P_tLcapUAcute       (0x8E)
#define TI83P_tLcapUGrave       (0x8F)
#define TI83P_tLcapUCaret       (0x90)
#define TI83P_tLcapUDier        (0x91)
#define TI83P_tLuAcute          (0x92)
#define TI83P_tLuGrave          (0x93)
#define TI83P_tLuCaret          (0x94)
#define TI83P_tLuDier           (0x95)
#define TI83P_tLcapCCed         (0x96)
#define TI83P_tLcCed            (0x97)
#define TI83P_tLcapNTilde       (0x98)
#define TI83P_tLnTilde          (0x99)
#define TI83P_tLaccent          (0x9A)
#define TI83P_tLgrave           (0x9B)
#define TI83P_tLdieresis        (0x9C)
#define TI83P_tLquesDown        (0x9D)
#define TI83P_tLexclamDown      (0x9E)
#define TI83P_tLalpha           (0x9F)
#define TI83P_tLbeta            (0x0a0)
#define TI83P_tLgamma           (0x0a1)
#define TI83P_tLcapDelta        (0x0a2)
#define TI83P_tLdelta           (0x0a3)
#define TI83P_tLepsilon         (0x0a4)
#define TI83P_tLlambda          (0x0a5)
#define TI83P_tLmu              (0x0a6)
#define TI83P_tLpi              (0x0a7)
#define TI83P_tLrho             (0x0a8)
#define TI83P_tLcapSigma        (0x0a9)
//
//
#define TI83P_tLphi             (0x0aB)
#define TI83P_tLcapOmega        (0x0aC)
#define TI83P_tLphat            (0x0aD)
#define TI83P_tLchi             (0x0aE)
#define TI83P_tLstatF           (0x0aF)
//

#define TI83P_tLa        (0x0b0)
#define TI83P_tLb        (0x0b1)
#define TI83P_tLc        (0x0b2)
#define TI83P_tLd        (0x0b3)
#define TI83P_tLsmalle   (0x0b4)
#define TI83P_tLf        (0x0b5)
#define TI83P_tLsmallg   (0x0b6)
#define TI83P_tLh        (0x0b7)
#define TI83P_tLi        (0x0b8)
#define TI83P_tLj        (0x0b9)
#define TI83P_tLk        (0x0bA)
//

#define TI83P_tLl        (0x0bC)
#define TI83P_tLm        (0x0bD)
#define TI83P_tLn        (0x0bE)
#define TI83P_tLo        (0x0bF)
#define TI83P_tLp        (0x0c0)
#define TI83P_tLq        (0x0c1)
#define TI83P_tLsmallr   (0x0c2)
#define TI83P_tLs        (0x0c3)
#define TI83P_tLsmallt   (0x0c4)
#define TI83P_tLu        (0x0c5)
#define TI83P_tLv        (0x0c6)
#define TI83P_tLw        (0x0c7)
#define TI83P_tLx        (0x0c8)
#define TI83P_tLy        (0x0c9)
#define TI83P_tLz        (0x0cA)
#define TI83P_tLsigma           (0x0cb)
#define TI83P_tLtau             (0x0cc)
#define TI83P_tLcapIAcute       (0x0cd)
//
//
#define TI83P_tGarbagec   (0x0Ce)
#define TI83P_LastToken         (0x0Ce)//tLAST TOKEN IN THIS VERSION...
//
//= ()=====================================================================
//           Data Type Equates                                                    
//= ()=====================================================================
//
#define TI83P_RealObj           (0)
#define TI83P_ListObj           (1)
#define TI83P_MatObj            (2)
#define TI83P_EquObj            (3)
#define TI83P_StrngObj          (4)
#define TI83P_ProgObj           (5)
#define TI83P_ProtProgObj       (6)
#define TI83P_PictObj           (7)
#define TI83P_GDBObj            (8)
#define TI83P_UnknownObj        (9)
#define TI83P_UnknownEquObj     (0x0A)
#define TI83P_NewEquObj         (0x0B)
#define TI83P_CplxObj           (0x0C)
#define TI83P_CListObj          (0x0D)
#define TI83P_UndefObj          (0x0E)
#define TI83P_WindowObj         (0x0F)
#define TI83P_ZStoObj           (0x10)
#define TI83P_TblRngObj         (0x11)
#define TI83P_LCDObj            (0x12)
#define TI83P_BackupObj         (0x13)
#define TI83P_AppObj		  ( 0x14)//application, only used in menus/link
#define TI83P_AppVarObj	  ( 0x15)//application variable
#define TI83P_TempProgObj       (0x16)//program, home deletes when finished
#define TI83P_GroupObj          (0x17)//group.
// 
//= ()=====================================================================
//           I/O equates                                                          
//= ()=====================================================================
//
#define TI83P_D0D1_bits	  (0x03)
#define TI83P_D0LD1L		  (0x03)
#define TI83P_D0LD1H		  (0x01)
#define TI83P_D0HD1L		  (0x02)
#define TI83P_D0HD1H		  (0x00)
#define TI83P_bport		  (0)// 4-BIT LINK PORT (I/O) 
//
//= ()=====================================================================
//           DEVICE CODES                                                       
//= ()=====================================================================
//
//
#define TI83P_TI82DEV		  (0x82)
#define TI83P_PC82DEV		  (0x02)
#define TI83P_MAC82DEV	  (0x12)
//
#define TI83P_TI83FDEV	  (0x73)
#define TI83P_LINK83FDEV	  (0x23)
//
#define TI83P_TI83DEV		  (0x83)
#define TI83P_PC83DEV		  (0x03)
#define TI83P_MAC83DEV	  (0x13)
//
#define TI83P_TI85DEV		  (0x95)// DIFF THEN REAL 85 SO ME TALK
#define TI83P_PC85DEV		  (0x05)
#define TI83P_MAC85DEV	  (0x15)
//
#define TI83P_TI73DEV		  (0x74)// Device x3 is always an 83
#define TI83P_PC73DEV		  (0x07)
#define TI83P_MAC73DEV	  (0x17)
//
#define TI83P_TI83FDEV	  (0x73)
#define TI83P_LINK73FDEV	  (0x23)
#define TI83P_PC83FDEV	  (0x23)
//
//= ()=====================================================================
//           System Error Codes                                                  
//= ()=====================================================================
//
#define TI83P_E_EDITF		  (7)//allow re-entering application
#define TI83P_E_Mask		  (0x7F)

#define TI83P_E_Overflow	  (1+E_EDIT)
#define TI83P_E_DivBy0	  (2+E_EDIT)
#define TI83P_E_SingularMat	  (3+E_EDIT)
#define TI83P_E_Domain	  (4+E_EDIT)
#define TI83P_E_Increment	  (5+E_EDIT)
#define TI83P_E_Break		  (6+E_EDIT)
#define TI83P_E_NonReal         (7+E_EDIT)
#define TI83P_E_Syntax          (8+E_EDIT)
#define TI83P_E_DataType        (9+E_EDIT)
#define TI83P_E_Argument        (10+E_EDIT)
#define TI83P_E_DimMismatch     (11+E_EDIT)
#define TI83P_E_Dimension       (12+E_EDIT)
#define TI83P_E_Undefined       (13+E_EDIT)
#define TI83P_E_Memory          (14+E_EDIT)
#define TI83P_E_Invalid         (15+E_EDIT)
#define TI83P_E_IllegalNest     (16+E_EDIT)
#define TI83P_E_Bound           (17+E_EDIT)
#define TI83P_E_GraphRange      (18+E_EDIT)
#define TI83P_E_Zoom            (19+E_EDIT)
#define TI83P_E_Label           (20)
#define TI83P_E_Stat            (21)
#define TI83P_E_Solver          (22+E_EDIT)
#define TI83P_E_Singularity     (23+E_EDIT)
#define TI83P_E_SignChange      (24+E_EDIT)
#define TI83P_E_Iterations      (25+E_EDIT)
#define TI83P_E_BadGuess        (26+E_EDIT)
#define TI83P_E_StatPlot        (27)
#define TI83P_E_TolTooSmall     (28+E_EDIT)
#define TI83P_E_Reserved        (29+E_EDIT)
#define TI83P_E_Mode            (30+E_EDIT)
#define TI83P_E_LnkErr          (31+E_EDIT)
#define TI83P_E_LnkMemErr       (32+E_EDIT)
#define TI83P_E_LnkTransErr     (33+E_EDIT)
#define TI83P_E_LnkDupErr       (34+E_EDIT)
#define TI83P_E_LnkMemFull      (35+E_EDIT)
#define TI83P_E_Unknown         (36+E_EDIT)

#define TI83P_E_Scale           (37+E_EDIT)
#define TI83P_E_IdNotFound      (38)
#define TI83P_E_NoMode          (39+E_EDIT)
#define TI83P_E_Validation      (40)
#define TI83P_E_Length          (41+E_EDIT)
#define TI83P_E_Application     (42+E_EDIT)
#define TI83P_E_AppErr1         (43+E_EDIT)
#define TI83P_E_AppErr2         (44+E_EDIT)
#define TI83P_E_ExpiredApp	  (45)
#define TI83P_E_BadAddr	  (46)
#define TI83P_E_Archived        (47+E_EDIT)
#define TI83P_E_Version         (48)
#define TI83P_E_ArchFull        (49)
#define TI83P_E_Variable        (50+E_EDIT)
#define TI83P_E_Duplicate       (51+E_EDIT)
#define TI83P_HigErrNum         (51)


// obsolete error numbers34              ;first LINK error
#define TI83P_E_LinkIOChkSum	  (34)
#define TI83P_E_LinkIOTimeOut	  (35)
#define TI83P_E_LinkIOBusy	  (36)
#define TI83P_E_LinkIOVer	  (37)

//
//= ()=====================================================================
//           = (TI83P_ATES TO RAM LOCATIONS FOR STAT VARS)
//= ()=====================================================================
//
//
#define TI83P_FPLEN	  (9)//Length of a floating-point number.
#define TI83P_StatN     (TI83P_statVars)
#define TI83P_XMean     (TI83P_StatN      + TI83P_fplen)
#define TI83P_SumX      (TI83P_XMean      + TI83P_fplen)
#define TI83P_SumXSqr   (TI83P_SumX       + TI83P_fplen)
#define TI83P_StdX      (TI83P_SumXSqr    + TI83P_fplen)
#define TI83P_StdPX     (TI83P_StdX       + TI83P_fplen)
#define TI83P_MinX      (TI83P_StdPX      + TI83P_fplen)
#define TI83P_MaxX      (TI83P_MinX       + TI83P_fplen)
#define TI83P_MinY      (TI83P_MaxX       + TI83P_fplen)
#define TI83P_MaxY      (TI83P_MinY       + TI83P_fplen)
#define TI83P_YMean     (TI83P_MaxY       + TI83P_fplen)
#define TI83P_SumY      (TI83P_YMean      + TI83P_fplen)
#define TI83P_SumYSqr   (TI83P_SumY       + TI83P_fplen)
#define TI83P_StdY      (TI83P_SumYSqr    + TI83P_fplen)
#define TI83P_StdPY     (TI83P_StdY       + TI83P_fplen)
#define TI83P_SumXY     (TI83P_StdPY      + TI83P_fplen)
#define TI83P_Corr      (TI83P_SumXY      + TI83P_fplen)
#define TI83P_MedX      (TI83P_Corr       + TI83P_fplen)
#define TI83P_Q1        (TI83P_MedX       + TI83P_fplen)
#define TI83P_Q3        (TI83P_Q1         + TI83P_fplen)
#define TI83P_QuadA     (TI83P_Q3         + TI83P_fplen)
#define TI83P_QuadB     (TI83P_QuadA      + TI83P_fplen)
#define TI83P_QuadC     (TI83P_QuadB      + TI83P_fplen)
#define TI83P_CubeD     (TI83P_QuadC      + TI83P_fplen)
#define TI83P_QuartE    (TI83P_CubeD      + TI83P_fplen)
#define TI83P_MedX1     (TI83P_QuartE     + TI83P_fplen)
#define TI83P_MedX2     (TI83P_MedX1      + TI83P_fplen)
#define TI83P_MedX3     (TI83P_MedX2      + TI83P_fplen)
#define TI83P_MedY1     (TI83P_MedX3      + TI83P_fplen)
#define TI83P_MedY2     (TI83P_MedY1      + TI83P_fplen)
#define TI83P_MedY3     (TI83P_MedY2      + TI83P_fplen)
#define TI83P_PStat     (TI83P_MedY3      + 2*TI83P_fplen)
#define TI83P_ZStat     (TI83P_PStat      + TI83P_fplen)
#define TI83P_TStat     (TI83P_ZStat      + TI83P_fplen)
#define TI83P_ChiStat   (TI83P_TStat      + TI83P_fplen)
#define TI83P_FStat     (TI83P_ChiStat    + TI83P_fplen)
#define TI83P_DF        (TI83P_FStat      + TI83P_fplen)
#define TI83P_Phat      (TI83P_DF         + TI83P_fplen)
#define TI83P_Phat1     (TI83P_Phat       + TI83P_fplen)
#define TI83P_Phat2     (TI83P_Phat1      + TI83P_fplen)
#define TI83P_MeanX1    (TI83P_Phat2      + TI83P_fplen)
#define TI83P_StdX1     (TI83P_MeanX1     + TI83P_fplen)
#define TI83P_StatN1    (TI83P_StdX1      + TI83P_fplen)
#define TI83P_MeanX2    (TI83P_StatN1     + TI83P_fplen)
#define TI83P_StdX2     (TI83P_MeanX2     + TI83P_fplen)
#define TI83P_StatN2    (TI83P_StdX2      + TI83P_fplen)
#define TI83P_StdXP2    (TI83P_StatN2     + TI83P_fplen)
#define TI83P_SLower    (TI83P_StdXP2     + TI83P_fplen)
#define TI83P_SUpper    (TI83P_SLower     + TI83P_fplen)
#define TI83P_SStat     (TI83P_SUpper     + TI83P_fplen)

#define TI83P_F_DF	  (TI83P_anovaf_vars)
#define TI83P_F_SS	  (TI83P_F_DF + TI83P_fplen)
#define TI83P_F_MS	  (TI83P_F_SS + TI83P_fplen)
#define TI83P_E_DF	  (TI83P_F_MS + TI83P_fplen)
#define TI83P_E_SS	  (TI83P_E_DF + TI83P_fplen)
#define TI83P_E_MS	  (TI83P_E_SS + TI83P_fplen)


//= ()=====================================================================
//= ()=====================================================================
//  The following is a duplicate of all of the above equates
//  in lower case.  
//
//  It may be deleted if you choose case insensitive development
//  tools or choose to follow the above conventions.
//
//
//= ()=====================================================================
//
//= ()=====================================================================
//           system variable equates
//= ()=====================================================================
//       entry points : rclsystok, stosystok
//
#define TI83P_xsclt	  (2)
#define TI83P_ysclt	  (3)
#define TI83P_xmint	  (0x0a)
#define TI83P_xmaxt	  (0x0b)
#define TI83P_ymint	  (0x0c)
#define TI83P_ymaxt	  (0x0d)
#define TI83P_tmint	  (0x0e)
#define TI83P_tmaxt	  (0x0f)
#define TI83P_thetmint  (0x10)
#define TI83P_thetmaxt  (0x11)
#define TI83P_tblmint	  (0x1a)
#define TI83P_plotstartt  (0x1b)
#define TI83P_nmaxt	  (0x1d)
#define TI83P_nmint	  (0x1f)
#define TI83P_tblstept  (0x21)
#define TI83P_tstept	  (0x22)
#define TI83P_thetstept  (0x23)
#define TI83P_deltaxt	  (0x26)
#define TI83P_deltayt	  (0x27)
#define TI83P_xfactt	  (0x28)
#define TI83P_yfactt	  (0x29)
#define TI83P_finnt	  (0x2b)
#define TI83P_finit	  (0x2c)
#define TI83P_finpvt	  (0x2d)
#define TI83P_finpmtt	  (0x2e)
#define TI83P_finfvt	  (0x2f)
#define TI83P_finpyt	  (0x30)
#define TI83P_fincyt	  (0x31)
#define TI83P_plotstept  (0x34)
#define TI83P_xrest	  (0x36)
//

//= ()=====================================================================
//           run indicators
//= ()=====================================================================
//
//TI83P_busypause = (10101010b)
//TI83P_busynormal = (11110000b)
//
//= ()=====================================================================
// macro to call base code from an app,
//= ()=====================================================================
//
#define TI83P_rbr_call   (0x28)// needed for apps
#define TI83P_brt_jump0   (0x50)
//
//

//= ()=====================================================================
//           common subroutine rst numbers  
//= ()=====================================================================
//
#define TI83P_rop1toop2  (0x08)
#define TI83P_rfindsym  (0x10)
#define TI83P_rpushrealo1  (0x18)
#define TI83P_rmov9toop1  (0x20)
#define TI83P_rfpadd	  (0x30)
//

//symbolic_debug_start
//= ()=====================================================================
//           entry points  
//= ()=====================================================================
//
#define TI83P_abso1o2cp	  (0x410e)
#define TI83P_abso1pabso2	  (0x405a)
#define TI83P_acos		  (0x40de)
#define TI83P_acosh		  (0x40f0)
#define TI83P_acosrad	  (0x40d2)
#define TI83P_adrlele	  (0x462d)
#define TI83P_adrmele	  (0x4609)
#define TI83P_adrmrow	  (0x4606)
#define TI83P_alleq		  (0x4876)
#define TI83P_allocfps	  (0x43a5)
#define TI83P_allocfps1	  (0x43a8)
#define TI83P_angle		  (0x4102)
#define TI83P_ansname	  (0x4b52)
#define TI83P_apdsetup	  (0x4c93)
#define TI83P_appgetcalc	  (0x4c78)
#define TI83P_appgetcbl	  (0x4c75)
#define TI83P_arc_unarc	  (0x4fd8)
#define TI83P_asin		  (0x40e4)
#define TI83P_asinh		  (0x40ed)
#define TI83P_asinrad	  (0x40db)
#define TI83P_atan		  (0x40e1)
#define TI83P_atan2		  (0x40e7)
#define TI83P_atan2rad	  (0x40d8)
#define TI83P_atanh		  (0x40ea)
#define TI83P_atanrad	  (0x40d5)

#define TI83P_binopexec	  (0x4663)
#define TI83P_bit_vertsplit	  (0x4fa8)
#define TI83P_bufclr		  (0x5074)
#define TI83P_bufcpy		  (0x5071)

#define TI83P_cabs		  (0x4e97)
#define TI83P_cadd		  (0x4e88)
#define TI83P_canalphins	  (0x4c69)
#define TI83P_cdiv		  (0x4e94)
#define TI83P_cdivbyreal	  (0x4ebb)
#define TI83P_cetox		  (0x4ea9)
#define TI83P_cfrac		  (0x4ec1)
#define TI83P_checksplitflag	  (0x49f0)
#define TI83P_chkfindsym	  (0x42f1)
#define TI83P_cintgr		  (0x4ec4)
#define TI83P_circcmd	  (0x47d4)
#define TI83P_ckint		  (0x4234)
#define TI83P_ckodd		  (0x4237)
#define TI83P_ckop1c0	  (0x4225)
#define TI83P_ckop1cplx	  (0x40fc)
#define TI83P_ckop1fp0	  (0x4228)
#define TI83P_ckop1pos	  (0x4258)
#define TI83P_ckop1real	  (0x40ff)
#define TI83P_ckop2fp0	  (0x422b)
#define TI83P_ckop2pos	  (0x4255)
#define TI83P_ckop2real	  (0x42df)
#define TI83P_ckposint	  (0x4231)
#define TI83P_ckvalidnum	  (0x4270)
#define TI83P_cleanall	  (0x4a50)
#define TI83P_clearrect	  (0x4d5c)
#define TI83P_clearrow	  (0x4ced)
#define TI83P_cline		  (0x4798)
#define TI83P_clines		  (0x479b)
#define TI83P_cln		  (0x4ea0)
#define TI83P_clog		  (0x4ea3)
#define TI83P_closeeditbufnor	  (0x476e)
#define TI83P_closeprog	  (0x4a35)
#define TI83P_clrgraphref	  (0x4a38)
#define TI83P_clrlcd		  (0x4543)
#define TI83P_clrlcdfull	  (0x4540)
#define TI83P_clrlp		  (0x41d1)
#define TI83P_clrop1s	  (0x425e)
#define TI83P_clrop2s	  (0x425b)
#define TI83P_clrscrn	  (0x4549)
#define TI83P_clrscrnfull	  (0x4546)
#define TI83P_clrtxtshd	  (0x454c)
#define TI83P_cmltbyreal	  (0x4eb8)
#define TI83P_cmpsyms	  (0x4a4a)
#define TI83P_cmult		  (0x4e8e)
#define TI83P_conj		  (0x4eb5)
#define TI83P_convdim	  (0x4b43)
#define TI83P_convdim00	  (0x4b46)
#define TI83P_convlctolr	  (0x4a23)
#define TI83P_convlrtolc	  (0x4a56)
#define TI83P_convop1	  (0x4aef)
#define TI83P_cop1set0	  (0x4105)
#define TI83P_cos		  (0x40c0)
#define TI83P_cosh		  (0x40cc)
#define TI83P_cphlde		  (0x400c)
#define TI83P_cpoint		  (0x4dc8)
#define TI83P_cpoints	  (0x47f5)
#define TI83P_cpop1op2	  (0x4111)
#define TI83P_cpop4op3	  (0x4108)
#define TI83P_cpyo1tofps1	  (0x445c)
#define TI83P_cpyo1tofps2	  (0x446b)
#define TI83P_cpyo1tofps3	  (0x4477)
#define TI83P_cpyo1tofps4	  (0x4489)
#define TI83P_cpyo1tofps5	  (0x4483)
#define TI83P_cpyo1tofps6	  (0x447d)
#define TI83P_cpyo1tofps7	  (0x4480)
#define TI83P_cpyo1tofpst	  (0x444a)
#define TI83P_cpyo2tofps1	  (0x4459)
#define TI83P_cpyo2tofps2	  (0x4462)
#define TI83P_cpyo2tofps3	  (0x4474)
#define TI83P_cpyo2tofps4	  (0x4486)
#define TI83P_cpyo2tofpst	  (0x4444)
#define TI83P_cpyo3tofps1	  (0x4453)
#define TI83P_cpyo3tofps2	  (0x4465)
#define TI83P_cpyo3tofpst	  (0x4441)
#define TI83P_cpyo5tofps1	  (0x4456)
#define TI83P_cpyo5tofps3	  (0x4471)
#define TI83P_cpyo6tofps2	  (0x4468)
#define TI83P_cpyo6tofpst	  (0x4447)
#define TI83P_cpystack	  (0x4429)
#define TI83P_cpyto1fps1	  (0x4432)
#define TI83P_cpyto1fps10	  (0x43f3)
#define TI83P_cpyto1fps11	  (0x43d8)
#define TI83P_cpyto1fps2	  (0x443b)
#define TI83P_cpyto1fps3	  (0x4408)
#define TI83P_cpyto1fps4	  (0x440e)
#define TI83P_cpyto1fps5	  (0x43de)
#define TI83P_cpyto1fps6	  (0x43e4)
#define TI83P_cpyto1fps7	  (0x43ea)
#define TI83P_cpyto1fps8	  (0x43ed)
#define TI83P_cpyto1fps9	  (0x43f6)
#define TI83P_cpyto1fpst	  (0x4423)
#define TI83P_cpyto2fps1	  (0x442f)
#define TI83P_cpyto2fps2	  (0x4438)
#define TI83P_cpyto2fps3	  (0x4402)
#define TI83P_cpyto2fps4	  (0x43f9)
#define TI83P_cpyto2fps5	  (0x43db)
#define TI83P_cpyto2fps6	  (0x43e1)
#define TI83P_cpyto2fps7	  (0x43e7)
#define TI83P_cpyto2fps8	  (0x43f0)
#define TI83P_cpyto2fpst	  (0x4420)
#define TI83P_cpyto3fps1	  (0x442c)
#define TI83P_cpyto3fps2	  (0x4411)
#define TI83P_cpyto3fpst	  (0x441d)
#define TI83P_cpyto4fpst	  (0x441a)
#define TI83P_cpyto5fpst	  (0x4414)
#define TI83P_cpyto6fps2	  (0x43ff)
#define TI83P_cpyto6fps3	  (0x43fc)
#define TI83P_cpyto6fpst	  (0x4417)
#define TI83P_cpytofps1	  (0x445f)
#define TI83P_cpytofps2	  (0x446e)
#define TI83P_cpytofps3	  (0x447a)
#define TI83P_cpytofpst	  (0x444d)
#define TI83P_cpytostack	  (0x4450)
#define TI83P_create0equ	  (0x432a)
#define TI83P_createappvar	  (0x4e6a)
#define TI83P_createclist	  (0x431b)
#define TI83P_createcplx	  (0x430c)
#define TI83P_createequ	  (0x4330)
#define TI83P_createpair	  (0x4b0d)
#define TI83P_createpict	  (0x4333)
#define TI83P_createprog	  (0x4339)
#define TI83P_createprotprog	  (0x4e6d)
#define TI83P_createreal	  (0x430f)
#define TI83P_createrlist	  (0x4315)
#define TI83P_creatermat	  (0x4321)
#define TI83P_createstrng	  (0x4327)
#define TI83P_crecip		  (0x4e91)
#define TI83P_csqroot	  (0x4e9d)
#define TI83P_csquare	  (0x4e8b)
#define TI83P_csub		  (0x4e85)
#define TI83P_ctenx		  (0x4ea6)
#define TI83P_ctrunc		  (0x4ebe)
#define TI83P_cube		  (0x407b)
#define TI83P_cursoroff	  (0x45be)
#define TI83P_cursoron	  (0x45c4)
#define TI83P_cxrooty	  (0x4eac)
#define TI83P_cytox		  (0x4eb2)

#define TI83P_darkline	  (0x47dd)
#define TI83P_darkpnt	  (0x47f2)
#define TI83P_datasize	  (0x436c)
#define TI83P_datasizea	  (0x4369)
#define TI83P_deallocfps	  (0x439f)
#define TI83P_deallocfps1	  (0x43a2)
#define TI83P_deco1exp	  (0x4267)
#define TI83P_dellistel	  (0x4a2f)
#define TI83P_delmem		  (0x4357)
#define TI83P_delres		  (0x4a20)
#define TI83P_delvar		  (0x4351)
#define TI83P_delvararc	  (0x4fc6)
#define TI83P_delvarnoarc	  (0x4fc9)
#define TI83P_disableapd	  (0x4c84)
#define TI83P_disp		  (0x4f45)
#define TI83P_dispdone	  (0x45b5)
#define TI83P_dispeol	  (0x45a6)
#define TI83P_disphl		  (0x4507)
#define TI83P_displayimage	  (0x4d9b)
#define TI83P_dispop1a	  (0x4bf7)
#define TI83P_divhlby10	  (0x400f)
#define TI83P_divhlbya	  (0x4012)
#define TI83P_drawcirc2	  (0x4c66)
#define TI83P_drawcmd	  (0x48c1)
#define TI83P_drawrectborder	  (0x4d7d)
#define TI83P_drawrectborderclear	  (0x4d8c)
#define TI83P_dtor		  (0x4075)

#define TI83P_editprog	  (0x4a32)
#define TI83P_enableapd	  (0x4c87)
#define TI83P_enoughmem	  (0x42fd)
#define TI83P_eop1notreal	  (0x4279)
#define TI83P_equ_or_newequ	  (0x42c4)
#define TI83P_eraseeol	  (0x4552)
#define TI83P_eraserectborder	  (0x4d86)
#define TI83P_errargument	  (0x44ad)
#define TI83P_errbadguess	  (0x44cb)
#define TI83P_errbreak	  (0x44bf)
#define TI83P_errd_op1_0	  (0x42d3)
#define TI83P_errd_op1_le_0	  (0x42d0)
#define TI83P_errd_op1not_r	  (0x42ca)
#define TI83P_errd_op1notpos	  (0x42c7)
#define TI83P_errd_op1notposint	  (0x42cd)


#define TI83P_errdatatype	  (0x44aa)
#define TI83P_errdimension	  (0x44b3)
#define TI83P_errdimmismatch	  (0x44b0)
#define TI83P_errdivby0	  (0x4498)
#define TI83P_errdomain	  (0x449e)
#define TI83P_errincrement	  (0x44a1)
#define TI83P_errinvalid	  (0x44bc)
#define TI83P_erriterations	  (0x44c8)
#define TI83P_errlinkxmit	  (0x44d4)
#define TI83P_errmemory	  (0x44b9)
#define TI83P_errnon_real	  (0x44a4)
#define TI83P_errnonreal	  (0x4a8c)
#define TI83P_errnotenoughmem	  (0x448c)
#define TI83P_erroverflow	  (0x4495)
#define TI83P_errsignchange	  (0x44c5)
#define TI83P_errsingularmat	  (0x449b)
#define TI83P_errstat	  (0x44c2)
#define TI83P_errstatplot	  (0x44d1)
#define TI83P_errsyntax	  (0x44a7)
#define TI83P_errtoltoosmall	  (0x44ce)
#define TI83P_errundefined	  (0x44b6)
#define TI83P_etox		  (0x40b4)
#define TI83P_exch9		  (0x43d5)
#define TI83P_exlp		  (0x4222)
#define TI83P_exptohex	  (0x424f)

#define TI83P_factorial	  (0x4b85)
#define TI83P_fillrect	  (0x4d62)
#define TI83P_fillrectpattern	  (0x4d89)
#define TI83P_find_parse_formula	  (0x4af2)
#define TI83P_findalphadn	  (0x4a47)
#define TI83P_findalphaup	  (0x4a44)
#define TI83P_findapp		  (0x4c4e)
#define TI83P_findappdn		  (0x4c4b)
#define TI83P_findappnumpages	  (0x509b)
#define TI83P_findappup		  (0x4c48)
#define TI83P_findsym	  (0x42f4)
#define TI83P_fiveexec	  (0x467e)
#define TI83P_fixtempcnt	  (0x4a3b)
#define TI83P_flashtoram	  (0x5017)
#define TI83P_forcefullscreen	  (0x508f)
#define TI83P_formbase	  (0x50aa)
#define TI83P_formdcplx	  (0x4996)
#define TI83P_formereal	  (0x4990)
#define TI83P_formreal	  (0x4999)
#define TI83P_fourexec	  (0x467b)
#define TI83P_fpadd		  (0x4072)
#define TI83P_fpdiv		  (0x4099)
#define TI83P_fpmult		  (0x4084)
#define TI83P_fprecip	  (0x4096)
#define TI83P_fpsquare	  (0x4081)
#define TI83P_fpsub		  (0x406f)
#define TI83P_frac		  (0x4093)

#define TI83P_getbasever	  (0x4c6f)
#define TI83P_getcsc		  (0x4018)
#define TI83P_homeup		  (0x4775)
#define TI83P_getkey		  (0x4972)
#define TI83P_getltoop1	  (0x4636)
#define TI83P_getmtoop1	  (0x4615)
#define TI83P_gettoklen	  (0x4591)
#define TI83P_grbufclr	  (0x4bd0)
#define TI83P_grbufcpy	  (0x486a)
#define TI83P_grphcirc	  (0x47d7)

#define TI83P_hltimes9	  (0x40f9)
#define TI83P_horizcmd	  (0x48a6)
#define TI83P_htimesl	  (0x4276)

#define TI83P_ibounds	  (0x4c60)
#define TI83P_iboundsfull	  (0x4d98)
#define TI83P_iline		  (0x47e0)
#define TI83P_inclstsize	  (0x4a29)
#define TI83P_insertlist	  (0x4a2c)
#define TI83P_insertmem	  (0x42f7)
#define TI83P_int		  (0x40a5)
#define TI83P_intgr		  (0x405d)
#define TI83P_invcmd		  (0x48c7)
#define TI83P_invertrect	  (0x4d5f)
#define TI83P_invop1s	  (0x408d)
#define TI83P_invop1sc	  (0x408a)
#define TI83P_invop2s	  (0x4090)
#define TI83P_invsub		  (0x4063)
#define TI83P_ioffset	  (0x4c63)
#define TI83P_ipoint		  (0x47e3)

#define TI83P_jerror		  (0x44d7)
#define TI83P_jerrorno	  (0x4000)
#define TI83P_jforcecmdnochar	  (0x4027)
#define TI83P_jforcegraphkey	  (0x5005)
#define TI83P_jforcegraphnokey	  (0x5002)

#define TI83P_keytostring	  (0x45ca)

#define TI83P_linecmd	  (0x48ac)
#define TI83P_lnx		  (0x40ab)
#define TI83P_load_sfont	  (0x4783)
#define TI83P_loadcindpaged	  (0x501d)
#define TI83P_loaddeindpaged	  (0x501a)
#define TI83P_loadpattern	  (0x4cb1)
#define TI83P_logx		  (0x40ae)

#define TI83P_max		  (0x4057)
#define TI83P_memchk		  (0x42e5)
#define TI83P_memclear	  (0x4c30)
#define TI83P_memset		  (0x4c33)
#define TI83P_min		  (0x4054)
#define TI83P_minus1		  (0x406c)
#define TI83P_mov10b		  (0x415c)
#define TI83P_mov18b		  (0x47da)
#define TI83P_mov7b		  (0x4168)
#define TI83P_mov8b		  (0x4165)
#define TI83P_mov9b		  (0x415f)
#define TI83P_mov9op1op2	  (0x417d)
#define TI83P_mov9op2cp	  (0x410b)
#define TI83P_mov9toop1	  (0x417a)
#define TI83P_mov9toop2	  (0x4180)
#define TI83P_movfrop1	  (0x4183)

#define TI83P_onevar		  (0x4ba3)
#define TI83P_op1exop2	  (0x421f)
#define TI83P_op1exop3	  (0x4219)
#define TI83P_op1exop4	  (0x421c)
#define TI83P_op1exop5	  (0x420d)
#define TI83P_op1exop6	  (0x4210)
#define TI83P_op1exptodec	  (0x4252)
#define TI83P_op1set0	  (0x41bf)
#define TI83P_op1set1	  (0x419b)
#define TI83P_op1set2	  (0x41a7)
#define TI83P_op1set3	  (0x41a1)
#define TI83P_op1set4	  (0x419e)
#define TI83P_op1toop2	  (0x412f)
#define TI83P_op1toop3	  (0x4123)
#define TI83P_op1toop4	  (0x4117)
#define TI83P_op1toop5	  (0x4153)
#define TI83P_op1toop6	  (0x4150)
#define TI83P_op2exop4	  (0x4213)
#define TI83P_op2exop5	  (0x4216)
#define TI83P_op2exop6	  (0x4207)
#define TI83P_op2set0	  (0x41bc)
#define TI83P_op2set1	  (0x41ad)
#define TI83P_op2set2	  (0x41aa)
#define TI83P_op2set3	  (0x4198)
#define TI83P_op2set4	  (0x4195)
#define TI83P_op2set5	  (0x418f)
#define TI83P_op2set60	  (0x4ab0)
#define TI83P_op2set8	  (0x418c)
#define TI83P_op2seta	  (0x4192)
#define TI83P_op2toop1	  (0x4156)
#define TI83P_op2toop3	  (0x416e)
#define TI83P_op2toop4	  (0x411a)
#define TI83P_op2toop5	  (0x414a)
#define TI83P_op2toop6	  (0x414d)
#define TI83P_op3set0	  (0x41b9)
#define TI83P_op3set1	  (0x4189)
#define TI83P_op3set2	  (0x41a4)
#define TI83P_op3toop1	  (0x413e)
#define TI83P_op3toop2	  (0x4120)
#define TI83P_op3toop4	  (0x4114)
#define TI83P_op3toop5	  (0x4147)
#define TI83P_op4set0	  (0x41b6)
#define TI83P_op4set1	  (0x4186)
#define TI83P_op4toop1	  (0x4138)
#define TI83P_op4toop2	  (0x411d)
#define TI83P_op4toop3	  (0x4171)
#define TI83P_op4toop5	  (0x4144)
#define TI83P_op4toop6	  (0x4177)
#define TI83P_op5exop6	  (0x420a)
#define TI83P_op5set0	  (0x41b3)
#define TI83P_op5toop1	  (0x413b)
#define TI83P_op5toop2	  (0x4126)
#define TI83P_op5toop3	  (0x4174)
#define TI83P_op5toop4	  (0x412c)
#define TI83P_op5toop6	  (0x4129)
#define TI83P_op6toop1	  (0x4135)
#define TI83P_op6toop2	  (0x4132)
#define TI83P_op6toop5	  (0x4141)
#define TI83P_outputexpr	  (0x4bb2)

#define TI83P_pagedget	  (0x5023)
#define TI83P_parseinp	  (0x4a9b)
#define TI83P_pdspgrph	  (0x48a3)
#define TI83P_pixeltest	  (0x48b5)
#define TI83P_plus1		  (0x4069)
#define TI83P_pointcmd	  (0x48b2)
#define TI83P_pointon	  (0x4c39)
#define TI83P_popop1		  (0x437e)
#define TI83P_popop3		  (0x437b)
#define TI83P_popop5		  (0x4378)
#define TI83P_popreal	  (0x4393)
#define TI83P_poprealo1	  (0x4390)
#define TI83P_poprealo2	  (0x438d)
#define TI83P_poprealo3	  (0x438a)
#define TI83P_poprealo4	  (0x4387)
#define TI83P_poprealo5	  (0x4384)
#define TI83P_poprealo6	  (0x4381)
#define TI83P_posno0int	  (0x422e)
#define TI83P_ptor		  (0x40f3)
#define TI83P_pushop1	  (0x43c9)
#define TI83P_pushop3	  (0x43c3)
#define TI83P_pushop5	  (0x43c0)
#define TI83P_pushreal	  (0x43bd)
#define TI83P_pushrealo1	  (0x43ba)
#define TI83P_pushrealo2	  (0x43b7)
#define TI83P_pushrealo3	  (0x43b4)
#define TI83P_pushrealo4	  (0x43b1)
#define TI83P_pushrealo5	  (0x43ae)
#define TI83P_pushrealo6	  (0x43ab)
#define TI83P_putc		  (0x4504)
#define TI83P_putmap		  (0x4501)
#define TI83P_putps		  (0x4510)
#define TI83P_puts		  (0x450a)
#define TI83P_puttokstring	  (0x4960)
#define TI83P_puttol		  (0x4645)
#define TI83P_puttomat	  (0x461e)

#define TI83P_randinit	  (0x4b7f)
#define TI83P_random		  (0x4b79)
#define TI83P_rcl_statvar	  (0x42dc)
#define TI83P_rclans		  (0x4ad7)
#define TI83P_rclgdb2	  (0x47d1)
#define TI83P_rcln		  (0x4add)
#define TI83P_rclsystok	  (0x4ae6)
#define TI83P_rclvarsym	  (0x4ae3)
#define TI83P_rclx		  (0x4ae0)
#define TI83P_rcly		  (0x4ada)
#define TI83P_rec1stbyte	  (0x4efa)
#define TI83P_rec1stbytenc	  (0x4efd)
#define TI83P_recabyteio	  (0x4f03)
#define TI83P_redimmat	  (0x4a26)
#define TI83P_regraph	  (0x488e)
#define TI83P_reloadappentryvecs	  (0x4c36)
#define TI83P_restoredisp	  (0x4870)
#define TI83P_rname		  (0x427f)
#define TI83P_rndguard	  (0x409f)
#define TI83P_rnfx		  (0x40a2)
#define TI83P_round		  (0x40a8)
#define TI83P_rtod		  (0x4078)
#define TI83P_rtop		  (0x40f6)
#define TI83P_runindicoff	  (0x4570)
#define TI83P_runindicon	  (0x456d)

#define TI83P_savedisp	  (0x4c7b)
#define TI83P_sendabyte	  (0x4ee5)
#define TI83P_setallplots	  (0x4fcc)
#define TI83P_setfuncm	  (0x4840)
#define TI83P_setnorm_vals	  (0x49fc)
#define TI83P_setparm	  (0x4849)
#define TI83P_setpolm	  (0x4846)
#define TI83P_setseqm	  (0x4843)
#define TI83P_settblgraphdraw	  (0x4c00)
#define TI83P_setuppagedptr	  (0x5020)
#define TI83P_setxxop1	  (0x478c)
#define TI83P_setxxop2	  (0x478f)
#define TI83P_setxxxxop2	  (0x4792)
#define TI83P_sfont_len	  (0x4786)
#define TI83P_sin		  (0x40bd)
#define TI83P_sincosrad	  (0x40ba)
#define TI83P_sinh		  (0x40cf)
#define TI83P_sinhcosh	  (0x40c6)
#define TI83P_sqroot		  (0x409c)
#define TI83P_srchvlstdn	  (0x4f12)
#define TI83P_srchvlstup	  (0x4f0f)
#define TI83P_sstringlength	  (0x4cb4)
#define TI83P_stmatel	  (0x4ae9)
#define TI83P_stoans		  (0x4abf)
#define TI83P_stogdb2	  (0x47ce)
#define TI83P_ston		  (0x4acb)
#define TI83P_stoother	  (0x4ad4)
#define TI83P_stor		  (0x4ac5)
#define TI83P_storand	  (0x4b7c)
#define TI83P_stosystok	  (0x4abc)
#define TI83P_stot		  (0x4ace)
#define TI83P_stotheta	  (0x4ac2)
#define TI83P_stox		  (0x4ad1)
#define TI83P_stoy		  (0x4ac8)
#define TI83P_strcopy	  (0x44e3)
#define TI83P_strlength	  (0x4c3f)

#define TI83P_tan		  (0x40c3)
#define TI83P_tanh		  (0x40c9)
#define TI83P_tanlnf		  (0x48bb)
#define TI83P_tenx		  (0x40b7)
#define TI83P_thetaname	  (0x427c)
#define TI83P_threeexec	  (0x4675)
#define TI83P_times2		  (0x4066)
#define TI83P_timespt5	  (0x407e)
#define TI83P_tname		  (0x428e)
#define TI83P_tofrac		  (0x4657)
#define TI83P_trunc		  (0x4060)

#define TI83P_uclines	  (0x4795)
#define TI83P_unlinecmd	  (0x48af)
#define TI83P_unopexec	  (0x4672)

#define TI83P_vertcmd	  (0x48a9)
#define TI83P_vputmap	  (0x455e)
#define TI83P_vputs		  (0x4561)
#define TI83P_vputsn		  (0x4564)
#define TI83P_vtowhlde	  (0x47fb)


#define TI83P_xftoi		  (0x4804)
#define TI83P_xitof		  (0x47fe)
#define TI83P_xname		  (0x4288)
#define TI83P_xrooty		  (0x479e)

#define TI83P_yftoi		  (0x4801)
#define TI83P_yname		  (0x428b)
#define TI83P_ytox		  (0x47a1)

#define TI83P_zero16d	  (0x41b0)
#define TI83P_zeroop		  (0x41ce)
#define TI83P_zeroop1	  (0x41c5)
#define TI83P_zeroop2	  (0x41c8)
#define TI83P_zeroop3	  (0x41cb)
#define TI83P_zmdecml	  (0x484f)
#define TI83P_zmfit		  (0x485b)
#define TI83P_zmint		  (0x484c)
#define TI83P_zmprev		  (0x4852)
#define TI83P_zmsquare	  (0x485e)
#define TI83P_zmstats	  (0x47a4)
#define TI83P_zmtrig		  (0x4861)
#define TI83P_zmusr		  (0x4855)
#define TI83P_zoodefault	  (0x4867)
//
//= ()=====================================================================
//           system-defined ram variable address equates
//= ()=====================================================================
//

#define TI83P_ramstart               (0x8000)
#define TI83P_appdata                (0x8000)
#define TI83P_ramcode                (0x8100)
#define TI83P_ramcodeend             (0x822f)
#define TI83P_baseappbrtab           (0x8230)
#define TI83P_boottemp               (0x8251)
#define TI83P_appsearchpage          (0x82a3)
#define TI83P_tempswaparea           (0x82a5)
#define TI83P_appid                  (0x838d)
#define TI83P_ramreturndata          (0x83ed)
#define TI83P_arcinfo                (0x83ee)
#define TI83P_savedarcinfo           (0x8406)
#define TI83P_appinfo                (0x8432)
#define TI83P_appbank_jump           (0x843c)
#define TI83P_apppage                (0x843e)
#define TI83P_kbdscancode            (0x843f)
#define TI83P_kbdkey                 (0x8444)
#define TI83P_kbdgetky               (0x8445)
#define TI83P_keyextend              (0x8446)
#define TI83P_contrast               (0x8447)
#define TI83P_apdsubtimer            (0x8448)
#define TI83P_apdtimer               (0x8449)
#define TI83P_curtime                (0x844a)
#define TI83P_currow                 (0x844b)
#define TI83P_curcol                 (0x844c)
#define TI83P_curoffset              (0x844d)
#define TI83P_curunder               (0x844e)
#define TI83P_cury                   (0x844f)
#define TI83P_curtype                (0x8450)
#define TI83P_curxrow                (0x8451)
#define TI83P_prevddata              (0x8452)
#define TI83P_lfont_record           (0x845a)
#define TI83P_sfont_record           (0x8462)
#define TI83P_tokvarptr              (0x846a)
#define TI83P_toklen                 (0x846c)
#define TI83P_indicmem               (0x846e)
#define TI83P_indiccounter           (0x8476)
#define TI83P_indicbusy              (0x8477)
#define TI83P_op1                    (0x8478)
#define TI83P_op1m                   (0x847a)
#define TI83P_op2                    (0x8483)
#define TI83P_op2m                   (0x8485)
#define TI83P_op2ext                 (0x848c)
#define TI83P_op3                    (0x848e)
#define TI83P_op3m                   (0x8490)
#define TI83P_op4                    (0x8499)
#define TI83P_op4m                   (0x849b)
#define TI83P_op5                    (0x84a4)
#define TI83P_op5m                   (0x84a6)
#define TI83P_op6                    (0x84af)
#define TI83P_op6m                   (0x84b1)
#define TI83P_op6ext                 (0x84b8)
#define TI83P_progtoedit             (0x84bf)
#define TI83P_namebuff               (0x84c7)
#define TI83P_equ_edit_save          (0x84d2)
#define TI83P_imathptr1              (0x84d3)
#define TI83P_imathptr2              (0x84d5)
#define TI83P_imathptr3              (0x84d7)
#define TI83P_imathptr4              (0x84d9)
#define TI83P_imathptr5              (0x84db)
#define TI83P_chkdelptr1             (0x84dd)
#define TI83P_chkdelptr2             (0x84df)
#define TI83P_insdelptr              (0x84e1)
#define TI83P_updownptr              (0x84e3)
#define TI83P_foutdat                (0x84e5)
#define TI83P_asm_data_ptr1          (0x84eb)
#define TI83P_asm_data_ptr2          (0x84ed)
#define TI83P_asm_sym_ptr1           (0x84ef)
#define TI83P_asm_sym_ptr2           (0x84f1)
#define TI83P_asm_ram                (0x84f3)
#define TI83P_asm_ind_call           (0x8507)
#define TI83P_textshadow             (0x8508)
#define TI83P_textshadcur            (0x8588)
#define TI83P_textshadtop            (0x858a)
#define TI83P_textshadalph           (0x858b)
#define TI83P_textshadins            (0x858c)
#define TI83P_cxmain                 (0x858d)
#define TI83P_cxpputaway             (0x858f)
#define TI83P_cxputaway              (0x8591)
#define TI83P_cxredisp               (0x8593)
#define TI83P_cxerrorep              (0x8595)
#define TI83P_cxsizewind             (0x8597)
#define TI83P_cxpage                 (0x8599)
#define TI83P_cxcurapp               (0x859a)
#define TI83P_cxprev                 (0x859b)
#define TI83P_monqh                  (0x85aa)
#define TI83P_monqt                  (0x85ab)
#define TI83P_monqueue               (0x85ac)
#define TI83P_onsp                   (0x85bc)
#define TI83P_promptrow              (0x85c0)
#define TI83P_promptcol              (0x85c1)
#define TI83P_promptins              (0x85c2)
#define TI83P_promptshift            (0x85c3)
#define TI83P_promptret              (0x85c4)
#define TI83P_promptvalid            (0x85c6)
#define TI83P_prompttop              (0x85c8)
#define TI83P_promptcursor           (0x85ca)
#define TI83P_prompttail             (0x85cc)
#define TI83P_promptbtm              (0x85ce)
#define TI83P_vartype                (0x85d0)
#define TI83P_varcurrent             (0x85d1)
#define TI83P_varclass               (0x85d9)
#define TI83P_menuactive             (0x85dc)
#define TI83P_menuappdepth           (0x85dd)
#define TI83P_menucurrent            (0x85de)
#define TI83P_progcurrent            (0x85e8)
#define TI83P_usermenusa             (0x85fe)
#define TI83P_ioprompt               (0x865f)
#define TI83P_dimagewidth            (0x8660)
#define TI83P_ioflag                 (0x8670)
#define TI83P_sndrecstate            (0x8672)
#define TI83P_ioerrstate             (0x8673)
#define TI83P_header                 (0x8674)
#define TI83P_iodata                 (0x867d)
#define TI83P_ionewdata              (0x8689)
#define TI83P_bakheader              (0x868b)
#define TI83P_pencol                 (0x86d7)
#define TI83P_penrow                 (0x86d8)
#define TI83P_rclqueue               (0x86d9)
#define TI83P_rclqueueend            (0x86db)
#define TI83P_errno                  (0x86dd)
#define TI83P_errsp                  (0x86de)
#define TI83P_erroffset              (0x86e0)
#define TI83P_savesscreen            (0x86ec)
#define TI83P_bstcounter             (0x89ee)
#define TI83P_flags                  (0x89f0)
#define TI83P_statvars               (0x8a3a)
#define TI83P_anovaf_vars            (0x8c17)
#define TI83P_infvars                (0x8c4d)
#define TI83P_curgstyle              (0x8d17)
#define TI83P_curgy                  (0x8d18)
#define TI83P_curgx                  (0x8d19)
#define TI83P_curgy2                 (0x8d1a)
#define TI83P_curgx2                 (0x8d1b)
#define TI83P_freesavey              (0x8d1c)
#define TI83P_freesavex              (0x8d1d)
#define TI83P_xoffset                (0x8da1)
#define TI83P_yoffset                (0x8da2)
#define TI83P_lcdtallp               (0x8da3)
#define TI83P_pixwidep               (0x8da4)
#define TI83P_pixwide_m_1            (0x8da5)
#define TI83P_pixwide_m_2            (0x8da6)
#define TI83P_lastentryptr           (0x8da7)
#define TI83P_lastentrystk           (0x8da9)
#define TI83P_numlastentries         (0x8e29)
#define TI83P_currlastentry          (0x8e2a)
#define TI83P_curinc                 (0x8e67)
#define TI83P_uxmin                  (0x8e7e)
#define TI83P_uxmax                  (0x8e87)
#define TI83P_uxscl                  (0x8e90)
#define TI83P_uymin                  (0x8e99)
#define TI83P_uymax                  (0x8ea2)
#define TI83P_uyscl                  (0x8eab)
#define TI83P_uthetmin               (0x8eb4)
#define TI83P_uthetmax               (0x8ebd)
#define TI83P_uthetstep              (0x8ec6)
#define TI83P_utmin                  (0x8ecf)
#define TI83P_utmax                  (0x8ed8)
#define TI83P_utstep                 (0x8ee1)
#define TI83P_uplotstart             (0x8eea)
#define TI83P_unmax                  (0x8ef3)
#define TI83P_uu0                    (0x8efc)
#define TI83P_uv0                    (0x8f05)
#define TI83P_unmin                  (0x8f0e)
#define TI83P_uu02                   (0x8f17)
#define TI83P_uv02                   (0x8f20)
#define TI83P_uw0                    (0x8f29)
#define TI83P_uplotstep              (0x8f32)
#define TI83P_uxres                  (0x8f3b)
#define TI83P_uw02                   (0x8f44)
#define TI83P_xmin                   (0x8f50)
#define TI83P_xmax                   (0x8f59)
#define TI83P_xscl                   (0x8f62)
#define TI83P_ymin                   (0x8f6b)
#define TI83P_ymax                   (0x8f74)
#define TI83P_yscl                   (0x8f7d)
#define TI83P_thetamin               (0x8f86)
#define TI83P_thetamax               (0x8f8f)
#define TI83P_thetastep              (0x8f98)
#define TI83P_tminpar                (0x8fa1)
#define TI83P_tmaxpar                (0x8faa)
#define TI83P_tstep                  (0x8fb3)
#define TI83P_plotstart              (0x8fbc)
#define TI83P_nmax                   (0x8fc5)
#define TI83P_u0                     (0x8fce)
#define TI83P_v0                     (0x8fd7)
#define TI83P_nmin                   (0x8fe0)
#define TI83P_u02                    (0x8fe9)
#define TI83P_v02                    (0x8ff2)
#define TI83P_w0                     (0x8ffb)
#define TI83P_plotstep               (0x9004)
#define TI83P_xreso                  (0x900d)
#define TI83P_w02                    (0x9016)
#define TI83P_un1                    (0x901f)
#define TI83P_un2                    (0x9028)
#define TI83P_vn1                    (0x9031)
#define TI83P_vn2                    (0x903a)
#define TI83P_wn1                    (0x9043)
#define TI83P_wn2                    (0x904c)
#define TI83P_fin_n                  (0x9055)
#define TI83P_fin_i                  (0x905e)
#define TI83P_fin_pv                 (0x9067)
#define TI83P_fin_pmt                (0x9070)
#define TI83P_fin_fv                 (0x9079)
#define TI83P_fin_py                 (0x9082)
#define TI83P_fin_cy                 (0x908b)
#define TI83P_cal_n                  (0x9094)
#define TI83P_cal_i                  (0x909d)
#define TI83P_cal_pv                 (0x90a6)
#define TI83P_cal_pmt                (0x90af)
#define TI83P_cal_fv                 (0x90b8)
#define TI83P_cal_py                 (0x90c1)
#define TI83P_smalleditram           (0x90d3)
#define TI83P_xfact                  (0x913f)
#define TI83P_yfact                  (0x9148)
#define TI83P_xres_int               (0x9151)
#define TI83P_deltax                 (0x9152)
#define TI83P_deltay                 (0x915b)
#define TI83P_shortx                 (0x9164)
#define TI83P_shorty                 (0x916d)
#define TI83P_lower                  (0x9176)
#define TI83P_upper                  (0x917f)
#define TI83P_xoutsym                (0x918c)
#define TI83P_xoutdat                (0x918e)
#define TI83P_youtsym                (0x9190)
#define TI83P_youtdat                (0x9192)
#define TI83P_inputsym               (0x9194)
#define TI83P_inputdat               (0x9196)
#define TI83P_prevdata               (0x9198)
#define TI83P_tblmin                 (0x92b3)
#define TI83P_tblstep                (0x92bc)
#define TI83P_plotsscreen            (0x9340)
#define TI83P_seed1                  (0x9640)
#define TI83P_seed2                  (0x9649)
#define TI83P_cmdshadow              (0x966e)
#define TI83P_cmdshadcur             (0x96ee)
#define TI83P_cmdshadalph            (0x96f0)
#define TI83P_cmdshadins             (0x96f1)
#define TI83P_cmdcursor              (0x96f2)
#define TI83P_edittop                (0x96f4)
#define TI83P_editcursor             (0x96f6)
#define TI83P_edittail               (0x96f8)
#define TI83P_editbtm                (0x96fa)
#define TI83P_editsym                (0x9706)
#define TI83P_editdat                (0x9708)
#define TI83P_wintop                 (0x97a5)
#define TI83P_winbtm                 (0x97a6)
#define TI83P_winleftedge            (0x97a7)
#define TI83P_winleft                (0x97a8)
#define TI83P_winabove               (0x97aa)
#define TI83P_winrow                 (0x97ac)
#define TI83P_wincol                 (0x97ae)
#define TI83P_fmtdigits              (0x97b0)
#define TI83P_fmtstring              (0x97b1)
#define TI83P_fmtconv                (0x97f2)
#define TI83P_fmtleft                (0x9804)
#define TI83P_fmtindex               (0x9806)
#define TI83P_fmtmatsym              (0x9808)
#define TI83P_fmtmatmem              (0x980a)
#define TI83P_eqs                    (0x980c)
#define TI83P_tsymptr1               (0x9818)
#define TI83P_tsymptr2               (0x981a)
#define TI83P_chkdelptr3             (0x981c)
#define TI83P_chkdelptr4             (0x981e)
#define TI83P_tempmem                (0x9820)
#define TI83P_fpbase                 (0x9822)
#define TI83P_fps                    (0x9824)
#define TI83P_opbase                 (0x9826)
#define TI83P_ops                    (0x9828)
#define TI83P_ptempcnt               (0x982a)
#define TI83P_cleantmp               (0x982c)
#define TI83P_ptemp                  (0x982e)
#define TI83P_progptr                (0x9830)
#define TI83P_newdataptr             (0x9832)
#define TI83P_pagedcount             (0x9834)
#define TI83P_pagedpn                (0x9835)
#define TI83P_pagedgetptr            (0x9836)
#define TI83P_pagedputptr            (0x9838)
#define TI83P_pagedbuf               (0x983a)
#define TI83P_apperr1                (0x984d)
#define TI83P_apperr2                (0x985a)
#define TI83P_flashbyte1             (0x9867)
#define TI83P_flashbyte2             (0x9868)
#define TI83P_freearcblock           (0x9869)
#define TI83P_arcpage                (0x986b)
#define TI83P_arcptr                 (0x986c)
#define TI83P_apprawkeyhandle        (0x9870)
#define TI83P_appbackupscreen        (0x9872)
#define TI83P_customheight           (0x9b72)
#define TI83P_locallanguage          (0x9b73)
#define TI83P_cursorhookptr          (0x9b7c)
#define TI83P_rawkeyhookptr          (0x9b84)
#define TI83P_getkeyhookptr          (0x9b88)
#define TI83P_fonthookptr            (0x9b9c)
#define TI83P_restartclr             (0x9bd0)
#define TI83P_localtokstr            (0x9d65)
#define TI83P_keyforstr              (0x9d76)
#define TI83P_keytostrram            (0x9d77)
#define TI83P_sedmonsp               (0x9d88)
#define TI83P_bpsave                 (0x9d8a)
#define TI83P_usermem                (0x9d95)
#define TI83P_symtable               (0x0fe66)

//symbolic_debug_end
//
//= ()=====================================================================
//           error handler equates/macros 
//= ()=====================================================================
//
#define TI83P_app_push_errorh   (0x59)
#define TI83P_app_pop_errorh   (0x5c)
//

//
//= ()=====================================================================
//           system and state flags
//= ()=====================================================================
//

#define TI83P_trigflags  (0)//trigonometry mode settings
#define TI83P_trigdeg   (2)// 1= TI83P_degrees, 0=radians

#define TI83P_kbdflags  (0)//keyboard scan
#define TI83P_kbdscr	  (3)// 1= TI83P_scan code ready
#define TI83P_kbdkeypress  (4)// 1= TI83P_key has been pressed

#define TI83P_doneflags  (0)//display "done"
#define TI83P_doneprgm  (5)// 1= TI83P_display "done" after prgm

#define TI83P_iodelflag  (0)
#define TI83P_indelete  (0)//1 = TI83P_delete screen 

//----------------------------------------------------------------------
#define TI83P_editflags  (1)
#define TI83P_editopen  (2)// 1= TI83P_edit buffer is open

#define TI83P_monflags  (1)//monitor flags
#define TI83P_monabandon  (4)// 1= TI83P_don''t start any long process
//			| in put away (#715)
//----------------------------------------------------------------------
#define TI83P_plotflags  (2)//plot generation flags
#define TI83P_plotloc   (1)// 0= TI83P_bkup & display, 1=display only
#define TI83P_plotdisp  (2)// 1= TI83P_plot is in display, 0=text in display


#define TI83P_grfmodeflags  (2)//graph mode settings
#define TI83P_grffuncm  (4)// 1= TI83P_function graph
#define TI83P_grfpolarm  (5)// 1= TI83P_polar graph
#define TI83P_grfparamm  (6)// 1= TI83P_parametric graph
#define TI83P_grfrecurm         (7)// 1= TI83P_recursion graph

#define TI83P_graphflags  (3)
#define TI83P_graphdraw  (0)// 0= TI83P_graph is valid, 1=redraw graph

#define TI83P_grfdbflags  (4)
#define TI83P_grfdot	  (0)// 0= TI83P_line, 1=dot
#define TI83P_grfsimul  (1)// 0= TI83P_sequential, 1=simultaneous
#define TI83P_grfgrid   (2)// 0= TI83P_no grid, 1=grid
#define TI83P_grfpolar  (3)// 0= TI83P_rectangular, 1=polar coordinates
#define TI83P_grfnocoord  (4)// 0= TI83P_display coordinates, 1=off
#define TI83P_grfnoaxis  (5)// 0= TI83P_axis, 1=no axis
#define TI83P_grflabel  (6)// 0= TI83P_off, 1=axis label

#define TI83P_textflags  (5)//text output flags
#define TI83P_texterasebelow  (1)// 1= TI83P_erase line below small char
#define TI83P_textscrolled  (2)// 1= TI83P_screen scrolled
#define TI83P_textinverse  (3)// 1= TI83P_display inverse bit-map
#define TI83P_textinsmode  (4)// 0= TI83P_overstrike, 1=insert mode

#define TI83P_parsflag2  (7)//parser flags
#define TI83P_numop1	  (0)// 1= TI83P_result in op1, 0=no result

#define TI83P_newdispf          (8)//derivative mode flags
#define TI83P_preclrformode     (0)// 1= TI83P_help blink on mode screen

#define TI83P_apdflags  (8)//automatic power-down
#define TI83P_apdable   (2)// 1= TI83P_apd enabled
#define TI83P_apdrunning  (3)// 1= TI83P_apd clock running


#define TI83P_web_err_mask      (0x60)

#define TI83P_onflags   (9)//on key flags
#define TI83P_oninterrupt  (4)// 1= TI83P_on key interrupt request

#define TI83P_statflags  (9)//statistics flags
#define TI83P_statsvalid  (6)// 1= TI83P_stats are valid

#define TI83P_fmtflags  (10)//numeric format flags
#define TI83P_fmtexponent  (0)// 1= TI83P_show exponent, 0=no exponent
#define TI83P_fmteng	  (1)// 1= TI83P_engineering notion, 0=scientific
#define TI83P_fmthex	  (2)// 1= TI83P_hexadecimal
#define TI83P_fmtoct	  (3)// 1= TI83P_octal
#define TI83P_fmtbin	  (4)// 1= TI83P_binary
//
#define TI83P_nummode           (10)
#define TI83P_fmtreal           (5)
#define TI83P_fmtrect           (6)
#define TI83P_fmtpolar          (7)

#define TI83P_realmode          (5)
#define TI83P_rectmode          (6)
#define TI83P_polarmode         (7)
//					;   if hex and oct both = (1)
//					;   then bin= (0 means >frac)
//					;	 bin= (1 means >dms)
//TI83P_fmtbasemask     = (00011100b)| mask to base flags
#define TI83P_fmtbaseshift      (2)// offset to base flags
//
//       check if these are used by numform,
//
//               = (6)
//               = (7)

#define TI83P_fmtoverride  (11)//copy of fmtflags with conversion override

#define TI83P_fmteditflags  (12)//numeric editing flags
#define TI83P_fmtedit   (0)// 1= TI83P_format number for editing

#define TI83P_curflags  (12)//cursor
#define TI83P_curable   (2)// 1= TI83P_cursor flash is enabled
#define TI83P_curon	  (3)// 1= TI83P_cursor is showing
#define TI83P_curlock   (4)// 1= TI83P_cursor is locked off

#define TI83P_appflags  (13)//application flags
#define TI83P_appwantintrpt  (0)// 1= TI83P_want on key interrupts
#define TI83P_apptextsave  (1)// 1= TI83P_save characters in textshadow
#define TI83P_appautoscroll  (2)// 1= TI83P_auto-scroll text on last line
#define TI83P_appmenus  (3)// 1= TI83P_process keys that bring up menus
//TI83P_					| 0= (TI83P_check lock menu flag)
#define TI83P_applockmenus  (4)// 1= TI83P_ignore menu keys
//TI83P_					| 0= (TI83P_switch to home screen and bring up menu)
#define TI83P_appcurgraphic  (5)// 1= TI83P_graphic cursor
#define TI83P_appcurword  (6)// 1= TI83P_text cursor covers entire word
#define TI83P_appexit   (7)// 1= TI83P_application handles [exit] key itself



#define TI83P_seqflags          (15)// sequential graph flags
#define TI83P_webmode           (0)// 0 = TI83P_normal seq mode, 1 = web mode
#define TI83P_webvert           (1)//
#define TI83P_sequv             (2)// u vs v
#define TI83P_seqvw             (3)// v vs w
#define TI83P_sequw             (4)// u vs w


#define TI83P_promptflags  (17)//prompt line flags
#define TI83P_promptedit  (0)// 1= TI83P_editing in prompt buffer

#define TI83P_indicflags  (18)//indicator flags
#define TI83P_indicrun  (0)// 1= TI83P_run indicator on
#define TI83P_indicinuse  (1)// indicator save area in use=1, free=0
#define TI83P_indiconly  (2)// interrupt handler only checks run indicator

#define TI83P_shiftflags  (18)//[2nd] and [alpha] flags
#define TI83P_shift2nd  (3)// 1= TI83P_[2nd] has been pressed
#define TI83P_shiftalpha  (4)// 1= TI83P_[alpha] has been pressed
#define TI83P_shiftlwralph  (5)// 1= TI83P_lower case, 0=upper case
#define TI83P_shiftalock  (6)// 1= TI83P_alpha lock has been pressed
#define TI83P_shiftkeepalph  (7)// 1= TI83P_cannot cancel alpha shift


#define TI83P_tblflags          (19)//table flags.
#define TI83P_autofill          (4)// 1= TI83P_prompt, 0=fillauto
#define TI83P_autocalc          (5)// 1= TI83P_prompt, 0=calcauto
#define TI83P_retable           (6)// 0= TI83P_table is ok, 1=must recompute table.

#define TI83P_sgrflags  (20)
#define TI83P_grfsplit          (0)// 1= TI83P_split graph, 0=normal
#define TI83P_vertsplit         (1)// 1= TI83P_vertical (left-right) split
#define TI83P_grfschanged       (2)// 1= TI83P_graph just changed split <-> normal
#define TI83P_grfsplitoverride   (3)// 1 = TI83P_ignore graph split flag if set
#define TI83P_write_on_graph    (4)// 1 = TI83P_text or=writing to graph screen
#define TI83P_g_style_active    (5)// 1 = TI83P_graph styles are enabled, use them
#define TI83P_cmp_mod_box       (6)// 1 = TI83P_doing mod box plot computation
#define TI83P_textwrite         (7)
//

#define TI83P_newindicflags     (21)
#define TI83P_extraindic        (0)
#define TI83P_saindic           (1)

#define TI83P_smartflags        (23)
//
//----------------------------------------------------------------------
// note: fix these equates if smartflags are moved                            
//----------------------------------------------------------------------
//
#define TI83P_smarter_mask      (3)
#define TI83P_smarter_test      (1)
#define TI83P_smartgraph        (0)
#define TI83P_smartgraph_inv    (1)

//----------------------------------------------------------------------
//           available for asm programming
//----------------------------------------------------------------------

#define TI83P_asm_flag1         (33)// asm coding
#define TI83P_asm_flag2         (34)// asm coding
#define TI83P_asm_flag3         (35)// asm coding

//----------------------------------------------------------------------
//
#define TI83P_getsendflg  (36)
#define TI83P_comfailed  (1)// 1 = TI83P_get/send communication failed
//
#define TI83P_applwrcaseflag    (36)
#define TI83P_lwrcaseactive     (3)
//
#define TI83P_apiflg3	  (42)
//
#define TI83P_apiflg4	  (43)
#define TI83P_fullscrndraw  (2)// draw into last row/col of screen

#define TI83P_groupflags  (38)
#define TI83P_ingroup	  (1)//1 = TI83P_in group context


#define TI83P_xapflag0          (46)// external app flags
#define TI83P_xapflag1          (47)
#define TI83P_xapflag2          (48)
#define TI83P_xapflag3          (49)

#define TI83P_fontflags  (50)
#define TI83P_fracdrawlfont  (2)
#define TI83P_fractalllfont  (3)
#define TI83P_customfont  (7)

#define TI83P_plotflag3  (60)
#define TI83P_bufferonly  (0)
#define TI83P_usefastcirc  (4)

//
#define TI83P_vartypemask  (0x1f)
#define TI83P_vargraphref  (6)

//
//= ()=====================================================================
//           character font equates  
//= ()=====================================================================
//
#define TI83P_lrecurn           (0x001)
#define TI83P_lrecuru    (0x002)
#define TI83P_lrecurv    (0x003)
#define TI83P_lrecurw	   (0x004)
#define TI83P_lconvert   (0x005)
#define TI83P_lsqup	   (0x006)
#define TI83P_lsqdown	   (0x007)
#define TI83P_lintegral   (0x008)
#define TI83P_lcross	   (0x009)
#define TI83P_lboxicon   (0x00a)
#define TI83P_lcrossicon   (0x00b)
#define TI83P_ldoticon   (0x00c)
#define TI83P_lsubt     (0x00d)//small capital t for parametric mode.
#define TI83P_lcuber    (0x00e)//slightly different 3 for cubed root.
#define TI83P_lhexf	   (0x00f)
#define TI83P_lroot	   (0x010)
#define TI83P_linverse   (0x011)
#define TI83P_lsquare	   (0x012)
#define TI83P_langle	   (0x013)
#define TI83P_ldegree	   (0x014)
#define TI83P_lradian	   (0x015)
#define TI83P_ltranspose   (0x016)
#define TI83P_lle	   (0x017)
#define TI83P_lne	   (0x018)
#define TI83P_lge	   (0x019)
#define TI83P_lneg	   (0x01a)
#define TI83P_lexponent   (0x01b)
#define TI83P_lstore	   (0x01c)
#define TI83P_lten	   (0x01d)
#define TI83P_luparrow   (0x01e)
#define TI83P_ldownarrow   (0x01f)
#define TI83P_lspace	   (0x020)
#define TI83P_lexclam	   (0x021)
#define TI83P_lquote	   (0x022)
#define TI83P_lpound	   (0x023)
#define TI83P_lfourth	  (0x024)
#define TI83P_lpercent   (0x025)
#define TI83P_lampersand   (0x026)
#define TI83P_lapostrophe   (0x027)
#define TI83P_llparen	   (0x028)
#define TI83P_lrparen	   (0x029)
#define TI83P_lasterisk   (0x02a)
#define TI83P_lplussign   (0x02b)
#define TI83P_lcomma	   (0x02c)
#define TI83P_ldash	   (0x02d)
#define TI83P_lperiod	   (0x02e)
#define TI83P_lslash	   (0x02f)
#define TI83P_l0	   (0x030)
#define TI83P_l1	   (0x031)
#define TI83P_l2	   (0x032)
#define TI83P_l3	   (0x033)
#define TI83P_l4	   (0x034)
#define TI83P_l5	   (0x035)
#define TI83P_l6	   (0x036)
#define TI83P_l7	   (0x037)
#define TI83P_l8	   (0x038)
#define TI83P_l9	   (0x039)
#define TI83P_lcolon	   (0x03a)
#define TI83P_lsemicolon   (0x03b)
#define TI83P_llt	   (0x03c)
#define TI83P_leq	   (0x03d)
#define TI83P_lgt	   (0x03e)
#define TI83P_lquestion   (0x03f)
#define TI83P_latsign	   (0x040)
#define TI83P_lcapa   (0x041)
#define TI83P_lcapb   (0x042)
#define TI83P_lcapc   (0x043)
#define TI83P_lcapd   (0x044)
#define TI83P_lcape   (0x045)
#define TI83P_lcapf   (0x046)
#define TI83P_lcapg   (0x047)
#define TI83P_lcaph   (0x048)
#define TI83P_lcapi   (0x049)
#define TI83P_lcapj   (0x04a)
#define TI83P_lcapk   (0x04b)
#define TI83P_lcapl   (0x04c)
#define TI83P_lcapm   (0x04d)
#define TI83P_lcapn   (0x04e)
#define TI83P_lcapo   (0x04f)
#define TI83P_lcapp   (0x050)
#define TI83P_lcapq   (0x051)
#define TI83P_lcapr   (0x052)
#define TI83P_lcaps   (0x053)
#define TI83P_lcapt   (0x054)
#define TI83P_lcapu   (0x055)
#define TI83P_lcapv   (0x056)
#define TI83P_lcapw   (0x057)
#define TI83P_lcapx   (0x058)
#define TI83P_lcapy   (0x059)
#define TI83P_lcapz   (0x05a)
#define TI83P_ltheta    (0x05b)
#define TI83P_lbackslash   (0x05c)
#define TI83P_lrbrack	   (0x05d)
#define TI83P_lcaret	   (0x05e)
#define TI83P_lunderscore   (0x05f)
#define TI83P_lbackquote   (0x060)
#define TI83P_la   (0x061)
#define TI83P_lb   (0x062)
#define TI83P_lc   (0x063)
#define TI83P_ld   (0x064)
#define TI83P_le   (0x065)
#define TI83P_lf   (0x066)
#define TI83P_lg   (0x067)
#define TI83P_lh   (0x068)
#define TI83P_li   (0x069)
#define TI83P_lj   (0x06a)
#define TI83P_lk   (0x06b)
#define TI83P_ll   (0x06c)
#define TI83P_lm   (0x06d)
#define TI83P_ln   (0x06e)
#define TI83P_lo   (0x06f)
#define TI83P_lp   (0x070)
#define TI83P_lq   (0x071)
#define TI83P_lr   (0x072)
#define TI83P_ls   (0x073)
#define TI83P_lt   (0x074)
#define TI83P_lu   (0x075)
#define TI83P_lv   (0x076)
#define TI83P_lw   (0x077)
#define TI83P_lx   (0x078)
#define TI83P_ly   (0x079)
#define TI83P_lz   (0x07a)
#define TI83P_llbrace   (0x07b)
#define TI83P_lbar   (0x07c)
#define TI83P_lrbrace   (0x07d)
#define TI83P_ltilde   (0x07e)
#define TI83P_linveq   (0x07f)
#define TI83P_lsub0   (0x080)
#define TI83P_lsub1   (0x081)
#define TI83P_lsub2   (0x082)
#define TI83P_lsub3   (0x083)
#define TI83P_lsub4   (0x084)
#define TI83P_lsub5   (0x085)
#define TI83P_lsub6   (0x086)
#define TI83P_lsub7   (0x087)
#define TI83P_lsub8   (0x088)
#define TI83P_lsub9   (0x089)
#define TI83P_lcapaacute   (0x08a)
#define TI83P_lcapagrave   (0x08b)
#define TI83P_lcapacaret   (0x08c)
#define TI83P_lcapadier   (0x08d)
#define TI83P_laacute	   (0x08e)
#define TI83P_lagrave	   (0x08f)
#define TI83P_lacaret	   (0x090)
#define TI83P_ladier	   (0x091)
#define TI83P_lcapeacute   (0x092)
#define TI83P_lcapegrave   (0x093)
#define TI83P_lcapecaret   (0x094)
#define TI83P_lcapedier   (0x095)
#define TI83P_leacute	   (0x096)
#define TI83P_legrave	   (0x097)
#define TI83P_lecaret	   (0x098)
#define TI83P_ledier	   (0x099)
#define TI83P_lcapiacute   (0x09a)
#define TI83P_lcapigrave   (0x09b)
#define TI83P_lcapicaret   (0x09c)
#define TI83P_lcapidier   (0x09d)
#define TI83P_liacute	   (0x09e)
#define TI83P_ligrave	   (0x09f)
#define TI83P_licaret	   (0x0a0)
#define TI83P_lidier	   (0x0a1)
#define TI83P_lcapoacute   (0x0a2)
#define TI83P_lcapograve   (0x0a3)
#define TI83P_lcapocaret   (0x0a4)
#define TI83P_lcapodier   (0x0a5)
#define TI83P_loacute	   (0x0a6)
#define TI83P_lograve	   (0x0a7)
#define TI83P_locaret	   (0x0a8)
#define TI83P_lodier	   (0x0a9)
#define TI83P_lcapuacute   (0x0aa)
#define TI83P_lcapugrave   (0x0ab)
#define TI83P_lcapucaret   (0x0ac)
#define TI83P_lcapudier   (0x0ad)
#define TI83P_luacute	   (0x0ae)
#define TI83P_lugrave	   (0x0af)
#define TI83P_lucaret	   (0x0b0)
#define TI83P_ludier	   (0x0b1)
#define TI83P_lcapcced   (0x0b2)
#define TI83P_lcced	   (0x0b3)
#define TI83P_lcapntilde   (0x0b4)
#define TI83P_lntilde	   (0x0b5)
#define TI83P_laccent	   (0x0b6)
#define TI83P_lgrave	   (0x0b7)
#define TI83P_ldieresis   (0x0b8)
#define TI83P_lquesdown   (0x0b9)
#define TI83P_lexclamdown   (0x0ba)
#define TI83P_lalpha	   (0x0bb)
#define TI83P_lbeta	   (0x0bc)
#define TI83P_lgamma	   (0x0bd)
#define TI83P_lcapdelta   (0x0be)
#define TI83P_ldelta	   (0x0bf)
#define TI83P_lepsilon   (0x0c0)
#define TI83P_llbrack   (0x0c1)
#define TI83P_llambda	   (0x0c2)
#define TI83P_lmu	   (0x0c3)
#define TI83P_lpi	   (0x0c4)
#define TI83P_lrho	   (0x0c5)
#define TI83P_lcapsigma   (0x0c6)
#define TI83P_lsigma	   (0x0c7)
#define TI83P_ltau	   (0x0c8)
#define TI83P_lphi	   (0x0c9)
#define TI83P_lcapomega   (0x0ca)
#define TI83P_lxmean	   (0x0cb)
#define TI83P_lymean	   (0x0cc)
#define TI83P_lsupx	   (0x0cd)
#define TI83P_lellipsis   (0x0ce)
#define TI83P_lleft	   (0x0cf)
#define TI83P_lblock	   (0x0d0)
#define TI83P_lper	   (0x0d1)
#define TI83P_lhyphen	   (0x0d2)
#define TI83P_larea	   (0x0d3)
#define TI83P_ltemp	   (0x0d4)
#define TI83P_lcube	   (0x0d5)
#define TI83P_lenter	   (0x0d6)
#define TI83P_limagi	   (0x0d7)
#define TI83P_lphat	   (0x0d8)
#define TI83P_lchi	   (0x0d9)
#define TI83P_lstatf	  (0x0da)
#define TI83P_llne	   (0x0db)
#define TI83P_llistl	   (0x0dc)
#define TI83P_lfinann    (0x0dd)
#define TI83P_l2_r_paren    (0x0de)
#define TI83P_lblockarrow       (0x0df)
#define TI83P_lcuro     (0x0e0)
#define TI83P_lcuro2    (0x0e1)
#define TI83P_lcurocapa         (0x0e2)
#define TI83P_lcuroa    (0x0e3)
#define TI83P_lcuri     (0x0e4)
#define TI83P_lcuri2    (0x0e5)
#define TI83P_lcuricapa         (0x0e6)
#define TI83P_lcuria    (0x0e7)
#define TI83P_lgline            (0x0e8)// = 0
#define TI83P_lgthick           (0x0e9)// = 1
#define TI83P_lgabove           (0x0ea)// = 2
#define TI83P_lgbelow           (0x0eb)// = 3
#define TI83P_lgpath            (0x0ec)// = 4
#define TI83P_lganimate         (0x0ed)// = 5
#define TI83P_lgdot             (0x0ee)// = 6
#define TI83P_lupblk            (0x0ef)//up arrow and block in solver
#define TI83P_ldnblk            (0x0f0)//down arrow and block in solver
#define TI83P_lcurfull          (0x0f1)//note: must be last char (putmap checks)
//
//= ()=====================================================================
//           keypress equates
//= ()=====================================================================
//           keyboard key names
//
//
#define TI83P_kright            (0x001)
#define TI83P_kleft             (0x002)
#define TI83P_kup               (0x003)
#define TI83P_kdown             (0x004)
#define TI83P_kenter            (0x005)
#define TI83P_kalphaenter       (0x006)
#define TI83P_kalphaup          (0x007)
#define TI83P_kalphadown        (0x008)
#define TI83P_kclear            (0x009)
#define TI83P_kdel              (0x00a)
#define TI83P_kins              (0x00b)
#define TI83P_krecall           (0x00c)
#define TI83P_klastent          (0x00d)
#define TI83P_kbol              (0x00e)
#define TI83P_keol              (0x00f)
//
#define TI83P_kselall           (0x010)
#define TI83P_kunselall         (0x011)
#define TI83P_kltoti82          (0x012)
#define TI83P_kbackup           (0x013)
#define TI83P_krecieve          (0x014)
#define TI83P_klnkquit          (0x015)
#define TI83P_ktrans            (0x016)
#define TI83P_krename           (0x017)
#define TI83P_koverw            (0x018)
#define TI83P_komit             (0x019)
#define TI83P_kcont             (0x01a)
#define TI83P_ksendid           (0x01b)
#define TI83P_ksendsw           (0x01c)
#define TI83P_kyes              (0x01d)
#define TI83P_knoway            (0x01e)
#define TI83P_kvsendtype        (0x01f)
#define TI83P_koverwall         (0x020)
//
#define TI83P_kno               (0x025)
#define TI83P_kkreset           (0x026)
#define TI83P_kapp              (0x027)
//
#define TI83P_kdoug             (0x028)
#define TI83P_klistflag         (0x029)
#define TI83P_menustart         (0x02b)
//
#define TI83P_kareyousure       (0x02b)
#define TI83P_kappsmenu         (0x02c)
#define TI83P_kprgm             (0x02d)
#define TI83P_kzoom             (0x02e)
#define TI83P_kdraw             (0x02f)
#define TI83P_ksplot            (0x030)
#define TI83P_kstat             (0x031)
#define TI83P_kmath             (0x032)
#define TI83P_ktest             (0x033)
#define TI83P_kchar             (0x034)
#define TI83P_kvars             (0x035)
#define TI83P_kmem              (0x036)
#define TI83P_kmatrix           (0x037)
#define TI83P_kdist             (0x038)
#define TI83P_kangle            (0x039)
#define TI83P_klist             (0x03a)
#define TI83P_kcalc             (0x03b)
#define TI83P_kfin              (0x03c)
//
#define TI83P_menuend           (TI83P_kfin)
//
#define TI83P_kcatalog          (0x03e)
#define TI83P_kinputdone        (0x03f)
#define TI83P_koff              (TI83P_kinputdone)
//
#define TI83P_kquit             (0x040)
#define TI83P_appstart          (TI83P_kquit)

//
#define TI83P_klinkio           (0x041)
#define TI83P_kmatrixed         (0x042)
#define TI83P_kstated           (0x043)
#define TI83P_kgraph            (0x044)
#define TI83P_kmode             (0x045)
#define TI83P_kprgmed           (0x046)// program edit
#define TI83P_kprgmcr           (0x047)// program create
#define TI83P_kwindow           (0x048)// range editor
#define TI83P_kyequ             (0x049)// equation editor
#define TI83P_ktable            (0x04a)// table editor
#define TI83P_ktblset           (0x04b)// table set
#define TI83P_kchkram           (0x04c)// check ram
#define TI83P_kdelmem           (0x04d)// delete mem
#define TI83P_kresetmem         (0x04e)// reset mem
#define TI83P_kresetdef   (0x04f)// reset default
#define TI83P_kprgminput        (0x050)// program input
#define TI83P_kzfacted          (0x051)// zoom factor editor
#define TI83P_kerror            (0x052)// error
#define TI83P_ksolvetvm         (0x053)// tvm solver
#define TI83P_ksolveroot   (0x054)// solve editor
#define TI83P_kstatp            (0x055)// stat plot
#define TI83P_kinfstat    (0x056)// inferential statistic
#define TI83P_kformat           (0x057)// format
#define TI83P_kextapps          (0x058)// external applications.     new
#define TI83P_knewapps          (0x059)// new apps for cerberus.
//
#define TI83P_append            (TI83P_knewapps)
//
#define TI83P_echostart1        (0x05a)
//
#define TI83P_ktrace            (0x05a)
#define TI83P_kzfit             (0x05b)
#define TI83P_kzin              (0x05c)
#define TI83P_kzout             (0x05d)
#define TI83P_kzprev            (0x05e)
#define TI83P_kbox              (0x05f)
#define TI83P_kdecml            (0x060)
#define TI83P_ksetzm            (0x061)
#define TI83P_ksquar            (0x062)
#define TI83P_kstd              (0x063)
#define TI83P_ktrig             (0x064)
#define TI83P_kusrzm            (0x065)
#define TI83P_kzsto             (0x066)
#define TI83P_kzint             (0x067)
#define TI83P_kzstat            (0x068)
//
#define TI83P_echostart2        (0x069)
//
#define TI83P_kselect           (0x069)
#define TI83P_kcircl            (0x06a)
#define TI83P_kcldrw            (0x06b)
#define TI83P_kline             (0x06c)
#define TI83P_kpen              (0x06d)
#define TI83P_kptchg            (0x06e)
#define TI83P_kptoff            (0x06f)
#define TI83P_kpton             (0x070)
#define TI83P_kvert             (0x071)
#define TI83P_khoriz            (0x072)
#define TI83P_ktext             (0x073)
#define TI83P_ktanln            (0x074)
//
#define TI83P_keval             (0x075)
#define TI83P_kinters           (0x076)
#define TI83P_kdydx             (0x077)
#define TI83P_kfnintg           (0x078)
#define TI83P_krootg            (0x079)
#define TI83P_kdydt             (0x07a)
#define TI83P_kdxdt             (0x07b)
#define TI83P_kdrdo             (0x07c)
#define TI83P_kgfmin            (0x07d)
#define TI83P_kgfmax            (0x07e)
//
//
#define TI83P_echostart         (0x07f)
//
#define TI83P_klistname         (0x07f)
#define TI83P_kadd              (0x080)
#define TI83P_ksub              (0x081)
#define TI83P_kmul              (0x082)
#define TI83P_kdiv              (0x083)
#define TI83P_kexpon            (0x084)
#define TI83P_klparen           (0x085)
#define TI83P_krparen           (0x086)
#define TI83P_klbrack           (0x087)
#define TI83P_krbrack           (0x088)
#define TI83P_kshade            (0x089)
#define TI83P_kstore            (0x08a)
#define TI83P_kcomma            (0x08b)
#define TI83P_kchs              (0x08c)
#define TI83P_kdecpnt           (0x08d)
#define TI83P_k0                (0x08e)
#define TI83P_k1                (0x08f)
#define TI83P_k2                (0x090)
#define TI83P_k3                (0x091)
#define TI83P_k4                (0x092)
#define TI83P_k5                (0x093)
#define TI83P_k6                (0x094)
#define TI83P_k7                (0x095)
#define TI83P_k8                (0x096)
#define TI83P_k9                (0x097)
#define TI83P_kee               (0x098)
#define TI83P_kspace            (0x099)
#define TI83P_kcapa             (0x09a)
#define TI83P_kcapb             (0x09b)
#define TI83P_kcapc             (0x09c)
#define TI83P_kcapd             (0x09d)
#define TI83P_kcape             (0x09e)
#define TI83P_kcapf             (0x09f)
#define TI83P_kcapg             (0x0a0)
#define TI83P_kcaph             (0x0a1)
#define TI83P_kcapi             (0x0a2)
#define TI83P_kcapj             (0x0a3)
#define TI83P_kcapk             (0x0a4)
#define TI83P_kcapl             (0x0a5)
#define TI83P_kcapm             (0x0a6)
#define TI83P_kcapn             (0x0a7)
#define TI83P_kcapo             (0x0a8)
#define TI83P_kcapp             (0x0a9)
#define TI83P_kcapq             (0x0aa)
#define TI83P_kcapr             (0x0ab)
#define TI83P_kcaps             (0x0ac)
#define TI83P_kcapt             (0x0ad)
#define TI83P_kcapu             (0x0ae)
#define TI83P_kcapv             (0x0af)
#define TI83P_kcapw             (0x0b0)
#define TI83P_kcapx             (0x0b1)
#define TI83P_kcapy             (0x0b2)
#define TI83P_kcapz             (0x0b3)
#define TI83P_kvarx             (0x0b4)
#define TI83P_kpi               (0x0b5)
#define TI83P_kinv              (0x0b6)
#define TI83P_ksin              (0x0b7)
#define TI83P_kasin             (0x0b8)
#define TI83P_kcos              (0x0b9)
#define TI83P_kacos             (0x0ba)
#define TI83P_ktan              (0x0bb)
#define TI83P_katan             (0x0bc)
#define TI83P_ksquare           (0x0bd)
#define TI83P_ksqrt             (0x0be)
#define TI83P_kln               (0x0bf)
#define TI83P_kexp              (0x0c0)
#define TI83P_klog              (0x0c1)
#define TI83P_kalog             (0x0c2)
#define TI83P_ktoabc            (0x0c3)
//
#define TI83P_kclrtbl           (0x0c4)
//
#define TI83P_kans              (0x0c5)
#define TI83P_kcolon            (0x0c6)
//
#define TI83P_knderiv           (0x0c7)
#define TI83P_kfnint            (0x0c8)
#define TI83P_kroot             (0x0c9)
//
#define TI83P_kquest            (0x0ca)
#define TI83P_kquote            (0x0cb)
#define TI83P_ktheta            (0x0cc)
#define TI83P_kif               (0x0cd)
#define TI83P_kthen             (0x0ce)
#define TI83P_kelse             (0x0cf)
#define TI83P_kfor              (0x0d0)
#define TI83P_kwhile            (0x0d1)
#define TI83P_krepeat           (0x0d2)
#define TI83P_kend              (0x0d3)
#define TI83P_kpause            (0x0d4)
#define TI83P_klbl              (0x0d5)
#define TI83P_kgoto             (0x0d6)
#define TI83P_kisg              (0x0d7)
#define TI83P_kdsl              (0x0d8)
#define TI83P_kmenu             (0x0d9)
#define TI83P_kexec             (0x0da)
#define TI83P_kreturn           (0x0db)
#define TI83P_kstop             (0x0dc)
#define TI83P_kinput            (0x0dd)
#define TI83P_kprompt           (0x0de)
#define TI83P_kdisp             (0x0df)
#define TI83P_kdispg            (0x0e0)
#define TI83P_kdispt            (0x0e1)
#define TI83P_koutput           (0x0e2)
#define TI83P_kgetkey           (0x0e3)
#define TI83P_kclrhome          (0x0e4)
#define TI83P_kprtscr           (0x0e5)
#define TI83P_ksinh             (0x0e6)
#define TI83P_kcosh             (0x0e7)
#define TI83P_ktanh             (0x0e8)
#define TI83P_kasinh            (0x0e9)
#define TI83P_kacosh            (0x0ea)
#define TI83P_katanh            (0x0eb)
#define TI83P_klbrace           (0x0ec)
#define TI83P_krbrace           (0x0ed)
#define TI83P_ki                (0x0ee)
#define TI83P_kconstea          (0x0ef)
#define TI83P_kplot3            (0x0f0)
#define TI83P_kfmin             (0x0f1)
#define TI83P_kfmax             (0x0f2)
#define TI83P_kl1a              (0x0f3)
#define TI83P_kl2a              (0x0f4)
#define TI83P_kl3a              (0x0f5)
#define TI83P_kl4a              (0x0f6)
#define TI83P_kl5a              (0x0f7)
#define TI83P_kl6a              (0x0f8)
#define TI83P_kuna              (0x0f9)
#define TI83P_kvna              (0x0fa)
#define TI83P_kwna              (0x0fb)
//
//= ()=====================================================================
//       this key means that it is a 2 byte keycode
//       there are 2 of these keys; be careful with usage
//= ()=====================================================================
//
#define TI83P_kextendecho2      (0x0fc)
//
//= ()===================================================================== TI83P_;
//       this key means that the key press is one that echos
//       into a buffer, and it is a 2 byte key code, go look at
//       (extecho) for the key value 
//= ()=====================================================================
//
#define TI83P_kextendecho       (0x0fe)
//

#define TI83P_ke1bt             (0)

#define TI83P_kdrawinv          (TI83P_ke1bt)
#define TI83P_kdrawf            (TI83P_ke1bt+1)
#define TI83P_kpixelon          (TI83P_ke1bt+2)
#define TI83P_kpixeloff         (TI83P_ke1bt+3)
#define TI83P_kpxltest          (TI83P_ke1bt+4)
#define TI83P_krcgdb            (TI83P_ke1bt+5)
#define TI83P_krcpic            (TI83P_ke1bt+6)
#define TI83P_kstgdb            (TI83P_ke1bt+7)
#define TI83P_kstpic            (TI83P_ke1bt+8)
#define TI83P_kabs              (TI83P_ke1bt+9)
#define TI83P_ktequ             (TI83P_ke1bt+10)// ==
#define TI83P_ktnoteq           (TI83P_ke1bt+11)// <>
#define TI83P_ktgt              (TI83P_ke1bt+12)// >
#define TI83P_ktgte             (TI83P_ke1bt+13)// > =
#define TI83P_ktlt              (TI83P_ke1bt+14)// <
#define TI83P_ktlte             (TI83P_ke1bt+15)// < =

#define TI83P_kand              (TI83P_ke1bt+16)
#define TI83P_kor               (TI83P_ke1bt+17)
#define TI83P_kxor              (TI83P_ke1bt+18)
#define TI83P_knot              (TI83P_ke1bt+19)

#define TI83P_klr1              (TI83P_ke1bt+20)

#define TI83P_kxroot            (TI83P_ke1bt+21)
#define TI83P_kcube             (TI83P_ke1bt+22)
#define TI83P_kcbrt             (TI83P_ke1bt+23)// cube root
#define TI83P_ktodec            (TI83P_ke1bt+24)
//
#define TI83P_kcubicr           (TI83P_ke1bt+25)
#define TI83P_kquartr           (TI83P_ke1bt+26)
//
#define TI83P_kplot1            (TI83P_ke1bt+27)
#define TI83P_kplot2            (TI83P_ke1bt+28)
//

#define TI83P_kround            (TI83P_ke1bt+29)
#define TI83P_kipart            (TI83P_ke1bt+30)
#define TI83P_kfpart            (TI83P_ke1bt+31)
#define TI83P_kint              (TI83P_ke1bt+32)

#define TI83P_krand             (TI83P_ke1bt+33)
#define TI83P_knpr              (TI83P_ke1bt+34)
#define TI83P_kncr              (TI83P_ke1bt+35)
#define TI83P_kxfactorial       (TI83P_ke1bt+36)

#define TI83P_krad              (TI83P_ke1bt+37)
#define TI83P_kdegr             (TI83P_ke1bt+38)// degrees conv
#define TI83P_kapost            (TI83P_ke1bt+39)
#define TI83P_ktodms            (TI83P_ke1bt+40)
#define TI83P_krtopo            (TI83P_ke1bt+41)// r
#define TI83P_krtopr            (TI83P_ke1bt+42)
#define TI83P_kptorx            (TI83P_ke1bt+43)
#define TI83P_kptory            (TI83P_ke1bt+44)

#define TI83P_krowswap          (TI83P_ke1bt+45)
#define TI83P_krowplus          (TI83P_ke1bt+46)
#define TI83P_ktimrow           (TI83P_ke1bt+47)
#define TI83P_ktrowp            (TI83P_ke1bt+48)

#define TI83P_ksorta            (TI83P_ke1bt+49)
#define TI83P_ksortd            (TI83P_ke1bt+50)
#define TI83P_kseq              (TI83P_ke1bt+51)

#define TI83P_kmin              (TI83P_ke1bt+52)
#define TI83P_kmax              (TI83P_ke1bt+53)
#define TI83P_kmean             (TI83P_ke1bt+54)
#define TI83P_kmedian           (TI83P_ke1bt+55)
#define TI83P_ksum              (TI83P_ke1bt+56)
#define TI83P_kprod             (TI83P_ke1bt+57)

#define TI83P_kdet              (TI83P_ke1bt+58)
#define TI83P_ktransp           (TI83P_ke1bt+59)
#define TI83P_kdim              (TI83P_ke1bt+60)
#define TI83P_kfill             (TI83P_ke1bt+61)
#define TI83P_kident            (TI83P_ke1bt+62)
#define TI83P_krandm            (TI83P_ke1bt+63)
#define TI83P_kaug              (TI83P_ke1bt+64)

#define TI83P_konevar           (TI83P_ke1bt+65)
#define TI83P_ktwovar           (TI83P_ke1bt+66)
#define TI83P_klr               (TI83P_ke1bt+67)
#define TI83P_klrexp            (TI83P_ke1bt+68)
#define TI83P_klrln             (TI83P_ke1bt+69)
#define TI83P_klrpwr            (TI83P_ke1bt+70)
#define TI83P_kmedmed           (TI83P_ke1bt+71)
#define TI83P_kquad             (TI83P_ke1bt+72)
#define TI83P_kclrlst           (TI83P_ke1bt+73)
#define TI83P_khist             (TI83P_ke1bt+74)
#define TI83P_kxyline           (TI83P_ke1bt+75)
#define TI83P_kscatter          (TI83P_ke1bt+76)

#define TI83P_kmrad             (TI83P_ke1bt+77)
#define TI83P_kmdeg             (TI83P_ke1bt+78)
#define TI83P_kmnormf           (TI83P_ke1bt+79)
#define TI83P_kmsci             (TI83P_ke1bt+80)
#define TI83P_kmeng             (TI83P_ke1bt+81)
#define TI83P_kmfloat           (TI83P_ke1bt+82)

#define TI83P_kfix              (TI83P_ke1bt+83)
#define TI83P_kspliton          (TI83P_ke1bt+84)
#define TI83P_kfullscreen       (TI83P_ke1bt+85)
#define TI83P_kstndrd           (TI83P_ke1bt+86)
#define TI83P_kparam            (TI83P_ke1bt+87)
#define TI83P_kpolar            (TI83P_ke1bt+88)
#define TI83P_kseqg             (TI83P_ke1bt+89)
#define TI83P_kafillon          (TI83P_ke1bt+90)
#define TI83P_kafilloff         (TI83P_ke1bt+91)
#define TI83P_kacalcon          (TI83P_ke1bt+92)
#define TI83P_kacalcoff         (TI83P_ke1bt+93)
#define TI83P_kfnon             (TI83P_ke1bt+94)
#define TI83P_kfnoff            (TI83P_ke1bt+95)

#define TI83P_kplotson          (TI83P_ke1bt+96)
#define TI83P_kplotsoff         (TI83P_ke1bt+97)

#define TI83P_kpixelchg         (TI83P_ke1bt+98)

#define TI83P_ksendmbl          (TI83P_ke1bt+99)
#define TI83P_krecvmbl          (TI83P_ke1bt+100)

#define TI83P_kboxplot          (TI83P_ke1bt+101)
#define TI83P_kboxicon          (TI83P_ke1bt+102)
#define TI83P_kcrossicon        (TI83P_ke1bt+103)
#define TI83P_kdoticon          (TI83P_ke1bt+104)

#define TI83P_ke2bt             (TI83P_ke1bt+105)

#define TI83P_kseqential        (TI83P_ke2bt)
#define TI83P_ksimulg           (TI83P_ke2bt+1)
#define TI83P_kpolarg           (TI83P_ke2bt+2)
#define TI83P_krectg            (TI83P_ke2bt+3)
#define TI83P_kcoordon          (TI83P_ke2bt+4)
#define TI83P_kcoordoff         (TI83P_ke2bt+5)
#define TI83P_kdrawline         (TI83P_ke2bt+6)
#define TI83P_kdrawdot          (TI83P_ke2bt+7)
#define TI83P_kaxison           (TI83P_ke2bt+8)
#define TI83P_kaxisoff          (TI83P_ke2bt+9)
#define TI83P_kgridon           (TI83P_ke2bt+10)
#define TI83P_kgridoff          (TI83P_ke2bt+11)
#define TI83P_klblon            (TI83P_ke2bt+12)
#define TI83P_klbloff           (TI83P_ke2bt+13)

#define TI83P_kl1               (TI83P_ke2bt+14)
#define TI83P_kl2               (TI83P_ke2bt+15)
#define TI83P_kl3               (TI83P_ke2bt+16)
#define TI83P_kl4               (TI83P_ke2bt+17)
#define TI83P_kl5               (TI83P_ke2bt+18)
#define TI83P_kl6               (TI83P_ke2bt+19)

//
//= ()=====================================================================
//           these keys are layed on top of existing keys to
//           enable localization in the inferential stats editor
//= ()=====================================================================
//
#define TI83P_kinfdata          (TI83P_kl1)
#define TI83P_kinfstats         (TI83P_kl1+1)
#define TI83P_kinfyes           (TI83P_kl1+2)
#define TI83P_kinfno            (TI83P_kl1+3)
#define TI83P_kinfcalc          (TI83P_kl1+4)
#define TI83P_kinfdraw          (TI83P_kl1+5)
#define TI83P_kinfalt1ne        (TI83P_kl1+6)
#define TI83P_kinfalt1lt        (TI83P_kl1+7)
#define TI83P_kinfalt1gt        (TI83P_kl1+8)
#define TI83P_kinfalt2ne        (TI83P_kl1+9)
#define TI83P_kinfalt2lt        (TI83P_kl1+10)
#define TI83P_kinfalt2gt        (TI83P_kl1+11)
#define TI83P_kinfalt3ne        (TI83P_kl1+12)
#define TI83P_kinfalt3lt        (TI83P_kl1+13)
#define TI83P_kinfalt3gt        (TI83P_kl1+14)
#define TI83P_kinfalt4ne        (TI83P_kl1+15)
#define TI83P_kinfalt4lt        (TI83P_kl1+16)
#define TI83P_kinfalt4gt        (TI83P_kl1+17)
#define TI83P_kinfalt5ne        (TI83P_kl1+18)
#define TI83P_kinfalt5lt        (TI83P_kl1+19)
#define TI83P_kinfalt5gt        (TI83P_kl1+20)
#define TI83P_kinfalt6ne        (TI83P_kl1+21)
#define TI83P_kinfalt6lt        (TI83P_kl1+22)
#define TI83P_kinfalt6gt        (TI83P_kl1+23)
//
//
#define TI83P_kmata             (TI83P_ke2bt+20)
#define TI83P_kmatb             (TI83P_ke2bt+21)
#define TI83P_kmatc             (TI83P_ke2bt+22)
#define TI83P_kmatd             (TI83P_ke2bt+23)
#define TI83P_kmate             (TI83P_ke2bt+24)

#define TI83P_kxmin             (TI83P_ke2bt+25)
#define TI83P_kxmax             (TI83P_ke2bt+26)
#define TI83P_kxscl             (TI83P_ke2bt+27)
#define TI83P_kymin             (TI83P_ke2bt+28)
#define TI83P_kymax             (TI83P_ke2bt+29)
#define TI83P_kyscl             (TI83P_ke2bt+30)
#define TI83P_ktmin             (TI83P_ke2bt+31)
#define TI83P_ktmax             (TI83P_ke2bt+32)
#define TI83P_ktstep            (TI83P_ke2bt+33)
#define TI83P_komin             (TI83P_ke2bt+34)
#define TI83P_komax             (TI83P_ke2bt+35)
#define TI83P_kostep            (TI83P_ke2bt+36)
#define TI83P_ku0               (TI83P_ke2bt+37)
#define TI83P_kv0               (TI83P_ke2bt+38)
#define TI83P_knmin             (TI83P_ke2bt+39)
#define TI83P_knmax             (TI83P_ke2bt+40)
#define TI83P_kdeltay           (TI83P_ke2bt+41)
#define TI83P_kdeltax           (TI83P_ke2bt+42)

#define TI83P_kzxmin            (TI83P_ke2bt+43)
#define TI83P_kzxmax            (TI83P_ke2bt+44)
#define TI83P_kzxscl            (TI83P_ke2bt+45)
#define TI83P_kzymin            (TI83P_ke2bt+46)
#define TI83P_kzymax            (TI83P_ke2bt+47)
#define TI83P_kzyscl            (TI83P_ke2bt+48)
#define TI83P_kztmin            (TI83P_ke2bt+49)
#define TI83P_kztmax            (TI83P_ke2bt+50)
#define TI83P_kztstep           (TI83P_ke2bt+51)
#define TI83P_kzomin            (TI83P_ke2bt+52)
#define TI83P_kzomax            (TI83P_ke2bt+53)
#define TI83P_kzostep           (TI83P_ke2bt+54)
#define TI83P_kzu0              (TI83P_ke2bt+55)
#define TI83P_kzv0              (TI83P_ke2bt+56)
#define TI83P_kznmin            (TI83P_ke2bt+57)
#define TI83P_kznmax            (TI83P_ke2bt+58)

#define TI83P_kdellast          (TI83P_ke2bt+59)
#define TI83P_ksinreg           (TI83P_ke2bt+60)
#define TI83P_kconste           (TI83P_ke2bt+61)

#define TI83P_kpic1             (TI83P_ke2bt+62)
#define TI83P_kpic2             (TI83P_ke2bt+63)
#define TI83P_kpic3             (TI83P_ke2bt+64)

#define TI83P_kdelvar           (TI83P_ke2bt+65)
#define TI83P_kgetcalc          (TI83P_ke2bt+66)
#define TI83P_krealm            (TI83P_ke2bt+67)
#define TI83P_kpolarm           (TI83P_ke2bt+68)
#define TI83P_krectm            (TI83P_ke2bt+69)
#define TI83P_kuv               (TI83P_ke2bt+70)// u vs v
#define TI83P_kvw               (TI83P_ke2bt+71)// v vs w
#define TI83P_kuw               (TI83P_ke2bt+72)// u vs w
#define TI83P_kfinpmtend        (TI83P_ke2bt+73)
#define TI83P_kfinpmtbeg        (TI83P_ke2bt+74)
//
#define TI83P_kgraphstyle       (TI83P_ke2bt+75)
//
#define TI83P_kexpron           (TI83P_ke2bt+76)
#define TI83P_kexproff          (TI83P_ke2bt+77)
#define TI83P_kstata            (TI83P_ke2bt+78)
#define TI83P_kstatb            (TI83P_ke2bt+79)
#define TI83P_kstatc            (TI83P_ke2bt+80)
#define TI83P_kcorr             (TI83P_ke2bt+81)
#define TI83P_kstatd            (TI83P_ke2bt+82)
#define TI83P_kstate            (TI83P_ke2bt+83)
#define TI83P_kregeq            (TI83P_ke2bt+84)
#define TI83P_kminx             (TI83P_ke2bt+85)
#define TI83P_kq1               (TI83P_ke2bt+86)
#define TI83P_kmd               (TI83P_ke2bt+87)
#define TI83P_kq3               (TI83P_ke2bt+88)
#define TI83P_kmaxx             (TI83P_ke2bt+89)
#define TI83P_kstatx1           (TI83P_ke2bt+90)
#define TI83P_kstaty1           (TI83P_ke2bt+91)
#define TI83P_kstatx2           (TI83P_ke2bt+92)
#define TI83P_kstaty2           (TI83P_ke2bt+93)
#define TI83P_kstatx3           (TI83P_ke2bt+94)
#define TI83P_kstaty3           (TI83P_ke2bt+95)
#define TI83P_ktblmin           (TI83P_ke2bt+96)
#define TI83P_ktblstep          (TI83P_ke2bt+97)
#define TI83P_ksetuplst         (TI83P_ke2bt+98)
#define TI83P_kclralllst        (TI83P_ke2bt+99)
#define TI83P_klogistic         (TI83P_ke2bt+100)
#define TI83P_kztest            (TI83P_ke2bt+101)
#define TI83P_kttest            (TI83P_ke2bt+102)
#define TI83P_k2sampztest       (TI83P_ke2bt+103)
#define TI83P_k2sampttest       (TI83P_ke2bt+104)
#define TI83P_k1propztest       (TI83P_ke2bt+105)
#define TI83P_k2propztest       (TI83P_ke2bt+106)
#define TI83P_kchitest          (TI83P_ke2bt+107)
#define TI83P_k2sampftest       (TI83P_ke2bt+108)
#define TI83P_kzintval          (TI83P_ke2bt+109)
#define TI83P_ktintval          (TI83P_ke2bt+110)
#define TI83P_k2samptint        (TI83P_ke2bt+111)
#define TI83P_k2sampzint        (TI83P_ke2bt+112)
#define TI83P_k1propzint        (TI83P_ke2bt+113)
#define TI83P_k2propzint        (TI83P_ke2bt+114)
#define TI83P_kdnormal          (TI83P_ke2bt+115)
#define TI83P_kinvnorm          (TI83P_ke2bt+116)
#define TI83P_kdt               (TI83P_ke2bt+117)
#define TI83P_kchi              (TI83P_ke2bt+118)
#define TI83P_kdf               (TI83P_ke2bt+119)
#define TI83P_kbinpdf           (TI83P_ke2bt+120)
#define TI83P_kbincdf           (TI83P_ke2bt+121)
#define TI83P_kpoipdf           (TI83P_ke2bt+122)
#define TI83P_kpoicdf           (TI83P_ke2bt+123)
#define TI83P_kun               (TI83P_ke2bt+124)
#define TI83P_kvn               (TI83P_ke2bt+125)
#define TI83P_kwn               (TI83P_ke2bt+126)
#define TI83P_krecn             (TI83P_ke2bt+127)
#define TI83P_kplotstart        (TI83P_ke2bt+128)
#define TI83P_kzplotstart       (TI83P_ke2bt+129)// recursion n
#define TI83P_kxfact            (TI83P_ke2bt+130)// plotstart
#define TI83P_kyfact            (TI83P_ke2bt+131)// zplotstart
#define TI83P_kanova            (TI83P_ke2bt+132)// xfact
#define TI83P_kmaxy             (TI83P_ke2bt+133)// yfact
#define TI83P_kwebon            (TI83P_ke2bt+134)// miny
#define TI83P_kweboff           (TI83P_ke2bt+135)// maxy
#define TI83P_ktblinput         (TI83P_ke2bt+136)// web on
#define TI83P_kgeopdf           (TI83P_ke2bt+137)// web off
#define TI83P_kgeocdf           (TI83P_ke2bt+138)// web off
#define TI83P_kshadenorm        (TI83P_ke2bt+139)
#define TI83P_kshadet           (TI83P_ke2bt+140)
#define TI83P_kshadechi         (TI83P_ke2bt+141)
#define TI83P_kshadef           (TI83P_ke2bt+142)
#define TI83P_kplotstep         (TI83P_ke2bt+143)
#define TI83P_kzplotstep        (TI83P_ke2bt+144)
#define TI83P_klinregttest      (TI83P_ke2bt+145)
#define TI83P_kmgt	   (TI83P_ke2bt+146)// vert split
#define TI83P_kselecta          (TI83P_ke2bt+147)
#define TI83P_kzfita            (TI83P_ke2bt+148)
#define TI83P_ke2bt_end         (TI83P_kzfita)
//
//
//= ()=====================================================================
//           more 2 byte keys 
//= ()=====================================================================

#define TI83P_ke2bt2	  (0)

#define TI83P_kgdb1	  (TI83P_ke2bt2)
#define TI83P_kgdb2	  (TI83P_ke2bt2+1)
#define TI83P_kgdb3	  (TI83P_ke2bt2+2)
#define TI83P_ky1	  (TI83P_ke2bt2+3)
#define TI83P_ky2	  (TI83P_ke2bt2+4)
#define TI83P_ky3	  (TI83P_ke2bt2+5)
#define TI83P_ky4	  (TI83P_ke2bt2+6)
#define TI83P_ky5	  (TI83P_ke2bt2+7)
#define TI83P_ky6	  (TI83P_ke2bt2+8)
#define TI83P_ky7	  (TI83P_ke2bt2+9)
#define TI83P_ky8	  (TI83P_ke2bt2+10)
#define TI83P_ky9	  (TI83P_ke2bt2+11)
#define TI83P_ky0	  (TI83P_ke2bt2+12)
#define TI83P_kx1t	  (TI83P_ke2bt2+13)
#define TI83P_ky1t	  (TI83P_ke2bt2+14)
#define TI83P_kx2t	  (TI83P_ke2bt2+15)
#define TI83P_ky2t	  (TI83P_ke2bt2+16)
#define TI83P_kx3t	  (TI83P_ke2bt2+17)
#define TI83P_ky3t	  (TI83P_ke2bt2+18)
#define TI83P_kx4t	  (TI83P_ke2bt2+19)
#define TI83P_ky4t	  (TI83P_ke2bt2+20)
#define TI83P_kx5t	  (TI83P_ke2bt2+21)
#define TI83P_ky5t	  (TI83P_ke2bt2+22)
#define TI83P_kx6t	  (TI83P_ke2bt2+23)
#define TI83P_ky6t	  (TI83P_ke2bt2+24)
#define TI83P_kr1	  (TI83P_ke2bt2+25)
#define TI83P_kr2	  (TI83P_ke2bt2+26)
#define TI83P_kr3	  (TI83P_ke2bt2+27)
#define TI83P_kr4	  (TI83P_ke2bt2+28)
#define TI83P_kr5	  (TI83P_ke2bt2+29)
#define TI83P_kr6	  (TI83P_ke2bt2+30)
#define TI83P_kgdb4	  (TI83P_ke2bt2+31)
#define TI83P_kgdb5	  (TI83P_ke2bt2+32)
#define TI83P_kgdb6	  (TI83P_ke2bt2+33)
#define TI83P_kpic4	  (TI83P_ke2bt2+34)
#define TI83P_kpic5	  (TI83P_ke2bt2+35)
#define TI83P_kpic6	  (TI83P_ke2bt2+36)
#define TI83P_kgdb7	  (TI83P_ke2bt2+37)
#define TI83P_kgdb8	  (TI83P_ke2bt2+38)
#define TI83P_kgdb9	  (TI83P_ke2bt2+39)
#define TI83P_kgdb0	  (TI83P_ke2bt2+40)
#define TI83P_kpic7	  (TI83P_ke2bt2+41)
#define TI83P_kpic8	  (TI83P_ke2bt2+42)
#define TI83P_kpic9	  (TI83P_ke2bt2+43)
#define TI83P_kpic0	  (TI83P_ke2bt2+44)
#define TI83P_kstatn	  (TI83P_ke2bt2+45)
#define TI83P_kxmean	  (TI83P_ke2bt2+46)
#define TI83P_kconj	  (TI83P_ke2bt2+47)
#define TI83P_kreal	  (TI83P_ke2bt2+48)
#define TI83P_kfangle	  (TI83P_ke2bt2+49)
#define TI83P_klcm	  (TI83P_ke2bt2+50)
#define TI83P_kgcd	  (TI83P_ke2bt2+51)
#define TI83P_krandint  (TI83P_ke2bt2+52)
#define TI83P_krandnorm  (TI83P_ke2bt2+53)
#define TI83P_ktopolar  (TI83P_ke2bt2+54)
#define TI83P_ktorect	  (TI83P_ke2bt2+55)
#define TI83P_kymean	  (TI83P_ke2bt2+56)
#define TI83P_kstdx	  (TI83P_ke2bt2+57)
#define TI83P_kstdx1	  (TI83P_ke2bt2+58)
#define TI83P_kw0	  (TI83P_ke2bt2+59)
#define TI83P_kmatf	  (TI83P_ke2bt2+60)
#define TI83P_kmatg	  (TI83P_ke2bt2+61)
#define TI83P_kmatrh	  (TI83P_ke2bt2+62)
#define TI83P_kmati	  (TI83P_ke2bt2+63)
#define TI83P_kmatj	  (TI83P_ke2bt2+64)
#define TI83P_kymean1	  (TI83P_ke2bt2+65)
#define TI83P_kstdy	  (TI83P_ke2bt2+66)
#define TI83P_kstdy1	  (TI83P_ke2bt2+67)
#define TI83P_kmattolst  (TI83P_ke2bt2+68)
#define TI83P_klsttomat  (TI83P_ke2bt2+69)
#define TI83P_kcumsum	  (TI83P_ke2bt2+70)
#define TI83P_kdeltalst  (TI83P_ke2bt2+71)
#define TI83P_kstddev	  (TI83P_ke2bt2+72)
#define TI83P_kvariance  (TI83P_ke2bt2+73)
#define TI83P_klength	  (TI83P_ke2bt2+74)
#define TI83P_kequtostrng  (TI83P_ke2bt2+75)
#define TI83P_kstrngtoequ  (TI83P_ke2bt2+76)
#define TI83P_kexpr	  (TI83P_ke2bt2+77)
#define TI83P_ksubstrng  (TI83P_ke2bt2+78)
#define TI83P_kinstrng  (TI83P_ke2bt2+79)
#define TI83P_kstr1	  (TI83P_ke2bt2+80)
#define TI83P_kstr2	  (TI83P_ke2bt2+81)
#define TI83P_kstr3	  (TI83P_ke2bt2+82)
#define TI83P_kstr4             (TI83P_ke2bt2+83)
#define TI83P_kstr5             (TI83P_ke2bt2+84)
#define TI83P_kstr6             (TI83P_ke2bt2+85)
#define TI83P_kstr7             (TI83P_ke2bt2+86)
#define TI83P_kstr8             (TI83P_ke2bt2+87)
#define TI83P_kstr9             (TI83P_ke2bt2+88)
#define TI83P_kstr0             (TI83P_ke2bt2+89)
#define TI83P_kfinn             (TI83P_ke2bt2+90)
#define TI83P_kfini             (TI83P_ke2bt2+91)
#define TI83P_kfinpv            (TI83P_ke2bt2+92)
#define TI83P_kfinpmt           (TI83P_ke2bt2+93)
#define TI83P_kfinfv            (TI83P_ke2bt2+94)
#define TI83P_kfinpy            (TI83P_ke2bt2+95)
#define TI83P_kfincy            (TI83P_ke2bt2+96)
#define TI83P_kfinfpmt          (TI83P_ke2bt2+97)
#define TI83P_kfinfi            (TI83P_ke2bt2+98)
#define TI83P_kfinfpv           (TI83P_ke2bt2+99)
#define TI83P_kfinfn            (TI83P_ke2bt2+100)
#define TI83P_kfinffv           (TI83P_ke2bt2+101)
#define TI83P_kfinnpv           (TI83P_ke2bt2+102)
#define TI83P_kfinirr           (TI83P_ke2bt2+103)
#define TI83P_kfinbal           (TI83P_ke2bt2+104)
#define TI83P_kfinprn           (TI83P_ke2bt2+105)
#define TI83P_kfinint           (TI83P_ke2bt2+106)
#define TI83P_ksumx             (TI83P_ke2bt2+107)
#define TI83P_ksumx2            (TI83P_ke2bt2+108)
#define TI83P_kfintonom         (TI83P_ke2bt2+109)
#define TI83P_kfintoeff         (TI83P_ke2bt2+110)
#define TI83P_kfindbd           (TI83P_ke2bt2+111)
#define TI83P_kstatvp           (TI83P_ke2bt2+112)
#define TI83P_kstatz            (TI83P_ke2bt2+113)
#define TI83P_kstatt            (TI83P_ke2bt2+114)
#define TI83P_kstatchi          (TI83P_ke2bt2+115)
#define TI83P_kstatf            (TI83P_ke2bt2+116)
#define TI83P_kstatdf           (TI83P_ke2bt2+117)
#define TI83P_kstatphat         (TI83P_ke2bt2+118)
#define TI83P_kstatphat1        (TI83P_ke2bt2+119)
#define TI83P_kstatphat2        (TI83P_ke2bt2+120)
#define TI83P_kstatmeanx1       (TI83P_ke2bt2+121)
#define TI83P_kstatmeanx2       (TI83P_ke2bt2+122)
#define TI83P_kstatstdx1        (TI83P_ke2bt2+123)
#define TI83P_kstatstdx2        (TI83P_ke2bt2+124)
#define TI83P_kstatstdxp        (TI83P_ke2bt2+125)
#define TI83P_kstatn1           (TI83P_ke2bt2+126)
#define TI83P_kstatn2           (TI83P_ke2bt2+127)
#define TI83P_kstatlower        (TI83P_ke2bt2+128)
#define TI83P_kstatupper        (TI83P_ke2bt2+129)
#define TI83P_kuw0              (TI83P_ke2bt2+130)
#define TI83P_kimag             (TI83P_ke2bt2+131)
#define TI83P_ksumy             (TI83P_ke2bt2+132)
#define TI83P_kxres             (TI83P_ke2bt2+133)
#define TI83P_kstat_s           (TI83P_ke2bt2+134)
#define TI83P_ksumy2            (TI83P_ke2bt2+135)
#define TI83P_ksumxy            (TI83P_ke2bt2+136)
#define TI83P_kuxres            (TI83P_ke2bt2+137)
#define TI83P_kmodbox	  (TI83P_ke2bt2+138)
#define TI83P_knormprob  (TI83P_ke2bt2+139)
#define TI83P_knormalpdf        (TI83P_ke2bt2+140)
#define TI83P_ktpdf             (TI83P_ke2bt2+141)
#define TI83P_kchipdf           (TI83P_ke2bt2+142)
#define TI83P_kfpdf             (TI83P_ke2bt2+143)
#define TI83P_kminy             (TI83P_ke2bt2+144)// miny
#define TI83P_krandbin          (TI83P_ke2bt2+145)
#define TI83P_kref              (TI83P_ke2bt2+146)
#define TI83P_krref             (TI83P_ke2bt2+147)
#define TI83P_klrsqr            (TI83P_ke2bt2+148)
#define TI83P_kbrsqr            (TI83P_ke2bt2+149)
#define TI83P_kdiagon           (TI83P_ke2bt2+150)
#define TI83P_kdiagoff          (TI83P_ke2bt2+151)
#define TI83P_kun1              (TI83P_ke2bt2+152)// for rcl use when gotten from 82
#define TI83P_kvn1              (TI83P_ke2bt2+153)// for rcl use when gotten from 82
//
#define TI83P_k83_00end        (TI83P_kvn1)//end of original keys...
#define TI83P_karchive          (TI83P_k83_00end + 1)
#define TI83P_kunarchive        (TI83P_k83_00end + 2)
#define TI83P_kasm              (TI83P_k83_00end + 3)// asm(
#define TI83P_kasmprgm          (TI83P_k83_00end + 4)// asmprgm
#define TI83P_kasmcomp          (TI83P_k83_00end + 5)// asmcomp(
//
#define TI83P_kcapaacute  (TI83P_k83_00end + 6)
#define TI83P_kcapagrave  (TI83P_k83_00end + 7)
#define TI83P_kcapacaret  (TI83P_k83_00end + 8)
#define TI83P_kcapadier  (TI83P_k83_00end + 9)
#define TI83P_kaacute	  (TI83P_k83_00end + 10)
#define TI83P_kagrave	  (TI83P_k83_00end + 11)
#define TI83P_kacaret	  (TI83P_k83_00end + 12)
#define TI83P_kadier	  (TI83P_k83_00end + 13)
#define TI83P_kcapeacute  (TI83P_k83_00end + 14)
#define TI83P_kcapegrave  (TI83P_k83_00end + 15)
#define TI83P_kcapecaret  (TI83P_k83_00end + 16)
#define TI83P_kcapedier  (TI83P_k83_00end + 17)
#define TI83P_keacute	  (TI83P_k83_00end + 18)
#define TI83P_kegrave	  (TI83P_k83_00end + 19)
#define TI83P_kecaret	  (TI83P_k83_00end + 20)
#define TI83P_kedier	  (TI83P_k83_00end + 21)
#define TI83P_kcapiacute  (TI83P_k83_00end + 22)
#define TI83P_kcapigrave  (TI83P_k83_00end + 23)
#define TI83P_kcapicaret  (TI83P_k83_00end + 24)
#define TI83P_kcapidier  (TI83P_k83_00end + 25)
#define TI83P_kiacute	  (TI83P_k83_00end + 26)
#define TI83P_kigrave	  (TI83P_k83_00end + 27)
#define TI83P_kicaret	  (TI83P_k83_00end + 28)
#define TI83P_kidier	  (TI83P_k83_00end + 29)
#define TI83P_kcapoacute  (TI83P_k83_00end + 30)
#define TI83P_kcapograve  (TI83P_k83_00end + 31)
#define TI83P_kcapocaret  (TI83P_k83_00end + 32)
#define TI83P_kcapodier  (TI83P_k83_00end + 33)
#define TI83P_koacute	  (TI83P_k83_00end + 34)
#define TI83P_kograve	  (TI83P_k83_00end + 35)
#define TI83P_kocaret	  (TI83P_k83_00end + 36)
#define TI83P_kodier	  (TI83P_k83_00end + 37)
#define TI83P_kcapuacute  (TI83P_k83_00end + 38)
#define TI83P_kcapugrave  (TI83P_k83_00end + 39)
#define TI83P_kcapucaret  (TI83P_k83_00end + 40)
#define TI83P_kcapudier  (TI83P_k83_00end + 41)
#define TI83P_kuacute	  (TI83P_k83_00end + 42)
#define TI83P_kugrave	  (TI83P_k83_00end + 43)
#define TI83P_kucaret	  (TI83P_k83_00end + 44)
#define TI83P_kudier	  (TI83P_k83_00end + 45)
#define TI83P_kcapcced  (TI83P_k83_00end + 46)
#define TI83P_kcced	  (TI83P_k83_00end + 47)
#define TI83P_kcapntilde  (TI83P_k83_00end + 48)
#define TI83P_kntilde	  (TI83P_k83_00end + 49)
#define TI83P_kaccent	  (TI83P_k83_00end + 50)
#define TI83P_kgrave	  (TI83P_k83_00end + 51)
#define TI83P_kdieresis  (TI83P_k83_00end + 52)
#define TI83P_kquesdown  (TI83P_k83_00end + 53)
#define TI83P_kexclamdown       (TI83P_k83_00end + 54)
#define TI83P_kalpha            (TI83P_k83_00end + 55)
#define TI83P_kbeta             (TI83P_k83_00end +  56)
#define TI83P_kgamma            (TI83P_k83_00end +  57)
#define TI83P_kcapdelta         (TI83P_k83_00end +  58)
#define TI83P_kdelta            (TI83P_k83_00end +  59)
#define TI83P_kepsilon          (TI83P_k83_00end +  60)
#define TI83P_klambda           (TI83P_k83_00end +  61)
#define TI83P_kmu               (TI83P_k83_00end +  62)
#define TI83P_kpi2              (TI83P_k83_00end +  63)
#define TI83P_krho              (TI83P_k83_00end +  64)
#define TI83P_kcapsigma         (TI83P_k83_00end +  65)
#define TI83P_ksigma            (TI83P_k83_00end +  66)
#define TI83P_ktau              (TI83P_k83_00end +  67)
#define TI83P_kphi              (TI83P_k83_00end +  68)
#define TI83P_kcapomega         (TI83P_k83_00end +  69)
#define TI83P_kphat             (TI83P_k83_00end +  70)
#define TI83P_kchi2             (TI83P_k83_00end +  71)
#define TI83P_kstatf2           (TI83P_k83_00end +  72)
#define TI83P_kla	  (TI83P_k83_00end + 73)
#define TI83P_klb	  (TI83P_k83_00end + 74)
#define TI83P_klc	  (TI83P_k83_00end + 75)
#define TI83P_kld	  (TI83P_k83_00end + 76)
#define TI83P_kle	  (TI83P_k83_00end + 77)
#define TI83P_klf	  (TI83P_k83_00end + 78)
#define TI83P_klg	  (TI83P_k83_00end + 79)
#define TI83P_klh	  (TI83P_k83_00end + 80)
#define TI83P_kli	  (TI83P_k83_00end + 81)
#define TI83P_klj	  (TI83P_k83_00end + 82)
#define TI83P_klk	  (TI83P_k83_00end + 83)
#define TI83P_kll	  (TI83P_k83_00end + 84)
#define TI83P_klm	  (TI83P_k83_00end + 85)
#define TI83P_klsmalln  (TI83P_k83_00end +  86)
#define TI83P_klo	  (TI83P_k83_00end +  87)
#define TI83P_klp	  (TI83P_k83_00end +  88)
#define TI83P_klq	  (TI83P_k83_00end +  89)
#define TI83P_klsmallr  (TI83P_k83_00end +  90)
#define TI83P_kls	  (TI83P_k83_00end +  91)
#define TI83P_klt	  (TI83P_k83_00end +  92)
#define TI83P_klu	  (TI83P_k83_00end +  93)
#define TI83P_klv	  (TI83P_k83_00end +  94)
#define TI83P_klw	  (TI83P_k83_00end +  95)
#define TI83P_klx	  (TI83P_k83_00end +  96)
#define TI83P_kly	  (TI83P_k83_00end +  97)
#define TI83P_klz	  (TI83P_k83_00end +  98)
#define TI83P_kgarbagec  (TI83P_k83_00end +  99)// garbagecollect
//
#define TI83P_ke2bt2_end  (TI83P_kgarbagec)
//
//= ()=====================================================================
//           ti-83 plus context equates
//= ()=====================================================================
//
#define TI83P_cxcmd             (TI83P_kquit)//home screen
#define TI83P_cxmatedit         (TI83P_kmatrixed)//matrix editor
#define TI83P_cxprgmedit        (TI83P_kprgmed)//program editor
#define TI83P_cxequedit         (TI83P_kyequ)//equation editor
#define TI83P_cxgrrange         (TI83P_kwindow)//graph range editor
#define TI83P_cxgrzfact         (TI83P_kzfacted)//graph zoom factors editor
#define TI83P_cxgraph           (TI83P_kgraph)//graph mode
#define TI83P_cxstatedit        (TI83P_kstated)//statistics list editor
#define TI83P_cxprgminput       (TI83P_kprgminput)//programmed input
#define TI83P_cxerror           (TI83P_kerror)//error handler
#define TI83P_cxlinkio          (TI83P_klinkio)//link i/o interface
#define TI83P_cxmem             (TI83P_kresetmem)//reset memory
#define TI83P_cxdefmem          (TI83P_kresetdef)//reset default
#define TI83P_cxramapp          (TI83P_kchkram)//ram usage screen
#define TI83P_cxmode            (TI83P_kmode)//mode settings screen
#define TI83P_cxerase           (TI83P_kdelmem)//memory erase
#define TI83P_cxprgmcreate      (TI83P_kprgmcr)//program create
#define TI83P_cxtableeditor     (TI83P_ktable)//table editor
#define TI83P_cxtableset        (TI83P_ktblset)//table set up
#define TI83P_cxstatplot        (TI83P_kstatp)//stat plots
#define TI83P_cxinfstat   (TI83P_kinfstat)//inferential statistic
#define TI83P_cxformat          (TI83P_kformat)//format context
#define TI83P_cxsolvetvm        (TI83P_ksolvetvm)//solve tvm
#define TI83P_cxsolveroot       (TI83P_ksolveroot)//solve root
#define TI83P_lastoldapp        (TI83P_kextapps)//external applications
#define TI83P_cxextapps         (TI83P_kextapps)
#define TI83P_cxnewapps         (TI83P_knewapps)//new cerberus applications
#define TI83P_cxgroup           (TI83P_cxnewapps+0)//1st new app.
#define TI83P_cxungroup         (TI83P_cxnewapps+1)//2nd new app.
#define TI83P_lastnewapp        (TI83P_cxungroup)//last new app for this ver

//
//= ()=====================================================================
//           scan code equates
//= ()===================================================================== TI83P_;
#define TI83P_skdown            (0x01)
#define TI83P_skleft            (0x02)
#define TI83P_skright           (0x03)
#define TI83P_skup              (0x04)
#define TI83P_skenter           (0x09)
#define TI83P_skadd             (0x0a)
#define TI83P_sksub             (0x0b)
#define TI83P_skmul             (0x0c)
#define TI83P_skdiv             (0x0d)
#define TI83P_skpower           (0x0e)
#define TI83P_skclear           (0x0f)
#define TI83P_skchs             (0x11)
#define TI83P_sk3               (0x12)
#define TI83P_sk6               (0x13)
#define TI83P_sk9               (0x14)
#define TI83P_skrparen          (0x15)
#define TI83P_sktan             (0x16)
#define TI83P_skvars            (0x17)
#define TI83P_skdecpnt          (0x19)
#define TI83P_sk2               (0x1a)
#define TI83P_sk5               (0x1b)
#define TI83P_sk8               (0x1c)
#define TI83P_sklparen          (0x1d)
#define TI83P_skcos             (0x1e)
#define TI83P_skprgm            (0x1f)
#define TI83P_skstat            (0x20)
#define TI83P_sk0               (0x21)
#define TI83P_sk1               (0x22)
#define TI83P_sk4               (0x23)
#define TI83P_sk7               (0x24)
#define TI83P_skcomma           (0x25)
#define TI83P_sksin             (0x26)
#define TI83P_skmatrix          (0x27)
#define TI83P_skgraphvar        (0x28)
#define TI83P_skstore           (0x2a)
#define TI83P_skln              (0x2b)
#define TI83P_sklog             (0x2c)
#define TI83P_sksquare          (0x2d)
#define TI83P_skrecip           (0x2e)
#define TI83P_skmath            (0x2f)
#define TI83P_skalpha           (0x30)
#define TI83P_skgraph           (0x31)
#define TI83P_sktrace           (0x32)
#define TI83P_skzoom            (0x33)
#define TI83P_skwindow          (0x34)
#define TI83P_skyequ            (0x35)
#define TI83P_sk2nd             (0x36)
#define TI83P_skmode            (0x37)
#define TI83P_skdel             (0x38)
//
//= ()=====================================================================
//           tokens
//= ()=====================================================================
//
#define TI83P_eosstart          (0)
//
//
//   display conversions come immediately before 'tstore'
//
#define TI83P_dconv     (0x01)
//
#define TI83P_ttodms            (TI83P_dconv)//0x01
#define TI83P_ttodec            (TI83P_dconv+1)//0x02
#define TI83P_ttoabc            (TI83P_dconv+2)//0x03   > a b/c
//
#define TI83P_tstore            (TI83P_dconv+3)//0x04lstore                01
//
#define TI83P_tboxplot          (0x05)
//
#define TI83P_bracks            (0x06)
//
#define TI83P_tlbrack           (TI83P_bracks)//0x06'['
#define TI83P_trbrack           (TI83P_bracks+1)//0x07']'
#define TI83P_tlbrace           (TI83P_bracks+2)//0x08'{'
#define TI83P_trbrace           (TI83P_bracks+3)//0x09'}'
//
#define TI83P_tpost1            (TI83P_bracks+4)
//
#define TI83P_tfromrad          (TI83P_tpost1)//0x0alradian
#define TI83P_tfromdeg          (TI83P_tpost1+1)//0x0bldegree
#define TI83P_trecip            (TI83P_tpost1+2)//0x0clinverse
#define TI83P_tsqr              (TI83P_tpost1+3)//0x0dlsquare
#define TI83P_ttrnspos          (TI83P_tpost1+4)//0x0eltranspose
#define TI83P_tcube             (TI83P_tpost1+5)//0x0f'^3'
//
#define TI83P_tlparen           (0x10)// 10h '('
#define TI83P_trparen           (0x11)// 11h ')'
//
//
#define TI83P_imun              (0x12)
//
#define TI83P_tround            (TI83P_imun)//0x12'round'
#define TI83P_tpxtst            (TI83P_imun+1)//0x13'pxl-test'
#define TI83P_taug              (TI83P_imun+2)//0x14'aug'
#define TI83P_trowswap          (TI83P_imun+3)//0x15'rswap'
#define TI83P_trowplus          (TI83P_imun+4)//0x16'radd'
#define TI83P_tmrow             (TI83P_imun+5)//0x17'multr'
#define TI83P_tmrowplus         (TI83P_imun+6)//0x18'mradd'
#define TI83P_tmax              (TI83P_imun+7)//0x19'max'
#define TI83P_tmin              (TI83P_imun+8)//0x1a'min'
#define TI83P_trtopr            (TI83P_imun+9)//0x1b'r>pr'
#define TI83P_trtopo            (TI83P_imun+10)//0x1c'r>po'
#define TI83P_tptorx            (TI83P_imun+11)//0x1d'p>rx'
#define TI83P_tptory            (TI83P_imun+12)//0x1e'p>ry'
#define TI83P_tmedian           (TI83P_imun+13)//0x1f'median'
#define TI83P_trandm            (TI83P_imun+14)//0x20'randm'
#define TI83P_tmean             (TI83P_imun+15)//0x21
#define TI83P_troot             (TI83P_imun+16)//0x22'root'
#define TI83P_tseries           (TI83P_imun+17)//0x23'seq'
#define TI83P_tfnint            (TI83P_imun+18)//0x24'fnint'
#define TI83P_tnderiv           (TI83P_imun+19)//0x25'fnir'
#define TI83P_tevalf            (TI83P_imun+20)//0x26
#define TI83P_tfmin             (TI83P_imun+21)//0x27
#define TI83P_tfmax             (TI83P_imun+22)//0x28
//
#define TI83P_teosel            (TI83P_imun+23)
//
#define TI83P_tspace            (TI83P_teosel)//0x29  ' '
#define TI83P_tstring           (TI83P_teosel+1)//0x2a '"'
#define TI83P_tcomma            (TI83P_teosel+2)//0x2b ','
//
//
#define TI83P_tii               (0x2c)// i
//
//= ()=====================================================================
//           postfix functions
//= ()=====================================================================
//
#define TI83P_tpost             (0x2d)
//
#define TI83P_tfact             (TI83P_tpost)//0x2d'!'
//
#define TI83P_tcubicr           (0x2e)
#define TI83P_tquartr           (0x2f)

//= ()=====================================================================
//           number tokens 
//= ()=====================================================================
//
#define TI83P_nums              (0x30)
//
#define TI83P_t0                (TI83P_nums)//0x30
#define TI83P_t1                (TI83P_nums+1)//0x31
#define TI83P_t2                (TI83P_nums+2)//0x32
#define TI83P_t3                (TI83P_nums+3)//0x33
#define TI83P_t4                (TI83P_nums+4)//0x34
#define TI83P_t5                (TI83P_nums+5)//0x35
#define TI83P_t6                (TI83P_nums+6)//0x36
#define TI83P_t7                (TI83P_nums+7)//0x37
#define TI83P_t8                (TI83P_nums+8)//0x38
#define TI83P_t9                (TI83P_nums+9)//0x39
#define TI83P_tdecpt            (TI83P_nums+10)//0x3a
#define TI83P_tee               (TI83P_nums+11)//0x3b
//
//= ()=====================================================================
//            binary op
//= ()=====================================================================
//
#define TI83P_tor               (0x3c)// 3ch  '_or_'
#define TI83P_txor              (0x3d)//0x3d
//
#define TI83P_tcolon            (0x3e)// 3eh ':'
#define TI83P_tenter            (0x3f)// 3fh  lenter
//
#define TI83P_tand              (0x40)// 40h  '_and_'       
//
//= ()=====================================================================
//            letter tokens   
//= ()=====================================================================

//
#define TI83P_let               (0x41)
//
#define TI83P_ta                (TI83P_let)//0x41
#define TI83P_tb                (TI83P_let+1)//0x42
#define TI83P_tc                (TI83P_let+2)//0x43
#define TI83P_td                (TI83P_let+3)//0x44
#define TI83P_te                (TI83P_let+4)//0x45
#define TI83P_tf                (TI83P_let+5)//0x46
#define TI83P_tg                (TI83P_let+6)//0x47
#define TI83P_th                (TI83P_let+7)//0x48
#define TI83P_ti                (TI83P_let+8)//0x49
#define TI83P_tj                (TI83P_let+9)//0x4a
#define TI83P_tk                (TI83P_let+10)//0x4b
#define TI83P_tl                (TI83P_let+11)//0x4c
#define TI83P_tm                (TI83P_let+12)//0x4d
#define TI83P_tn                (TI83P_let+13)//0x4e
#define TI83P_to                (TI83P_let+14)//0x4f
#define TI83P_tp                (TI83P_let+15)//0x50
#define TI83P_tq                (TI83P_let+16)//0x51
#define TI83P_tr                (TI83P_let+17)//0x52
#define TI83P_ts                (TI83P_let+18)//0x53
#define TI83P_tt                (TI83P_let+19)//0x54
#define TI83P_tu                (TI83P_let+20)//0x55
#define TI83P_tv                (TI83P_let+21)//0x56
#define TI83P_tw                (TI83P_let+22)//0x57
#define TI83P_tx                (TI83P_let+23)//0x58
#define TI83P_ty                (TI83P_let+24)//0x59
#define TI83P_tz                (TI83P_let+25)//0x5a
#define TI83P_ttheta            (TI83P_let+26)//0x5b
//
//= ()=====================================================================
//   these var tokens are 1st of a double token 
//= ()=====================================================================

//
#define TI83P_vtoks     (TI83P_let+27)//
//
//       user matrix token, 2nd token needed for name
//
#define TI83P_tvarmat           (TI83P_vtoks)//0x5c
//
//       user list token, 2nd token needed for name
//
#define TI83P_tvarlst           (TI83P_vtoks+1)//0x5d
//
//       user equation token, 2nd token needed for name
//
#define TI83P_tvarequ           (TI83P_vtoks+2)//0x5e
#define TI83P_tprog             (TI83P_vtoks+3)//0x5f
//
//       user pict token, 2nd token needed for name
//
#define TI83P_tvarpict          (TI83P_vtoks+4)//0x60
//
//       user gdb token, 2nd token needed for name
//
#define TI83P_tvargdb           (TI83P_vtoks+5)//0x61
#define TI83P_tvarout           (TI83P_vtoks+6)//0x62
#define TI83P_tvarsys           (TI83P_vtoks+7)//0x63
//
//
//= ()=====================================================================
//            mode setting commands
//= ()=====================================================================

//
#define TI83P_modesa            (TI83P_vtoks+8)//0x64
//
#define TI83P_trad              (TI83P_modesa)//0x64'radian'
#define TI83P_tdeg              (TI83P_modesa+1)//0x65'degree'
#define TI83P_tnormf            (TI83P_modesa+2)//0x66'normal'
#define TI83P_tsci              (TI83P_modesa+3)//0x67'sci'
#define TI83P_teng              (TI83P_modesa+4)//0x68'eng'
#define TI83P_tfloat            (TI83P_modesa+5)//0x69'float'
//
#define TI83P_cmps              (0x6a)
//
#define TI83P_teq               (TI83P_cmps)//0x6a'=='
#define TI83P_tlt               (TI83P_cmps+1)//0x6b'<'
#define TI83P_tgt               (TI83P_cmps+2)//0x6c'>'
#define TI83P_tle               (TI83P_cmps+3)//0x6dlle
#define TI83P_tge               (TI83P_cmps+4)//0x6elge
#define TI83P_tne               (TI83P_cmps+5)//0x6flne
//
//= ()=====================================================================
//            binary op
//= ()=====================================================================
//
#define TI83P_tadd              (0x70)// 70h '+'
#define TI83P_tsub              (0x71)// 71h '-'
#define TI83P_tans              (0x72)//0x72
//
//= ()=====================================================================
//            mode setting commands
//= ()=====================================================================
//
#define TI83P_modes             (0x73)
//
#define TI83P_tfix              (TI83P_modes)//0x73'fix_'
#define TI83P_tspliton          (TI83P_modes+1)//0x74
#define TI83P_tfullscreen       (TI83P_modes+2)//0x75
#define TI83P_tstndrd           (TI83P_modes+3)//0x76'func'
#define TI83P_tparam            (TI83P_modes+4)//0x77'param'
#define TI83P_tpolar            (TI83P_modes+5)//0x78'pol'
#define TI83P_tseqg             (TI83P_modes+6)//0x79
#define TI83P_tafillon          (TI83P_modes+7)//0x7a'auto fill on'
#define TI83P_tafilloff         (TI83P_modes+8)//0x7b
#define TI83P_tacalcon          (TI83P_modes+9)//0x7c
#define TI83P_tacalcoff         (TI83P_modes+10)//0x7d'autofill off '
//
//       graph format tokens are 2 byte tokens
//
#define TI83P_tgformat          (TI83P_modes+11)//0x7e
//
#define TI83P_tboxicon          (0x7f)
#define TI83P_tcrossicon        (0x80)
#define TI83P_tdoticon          (0x81)
//
//= ()=====================================================================
//            (more) binary op
//= ()=====================================================================
//
#define TI83P_tmul              (0x82)// 82h  '*'
#define TI83P_tdiv              (0x83)// 83h  '/'
//
//= ()=====================================================================
//            some graph commands
//= ()=====================================================================
//
#define TI83P_grcmds            (0x84)
//
#define TI83P_ttrace            (TI83P_grcmds)//0x84'trace'
#define TI83P_tcldrw            (TI83P_grcmds+1)//0x85'cldrw'
#define TI83P_tzoomstd          (TI83P_grcmds+2)//0x86'zstd'
#define TI83P_tzoomtrg          (TI83P_grcmds+3)//0x87'ztrg'
#define TI83P_tzoombox          (TI83P_grcmds+4)//0x88'zbox'
#define TI83P_tzoomin           (TI83P_grcmds+5)//0x89'zin'
#define TI83P_tzoomout          (TI83P_grcmds+6)//0x8a'zout'
#define TI83P_tzoomsqr          (TI83P_grcmds+7)//0x8b'zsqr'
#define TI83P_tzoomint          (TI83P_grcmds+8)//0x8c'zint'
#define TI83P_tzoomprev         (TI83P_grcmds+9)//0x8d'zprev'
#define TI83P_tzoomdec          (TI83P_grcmds+10)//0x8e'zdecm'
#define TI83P_tzoomstat         (TI83P_grcmds+11)//0x8f'zstat'
#define TI83P_tusrzm            (TI83P_grcmds+12)//0x90'zrcl'
#define TI83P_tprtscrn          (TI83P_grcmds+13)//0x91'prtscrn'
#define TI83P_tzoomsto          (TI83P_grcmds+14)//0x92 zoom store
#define TI83P_ttext             (TI83P_grcmds+15)//0x93
//
//= ()=====================================================================
//           binary op  (combination & permutation)
//= ()=====================================================================
//
#define TI83P_tnpr              (TI83P_grcmds+16)//0x94'_npr_'
#define TI83P_tncr              (TI83P_grcmds+17)//0x95'_ncr_'
//
//= ()=====================================================================
//           more graph commands
//= ()=====================================================================
//
#define TI83P_tyon              (TI83P_grcmds+18)//0x96'fnon_'
#define TI83P_tyoff             (TI83P_grcmds+19)//0x97'fnoff_'
#define TI83P_tstpic            (TI83P_grcmds+20)//0x98'stpic_'
#define TI83P_trcpic            (TI83P_grcmds+21)//0x99'rcpic_'
#define TI83P_tstodb            (TI83P_grcmds+22)//0x9a'stgdb_'
#define TI83P_trcldb            (TI83P_grcmds+23)//0x9b'rcgdb_'
#define TI83P_tline             (TI83P_grcmds+24)//0x9c'line'
#define TI83P_tvert             (TI83P_grcmds+25)//0x9d'vert_'
#define TI83P_tpton             (TI83P_grcmds+26)//0x9e'pton'
#define TI83P_tptoff            (TI83P_grcmds+27)//0x9f'ptoff'
//
//= ()=====================================================================
//           token a0 cannot be an eos function
//           since low mult= (TI83P_a0 already)
//= ()=====================================================================
//
#define TI83P_tptchg            (TI83P_grcmds+28)//0xa0'ptchg'
#define TI83P_tpxon             (TI83P_grcmds+29)//0xa1
#define TI83P_tpxoff            (TI83P_grcmds+30)//0xa2
#define TI83P_tpxchg            (TI83P_grcmds+31)//0xa3
#define TI83P_tshade            (TI83P_grcmds+32)//0xa4'shade'
#define TI83P_tcircl            (TI83P_grcmds+33)//0xa5'circl'
#define TI83P_thorz             (TI83P_grcmds+34)//0xa6'horizontal'
#define TI83P_ttanln            (TI83P_grcmds+35)//0xa7'tanln'
#define TI83P_tdrinv            (TI83P_grcmds+36)//0xa8'drinv_'
#define TI83P_tdrawf            (TI83P_grcmds+37)//0xa9'drawf_'
//
#define TI83P_tvarstrng         (0x0aa)
//
//= ()=====================================================================
//           functions with no arguments                                    
//= ()=====================================================================
//
#define TI83P_noarg     (0x0ab)
//
#define TI83P_trand             (TI83P_noarg)//0xab'rand'
#define TI83P_tpi               (TI83P_noarg+1)//0xac lpi
#define TI83P_tgetkey           (TI83P_noarg+2)//0xad'getky'
//
//
#define TI83P_tapost            (TI83P_tgetkey+1)// apostrophy
#define TI83P_tquest            (TI83P_tapost+1)// question mark
//
//
#define TI83P_unary     (TI83P_tquest+1)//0xb0
//
#define TI83P_tchs              (TI83P_unary)//0xb0
#define TI83P_tint              (TI83P_unary+1)//0xb1
#define TI83P_tabs              (TI83P_unary+2)//0xb2
#define TI83P_tdet              (TI83P_unary+3)//0xb3
#define TI83P_tident            (TI83P_unary+4)//0xb4
#define TI83P_tdim              (TI83P_unary+5)//0xb5
#define TI83P_tsum              (TI83P_unary+6)//0xb6
#define TI83P_tprod             (TI83P_unary+7)//0xb7
#define TI83P_tnot              (TI83P_unary+8)//0xb8
#define TI83P_tipart            (TI83P_unary+9)//0xb9
#define TI83P_tfpart            (TI83P_unary+10)//0xba
//
//
//= ()=====================================================================
//           new 2 byte tokens
//= ()=====================================================================
//
#define TI83P_t2bytetok         (0x0bb)//
//
//
#define TI83P_unarylr   (TI83P_unary+12)
//
#define TI83P_tsqrt             (TI83P_unarylr)//0xbc
#define TI83P_tcubrt            (TI83P_unarylr+1)//0xbd
#define TI83P_tln               (TI83P_unarylr+2)//0xbe
#define TI83P_texp              (TI83P_unarylr+3)//0xbf
#define TI83P_tlog              (TI83P_unarylr+4)//0xc0
#define TI83P_talog             (TI83P_unarylr+5)//0xc1
#define TI83P_tsin              (TI83P_unarylr+6)//0xc2
#define TI83P_tasin             (TI83P_unarylr+7)//0xc3
#define TI83P_tcos              (TI83P_unarylr+8)//0xc4
#define TI83P_tacos             (TI83P_unarylr+9)//0xc5
#define TI83P_ttan              (TI83P_unarylr+10)//0xc6
#define TI83P_tatan             (TI83P_unarylr+11)//0xc7
#define TI83P_tsinh             (TI83P_unarylr+12)//0xc8
#define TI83P_tasinh            (TI83P_unarylr+13)//0xc9
#define TI83P_tcoshh            (TI83P_unarylr+14)//0xca
#define TI83P_tacosh            (TI83P_unarylr+15)//0xcb
#define TI83P_ttanh             (TI83P_unarylr+16)//0xcc
#define TI83P_tatanh            (TI83P_unarylr+17)//0xcd
// 
//= ()=====================================================================
//           some programming commands                                      
//= ()=====================================================================
//
#define TI83P_progtok   (TI83P_unarylr+18)
//
#define TI83P_tif               (TI83P_progtok)//0xce
#define TI83P_tthen             (TI83P_progtok+1)//0xcf
#define TI83P_telse             (TI83P_progtok+2)//0xd0
#define TI83P_twhile            (TI83P_progtok+3)//0xd1
#define TI83P_trepeat           (TI83P_progtok+4)//0xd2
#define TI83P_tfor              (TI83P_progtok+5)//0xd3
#define TI83P_tend              (TI83P_progtok+6)//0xd4
#define TI83P_treturn           (TI83P_progtok+7)//0xd5
#define TI83P_tlbl              (TI83P_progtok+8)//0xd6  'lbl_'
#define TI83P_tgoto             (TI83P_progtok+9)//0xd7  'goto_'
#define TI83P_tpause            (TI83P_progtok+10)//0xd8  'pause_'
#define TI83P_tstop             (TI83P_progtok+11)//0xd9  'stop'
#define TI83P_tisg              (TI83P_progtok+12)//0xda  'is>'
#define TI83P_tdsl              (TI83P_progtok+13)//0xdb  'ds<'
#define TI83P_tinput            (TI83P_progtok+14)//0xdc  'input_'
#define TI83P_tprompt           (TI83P_progtok+15)//0xdd  'prompt_'
#define TI83P_tdisp             (TI83P_progtok+16)//0xde  'disp_'
#define TI83P_tdispg            (TI83P_progtok+17)//0xdf  'dispg'
//
#define TI83P_toutput           (TI83P_progtok+18)//0xe0   'outpt'
#define TI83P_tcllcd            (TI83P_progtok+19)//0xe1   'cllcd'
#define TI83P_tconst            (TI83P_progtok+20)//0xe2   'fill'
#define TI83P_tsorta            (TI83P_progtok+21)//0xe3   'sorta_'
#define TI83P_tsortd            (TI83P_progtok+22)//0xe4   'sortd_'
#define TI83P_tdisptab          (TI83P_progtok+23)//0xe5   'disp table'
#define TI83P_tmenu             (TI83P_progtok+24)//0xe6   'menu'
#define TI83P_tsendmbl          (TI83P_progtok+25)//0xe7   'send'
#define TI83P_tgetmbl           (TI83P_progtok+26)//0xe8   'get'
//
//= ()=====================================================================
//           stat plot commands                                             
//= ()=====================================================================
//
#define TI83P_statpcmd          (TI83P_progtok+27)
//
#define TI83P_tploton           (TI83P_statpcmd)//0xe9    ' plotson'
#define TI83P_tplotoff          (TI83P_statpcmd+1)//0xea    ' plotsoff'
//
#define TI83P_tlistname         (0x0eb)// list designator
//
#define TI83P_tplot1            (0x0ec)
#define TI83P_tplot2            (0x0ed)
#define TI83P_tplot3            (0x0ee)
//
#define TI83P_tunused01         (0x0ef)//        available?
//
#define TI83P_tpower            (0x0f0)//        '^'
#define TI83P_txroot            (0x0f1)//        lsupx,lroot

#define TI83P_statcmd           (0x0f2)
//
#define TI83P_tonevar           (TI83P_statcmd)//0xf2   'onevar_'
#define TI83P_ttwovar           (TI83P_statcmd+1)//0xf3
#define TI83P_tlr               (TI83P_statcmd+2)//0xf4   'linr(a+bx'
#define TI83P_tlrexp            (TI83P_statcmd+3)//0xf5   'expr_'
#define TI83P_tlrln             (TI83P_statcmd+4)//0xf6   'lnr_'
#define TI83P_tlrpwr            (TI83P_statcmd+5)//0xf7   'pwrr_'
#define TI83P_tmedmed           (TI83P_statcmd+6)//0xf8
#define TI83P_tquad             (TI83P_statcmd+7)//0xf9
#define TI83P_tclrlst           (TI83P_statcmd+8)//0xfa   'clear list'
#define TI83P_tclrtbl           (TI83P_statcmd+9)//0xfb   clear table
#define TI83P_thist             (TI83P_statcmd+10)//0xfc   'hist_'
#define TI83P_txyline           (TI83P_statcmd+11)//0xfd   'xyline_'
#define TI83P_tscatter          (TI83P_statcmd+12)//0xfe   'scatter_'
#define TI83P_tlr1              (TI83P_statcmd+13)//0xff   'linr(ax+b'

//       
//= ()=====================================================================
//           2nd half of graph format tokens
//= ()=====================================================================
//           format settings commands
//
#define TI83P_gfmt              (0)
//
#define TI83P_tseq              (TI83P_gfmt)// 'seqg'
#define TI83P_tsimulg           (TI83P_gfmt+1)// 'simulg'
#define TI83P_tpolarg           (TI83P_gfmt+2)// 'polargc'
#define TI83P_trectg            (TI83P_gfmt+3)// 'rectgc'
#define TI83P_tcoordon          (TI83P_gfmt+4)// 'coordon'
#define TI83P_tcoordoff         (TI83P_gfmt+5)// 'coordoff'
#define TI83P_tdrawline         (TI83P_gfmt+6)// 'drawline'
#define TI83P_tdrawdot          (TI83P_gfmt+7)// 'drawdot'
#define TI83P_taxison           (TI83P_gfmt+8)// 'axeson'
#define TI83P_taxisoff          (TI83P_gfmt+9)// 'axesoff'
#define TI83P_tgridon           (TI83P_gfmt+10)// 'gridon'
#define TI83P_tgridoff          (TI83P_gfmt+11)// 'gridoff'
#define TI83P_tlblon            (TI83P_gfmt+12)// 'labelon'
#define TI83P_tlbloff           (TI83P_gfmt+13)// 'labeloff'
#define TI83P_twebon            (TI83P_gfmt+14)// 'webon'
#define TI83P_tweboff           (TI83P_gfmt+15)// 'weboff'
#define TI83P_tuv               (TI83P_gfmt+16)// u vs v
#define TI83P_tvw               (TI83P_gfmt+17)// v vs w
#define TI83P_tuw               (TI83P_gfmt+18)// u vs w
//
//= ()=====================================================================
//           2nd half of user matrix tokens                                 
//= ()=====================================================================
//
#define TI83P_tmata             (0x00)// mat a
#define TI83P_tmatb             (0x01)// mat b
#define TI83P_tmatc             (0x02)// mat c
#define TI83P_tmatd             (0x03)// mat d
#define TI83P_tmate             (0x04)// mat e
#define TI83P_tmatf             (0x05)// mat f
#define TI83P_tmatg             (0x06)// mat g
#define TI83P_tmath             (0x07)// mat0x
#define TI83P_tmati             (0x08)// mat i
#define TI83P_tmatj             (0x09)// mat j
//      
//= ()=====================================================================
//           2nd half of user list tokens
//= ()=====================================================================
//
#define TI83P_tl1               (0x00)// list 1
#define TI83P_tl2               (0x01)// list 2
#define TI83P_tl3               (0x02)// list 3
#define TI83P_tl4               (0x03)// list 4
#define TI83P_tl5               (0x04)// list 5
#define TI83P_tl6               (0x05)// list 6

//
//= ()=====================================================================
//           2nd half of user equation tokens
//= ()=====================================================================
//
//       "y" equations have bit 4 set
//
#define TI83P_ty1               (0x10)// y1
#define TI83P_ty2               (0x11)// y2
#define TI83P_ty3               (0x12)// y3
#define TI83P_ty4               (0x13)// y4
#define TI83P_ty5               (0x14)// y5
#define TI83P_ty6               (0x15)// y6
#define TI83P_ty7               (0x16)// y7
#define TI83P_ty8               (0x17)// y8
#define TI83P_ty9               (0x18)// y9
#define TI83P_ty0               (0x19)// y0
//
//       param equations have bit 5 set
//
#define TI83P_tx1t              (0x20)// x1t
#define TI83P_ty1t              (0x21)// y1t
#define TI83P_tx2t              (0x22)// x2t
#define TI83P_ty2t              (0x23)// y2t
#define TI83P_tx3t              (0x24)// x3t
#define TI83P_ty3t              (0x25)// y3t
#define TI83P_tx4t              (0x26)// x4t
#define TI83P_ty4t              (0x27)// y4t
#define TI83P_tx5t              (0x28)// x5t
#define TI83P_ty5t              (0x29)// y5t
#define TI83P_tx6t              (0x2a)// x6t
#define TI83P_ty6t              (0x2b)// y6t
//
//       polar equations have bit 6 set
//
#define TI83P_tr1               (0x40)// r1
#define TI83P_tr2               (0x41)// r2
#define TI83P_tr3               (0x42)// r3
#define TI83P_tr4               (0x43)// r4
#define TI83P_tr5               (0x44)// r5
#define TI83P_tr6               (0x45)// r6
//
//       recursion equations have bit 7 set
//
#define TI83P_tun               (0x80)// un
#define TI83P_tvn               (0x81)// vn
#define TI83P_twn               (0x82)// wn
//
//= ()=====================================================================
//           2nd half of user picture tokens                                
//= ()=====================================================================
//
#define TI83P_tpic1             (0x00)// pic1
#define TI83P_tpic2             (0x01)// pic2
#define TI83P_tpic3             (0x02)// pic3
#define TI83P_tpic4             (0x03)// pic4
#define TI83P_tpic5             (0x04)// pic5
#define TI83P_tpic6             (0x05)// pic6
#define TI83P_tpic7             (0x06)// pic7
#define TI83P_tpic8             (0x07)// pic8
#define TI83P_tpic9             (0x08)// pic9
#define TI83P_tpic0             (0x09)// pic0
// 
//= ()=====================================================================
//           2nd half of user graph database tokens                         
//= ()=====================================================================
//
#define TI83P_tgdb1             (0x00)// gdb1
#define TI83P_tgdb2             (0x01)// gdb2
#define TI83P_tgdb3             (0x02)// gdb3
#define TI83P_tgdb4             (0x03)// gdb4
#define TI83P_tgdb5             (0x04)// gdb5
#define TI83P_tgdb6             (0x05)// gdb6
#define TI83P_tgdb7             (0x06)// gdb7
#define TI83P_tgdb8             (0x07)// gdb8
#define TI83P_tgdb9             (0x08)// gdb9
#define TI83P_tgdb0             (0x09)// gdb0
//  
//= ()=====================================================================
//           2nd half of string vars                                        
//= ()=====================================================================
//
#define TI83P_tstr1             (0x00)
#define TI83P_tstr2             (0x01)
#define TI83P_tstr3             (0x02)
#define TI83P_tstr4             (0x03)
#define TI83P_tstr5             (0x04)
#define TI83P_tstr6             (0x05)
#define TI83P_tstr7             (0x06)
#define TI83P_tstr8             (0x07)
#define TI83P_tstr9             (0x08)
#define TI83P_tstr0             (0x09)

// 
//= ()=====================================================================
//           2nd half of system output only variables                       
//= ()=====================================================================
//
//
//   open        = (0x00)
//
#define TI83P_tregeq            (0x01)// regression equation
//
#define TI83P_tstatn            (0x02)// statistics n
//
#define TI83P_txmean            (0x03)// x mean
#define TI83P_tsumx             (0x04)// sum(x)
#define TI83P_tsumxsqr          (0x05)// sum(x^2)
#define TI83P_tstdx             (0x06)// standard dev x
#define TI83P_tstdpx            (0x07)// standard dev pop x
#define TI83P_tminx             (0x08)// min x value
#define TI83P_tmaxx             (0x09)// max x value
//
#define TI83P_tminy             (0x0a)// min y value
#define TI83P_tmaxy             (0x0b)// max y value
#define TI83P_tymean            (0x0c)// y mean
#define TI83P_tsumy             (0x0d)// sum(y)
#define TI83P_tsumysqr          (0x0e)// sum(y^2)
#define TI83P_tstdy             (0x0f)// standard dev y
#define TI83P_tstdpy            (0x10)// standard dev pop y
//
#define TI83P_tsumxy            (0x11)// sum(xy)
#define TI83P_tcorr             (0x12)// correlation
#define TI83P_tmedx             (0x13)// med(x)
#define TI83P_tq1               (0x14)// 1st quadrant of x
#define TI83P_tq3               (0x15)// 3rd quadrant of x
#define TI83P_tquada            (0x16)// 1st term of quad poly reg/ y-int
#define TI83P_tquadb            (0x17)// 2nd term of quad poly reg/ slope
#define TI83P_tquadc            (0x18)// 3rd term of quad poly reg
#define TI83P_tcubed            (0x19)// 4th term of cubic poly reg
#define TI83P_tquarte           (0x1a)// 5th term of quart poly reg
#define TI83P_tmedx1            (0x1b)// x1 for med-med
#define TI83P_tmedx2            (0x1c)// x2 for med-med
#define TI83P_tmedx3            (0x1d)// x3 for med-med
#define TI83P_tmedy1            (0x1e)// y1 for med-med
#define TI83P_tmedy2            (0x1f)// y2 for med-med
#define TI83P_tmedy3            (0x20)// y3 for med-med
//
#define TI83P_trecurn	  (0x21)// recursion n
#define TI83P_tstatp            (0x22)
#define TI83P_tstatz            (0x23)
#define TI83P_tstatt            (0x24)
#define TI83P_tstatchi          (0x25)
#define TI83P_tstatf            (0x26)
#define TI83P_tstatdf           (0x27)
#define TI83P_tstatphat         (0x28)
#define TI83P_tstatphat1        (0x29)
#define TI83P_tstatphat2        (0x2a)
#define TI83P_tstatmeanx1       (0x2b)
#define TI83P_tstatstdx1        (0x2c)
#define TI83P_tstatn1           (0x2d)
#define TI83P_tstatmeanx2       (0x2e)
#define TI83P_tstatstdx2        (0x2f)
#define TI83P_tstatn2           (0x30)
#define TI83P_tstatstdxp        (0x31)
#define TI83P_tstatlower        (0x32)
#define TI83P_tstatupper        (0x33)
#define TI83P_tstat_s           (0x34)
#define TI83P_tlrsqr            (0x35)// r^2
#define TI83P_tbrsqr            (0x36)// r^2
//
//= ()=====================================================================
//       these next tokens are only used to access the data
//       they are display only and the user cannot access them at all
//= ()=====================================================================
//
#define TI83P_tf_df      (0x37)// anofav factor df
#define TI83P_tf_ss      (0x38)// anofav factor ss
#define TI83P_tf_ms      (0x39)// anofav factor ms
#define TI83P_te_df      (0x3a)// anofav error df
#define TI83P_te_ss      (0x3b)// anofav error ss
#define TI83P_te_ms      (0x3c)// anofav error ms
//
//
//= ()=====================================================================
//           2nd half of system input/output variables
//= ()=====================================================================
//      system variable equates
//
#define TI83P_tuxscl         (0)
#define TI83P_tuyscl         (1)
#define TI83P_txscl          (2)
#define TI83P_tyscl          (3)
#define TI83P_trecuru0       (4)// u 1st initial cond
#define TI83P_trecurv0       (5)// v 1st initial cond
#define TI83P_tun1           (6)// u(n-1)    ; not used
#define TI83P_tvn1           (7)// v(n-1)    ; not used
#define TI83P_turecuru0      (8)//
#define TI83P_turecurv0      (9)//
//
#define TI83P_txmin          (0x0a)
#define TI83P_txmax          (0x0b)
#define TI83P_tymin          (0x0c)
#define TI83P_tymax          (0x0d)
#define TI83P_ttmin          (0x0e)
#define TI83P_ttmax          (0x0f)
#define TI83P_tthetamin      (0x10)
#define TI83P_tthetamax      (0x11)
#define TI83P_tuxmin         (0x12)
#define TI83P_tuxmax         (0x13)
#define TI83P_tuymin         (0x14)
#define TI83P_tuymax         (0x15)
#define TI83P_tuthetmin      (0x16)
#define TI83P_tuthetmax      (0x17)
#define TI83P_tutmin         (0x18)
#define TI83P_tutmax         (0x19)
#define TI83P_ttblmin        (0x1a)
#define TI83P_tplotstart     (0x1b)
#define TI83P_tuplotstart    (0x1c)
#define TI83P_tnmax          (0x1d)
#define TI83P_tunmax         (0x1e)
#define TI83P_tnmin          (0x1f)
#define TI83P_tunmin         (0x20)
//
#define TI83P_ttblstep  (0x21)
#define TI83P_ttstep	  (0x22)
#define TI83P_tthetastep  (0x23)
#define TI83P_tutstep	  (0x24)
#define TI83P_tuthetstep  (0x25)
//
#define TI83P_tdeltax	  (0x26)
#define TI83P_tdeltay	  (0x27)
//
#define TI83P_txfact	  (0x28)
#define TI83P_tyfact	  (0x29)
//
#define TI83P_ttblinput         (0x2a)
//
#define TI83P_tfinn             (0x2b)
#define TI83P_tfini             (0x2c)
#define TI83P_tfinpv            (0x2d)
#define TI83P_tfinpmt           (0x2e)
#define TI83P_tfinfv            (0x2f)
#define TI83P_tfinpy            (0x30)
#define TI83P_tfincy            (0x31)
//
#define TI83P_trecurw0          (0x32)// w0(1)
#define TI83P_turecurw0         (0x33)
//
#define TI83P_tplotstep         (0x34)
#define TI83P_tuplotstep        (0x35)
//
#define TI83P_txres             (0x36)
#define TI83P_tuxres            (0x37)
//
#define TI83P_trecuru02         (0x38)// u0(2)
#define TI83P_turecuru02        (0x39)
#define TI83P_trecurv02         (0x3c)// v0(2)
#define TI83P_turecurv02        (0x3d)
#define TI83P_trecurw02         (0x3e)// w0(2)
#define TI83P_turecurw02        (0x3f)
//
//= ()=====================================================================
//           2nd byte of t2bytetok tokens
//= ()=====================================================================
//
#define TI83P_tfinnpv           (0x00)//
#define TI83P_tfinirr           (0x01)//
#define TI83P_tfinbal           (0x02)//
#define TI83P_tfinprn           (0x03)//
#define TI83P_tfinint           (0x04)//
#define TI83P_tfintonom         (0x05)//
#define TI83P_tfintoeff         (0x06)//
#define TI83P_tfindbd           (0x07)//
#define TI83P_tlcm              (0x08)//
#define TI83P_tgcd              (0x09)//
#define TI83P_trandint          (0x0a)//
#define TI83P_trandbin          (0x0b)//
#define TI83P_tsubstrng         (0x0c)//
#define TI83P_tstddev           (0x0d)//
#define TI83P_tvariance         (0x0e)//
#define TI83P_tinstrng          (0x0f)//
#define TI83P_tdnormal          (0x10)//
#define TI83P_tinvnorm          (0x11)//
#define TI83P_tdt               (0x12)//
#define TI83P_tchi              (0x13)//
#define TI83P_tdf               (0x14)//
#define TI83P_tbinpdf           (0x15)//
#define TI83P_tbincdf           (0x16)//
#define TI83P_tpoipdf           (0x17)//
#define TI83P_tpoicdf           (0x18)//
#define TI83P_tgeopdf           (0x19)//
#define TI83P_tgeocdf           (0x1a)//
#define TI83P_tnormalpdf        (0x1b)//
#define TI83P_ttpdf             (0x1c)//
#define TI83P_tchipdf           (0x1d)//
#define TI83P_tfpdf             (0x1e)//
#define TI83P_trandnorm         (0x1f)//
#define TI83P_tfinfpmt          (0x20)//
#define TI83P_tfinfi            (0x21)//
#define TI83P_tfinfpv           (0x22)//
#define TI83P_tfinfn            (0x23)//
#define TI83P_tfinffv           (0x24)//
#define TI83P_tconj             (0x25)//
#define TI83P_treal             (0x26)//
#define TI83P_timag             (0x27)//
#define TI83P_tangle            (0x28)//
#define TI83P_tcumsum           (0x29)//
#define TI83P_texpr             (0x2a)//
#define TI83P_tlength           (0x2b)//
#define TI83P_tdeltalst         (0x2c)//
#define TI83P_tref              (0x2d)//
#define TI83P_trref             (0x2e)//
#define TI83P_ttorect           (0x2f)//
#define TI83P_ttopolar          (0x30)//
#define TI83P_tconste           (0x31)//
#define TI83P_tsinreg           (0x32)//
#define TI83P_tlogistic         (0x33)//
#define TI83P_tlinregttest      (0x34)//
#define TI83P_tshadenorm        (0x35)//
#define TI83P_tshadet           (0x36)//
#define TI83P_tshadechi         (0x37)//
#define TI83P_tshadef           (0x38)//
#define TI83P_tmattolst         (0x39)//
#define TI83P_tlsttomat         (0x3a)//
#define TI83P_tztest            (0x3b)//
#define TI83P_tttest            (0x3c)//
#define TI83P_t2sampztest       (0x3d)//
#define TI83P_t1propztest       (0x3e)//
#define TI83P_t2propztest       (0x3f)//
#define TI83P_tchitest          (0x40)//
#define TI83P_tzintval          (0x41)//
#define TI83P_t2sampzint        (0x42)//
#define TI83P_t1propzint        (0x43)//
#define TI83P_t2propzint        (0x44)//
#define TI83P_tgraphstyle       (0x45)//
#define TI83P_t2sampttest       (0x46)//
#define TI83P_t2sampftest       (0x47)//
#define TI83P_ttintval          (0x48)//
#define TI83P_t2samptint        (0x49)//
#define TI83P_tsetuplst         (0x4a)//
#define TI83P_tfinpmtend        (0x4b)//
#define TI83P_tfinpmtbeg        (0x4c)//
#define TI83P_trealm            (0x4d)//
#define TI83P_tpolarm           (0x4e)//
#define TI83P_trectm            (0x4f)//
#define TI83P_texpron           (0x50)//
#define TI83P_texproff          (0x51)//
#define TI83P_tclralllst        (0x52)//
#define TI83P_tgetcalc          (0x53)//
#define TI83P_tdelvar           (0x54)//
#define TI83P_tequtostrng       (0x55)//
#define TI83P_tstrngtoequ       (0x56)//
#define TI83P_tdellast          (0x57)//
#define TI83P_tselect           (0x58)//
#define TI83P_tanova            (0x59)//
#define TI83P_tmodbox           (0x5a)//
#define TI83P_tnormprob         (0x5b)//
//
//
#define TI83P_tmgt              (0x64)// vertical split
#define TI83P_tzfit             (0x65)// zoom fit
#define TI83P_tdiag_on          (0x66)// dianostic display on
#define TI83P_tdiag_off         (0x67)// dianostic display off
#define TI83P_tokend2v0         (0x67)//end of 2byte tokens for version 0.
#define TI83P_tarchive          (0x68)//archive
#define TI83P_tunarchive        (0x69)//unarchive
#define TI83P_tasm	   (0x6a)
#define TI83P_tasmcomp   (0x6b)// asm compile
#define TI83P_tasmprgm   (0x6c)// signifies a program is asm
#define TI83P_tasmcmp    (0x6d)// asm program is compiled
//
#define TI83P_tlcapaacute       (0x6e)
#define TI83P_tlcapagrave       (0x6f)
#define TI83P_tlcapacaret       (0x70)
#define TI83P_tlcapadier        (0x71)
#define TI83P_tlaacute          (0x72)
#define TI83P_tlagrave          (0x73)
#define TI83P_tlacaret          (0x74)
#define TI83P_tladier           (0x75)
#define TI83P_tlcapeacute       (0x76)
#define TI83P_tlcapegrave       (0x77)
#define TI83P_tlcapecaret       (0x78)
#define TI83P_tlcapedier        (0x79)
#define TI83P_tleacute          (0x7a)
#define TI83P_tlegrave          (0x7b)
#define TI83P_tlecaret          (0x7c)
#define TI83P_tledier           (0x7d)
//
#define TI83P_tlcapigrave       (0x7f)
#define TI83P_tlcapicaret       (0x80)
#define TI83P_tlcapidier        (0x81)
#define TI83P_tliacute          (0x82)
#define TI83P_tligrave          (0x83)
#define TI83P_tlicaret          (0x84)
#define TI83P_tlidier           (0x85)
#define TI83P_tlcapoacute       (0x86)
#define TI83P_tlcapograve       (0x87)
#define TI83P_tlcapocaret       (0x88)
#define TI83P_tlcapodier        (0x89)
#define TI83P_tloacute          (0x8a)
#define TI83P_tlograve          (0x8b)
#define TI83P_tlocaret          (0x8c)
#define TI83P_tlodier           (0x8d)
#define TI83P_tlcapuacute       (0x8e)
#define TI83P_tlcapugrave       (0x8f)
#define TI83P_tlcapucaret       (0x90)
#define TI83P_tlcapudier        (0x91)
#define TI83P_tluacute          (0x92)
#define TI83P_tlugrave          (0x93)
#define TI83P_tlucaret          (0x94)
#define TI83P_tludier           (0x95)
#define TI83P_tlcapcced         (0x96)
#define TI83P_tlcced            (0x97)
#define TI83P_tlcapntilde       (0x98)
#define TI83P_tlntilde          (0x99)
#define TI83P_tlaccent          (0x9a)
#define TI83P_tlgrave           (0x9b)
#define TI83P_tldieresis        (0x9c)
#define TI83P_tlquesdown        (0x9d)
#define TI83P_tlexclamdown      (0x9e)
#define TI83P_tlalpha           (0x9f)
#define TI83P_tlbeta            (0x0a0)
#define TI83P_tlgamma           (0x0a1)
#define TI83P_tlcapdelta        (0x0a2)
#define TI83P_tldelta           (0x0a3)
#define TI83P_tlepsilon         (0x0a4)
#define TI83P_tllambda          (0x0a5)
#define TI83P_tlmu              (0x0a6)
#define TI83P_tlpi              (0x0a7)
#define TI83P_tlrho             (0x0a8)
#define TI83P_tlcapsigma        (0x0a9)
//
//
#define TI83P_tlphi             (0x0ab)
#define TI83P_tlcapomega        (0x0ac)
#define TI83P_tlphat            (0x0ad)
#define TI83P_tlchi             (0x0ae)
#define TI83P_tlstatf           (0x0af)
//

#define TI83P_tla        (0x0b0)
#define TI83P_tlb        (0x0b1)
#define TI83P_tlc        (0x0b2)
#define TI83P_tld        (0x0b3)
#define TI83P_tlsmalle   (0x0b4)
#define TI83P_tlf        (0x0b5)
#define TI83P_tlsmallg   (0x0b6)
#define TI83P_tlh        (0x0b7)
#define TI83P_tli        (0x0b8)
#define TI83P_tlj        (0x0b9)
#define TI83P_tlk        (0x0ba)
//

#define TI83P_tll        (0x0bc)
#define TI83P_tlm        (0x0bd)
#define TI83P_tln        (0x0be)
#define TI83P_tlo        (0x0bf)
#define TI83P_tlp        (0x0c0)
#define TI83P_tlq        (0x0c1)
#define TI83P_tlsmallr   (0x0c2)
#define TI83P_tls        (0x0c3)
#define TI83P_tlsmallt   (0x0c4)
#define TI83P_tlu        (0x0c5)
#define TI83P_tlv        (0x0c6)
#define TI83P_tlw        (0x0c7)
#define TI83P_tlx        (0x0c8)
#define TI83P_tly        (0x0c9)
#define TI83P_tlz        (0x0ca)
#define TI83P_tlsigma           (0x0cb)
#define TI83P_tltau             (0x0cc)
#define TI83P_tlcapiacute       (0x0cd)
//
//
#define TI83P_tgarbagec   (0x0ce)
#define TI83P_lasttoken         (0x0ce)//tlast token in this version...
//
//= ()=====================================================================
//           data type equates                                                    
//= ()=====================================================================
//
#define TI83P_realobj           (0)
#define TI83P_listobj           (1)
#define TI83P_matobj            (2)
#define TI83P_equobj            (3)
#define TI83P_strngobj          (4)
#define TI83P_progobj           (5)
#define TI83P_protprogobj       (6)
#define TI83P_pictobj           (7)
#define TI83P_gdbobj            (8)
#define TI83P_unknownobj        (9)
#define TI83P_unknownequobj     (0x0a)
#define TI83P_newequobj         (0x0b)
#define TI83P_cplxobj           (0x0c)
#define TI83P_clistobj          (0x0d)
#define TI83P_undefobj          (0x0e)
#define TI83P_windowobj         (0x0f)
#define TI83P_zstoobj           (0x10)
#define TI83P_tblrngobj         (0x11)
#define TI83P_lcdobj            (0x12)
#define TI83P_backupobj         (0x13)
#define TI83P_appobj	   (0x14)//application, only used in menus/link
#define TI83P_appvarobj   (0x15)//application variable
#define TI83P_tempprogobj       (0x16)//program, home deletes when finished
#define TI83P_groupobj          (0x17)//group.
// 
//= ()=====================================================================
//           i/o equates                                                          
//= ()=====================================================================
//
#define TI83P_d0d1_bits  (0x03)
#define TI83P_d0ld1l	  (0x03)
#define TI83P_d0ld1h	  (0x01)
#define TI83P_d0hd1l	  (0x02)
#define TI83P_d0hd1h	  (0x00)
#define TI83P_bport	  (0)// 4-bit link port (i/o) 
//
//= ()=====================================================================
//           device codes                                                       
//= ()=====================================================================
//
//
#define TI83P_ti82dev	  (0x82)
#define TI83P_pc82dev	  (0x02)
#define TI83P_mac82dev  (0x12)
//
#define TI83P_ti83fdev  (0x73)
#define TI83P_link83fdev  (0x23)
//
#define TI83P_ti83dev	  (0x83)
#define TI83P_pc83dev	  (0x03)
#define TI83P_mac83dev  (0x13)
//
#define TI83P_ti85dev	  (0x95)// diff then real 85 so me talk
#define TI83P_pc85dev	  (0x05)
#define TI83P_mac85dev  (0x15)
//
#define TI83P_ti73dev	  (0x74)// device x3 is always an 83
#define TI83P_pc73dev	  (0x07)
#define TI83P_mac73dev  (0x17)
//
#define TI83P_ti83fdev  (0x73)
#define TI83P_link73fdev  (0x23)
#define TI83P_pc83fdev  (0x23)
//
//= ()=====================================================================
//           system error codes                                                  
//= ()=====================================================================
//
#define TI83P_e_editf	   (7)//allow re-entering application
#define TI83P_e_mask	   (0x7f)

#define TI83P_e_overflow   (1+e_edit)
#define TI83P_e_divby0   (2+e_edit)
#define TI83P_e_singularmat   (3+e_edit)
#define TI83P_e_domain   (4+e_edit)
#define TI83P_e_increment   (5+e_edit)
#define TI83P_e_break	   (6+e_edit)
#define TI83P_e_nonreal         (7+e_edit)
#define TI83P_e_syntax          (8+e_edit)
#define TI83P_e_datatype        (9+e_edit)
#define TI83P_e_argument        (10+e_edit)
#define TI83P_e_dimmismatch     (11+e_edit)
#define TI83P_e_dimension       (12+e_edit)
#define TI83P_e_undefined       (13+e_edit)
#define TI83P_e_memory          (14+e_edit)
#define TI83P_e_invalid         (15+e_edit)
#define TI83P_e_illegalnest     (16+e_edit)
#define TI83P_e_bound           (17+e_edit)
#define TI83P_e_graphrange      (18+e_edit)
#define TI83P_e_zoom            (19+e_edit)
#define TI83P_e_label           (20)
#define TI83P_e_stat            (21)
#define TI83P_e_solver          (22+e_edit)
#define TI83P_e_singularity     (23+e_edit)
#define TI83P_e_signchange      (24+e_edit)
#define TI83P_e_iterations      (25+e_edit)
#define TI83P_e_badguess        (26+e_edit)
#define TI83P_e_statplot        (27)
#define TI83P_e_toltoosmall     (28+e_edit)
#define TI83P_e_reserved        (29+e_edit)
#define TI83P_e_mode            (30+e_edit)
#define TI83P_e_lnkerr          (31+e_edit)
#define TI83P_e_lnkmemerr       (32+e_edit)
#define TI83P_e_lnktranserr     (33+e_edit)
#define TI83P_e_lnkduperr       (34+e_edit)
#define TI83P_e_lnkmemfull      (35+e_edit)
#define TI83P_e_unknown         (36+e_edit)

#define TI83P_e_scale           (37+e_edit)
#define TI83P_e_idnotfound      (38)
#define TI83P_e_nomode          (39+e_edit)
#define TI83P_e_validation      (40)
#define TI83P_e_length          (41+e_edit)
#define TI83P_e_application     (42+e_edit)
#define TI83P_e_apperr1         (43+e_edit)
#define TI83P_e_apperr2         (44+e_edit)
#define TI83P_e_expiredapp   (45)
#define TI83P_e_badaddr   (46)
#define TI83P_e_archived        (47+e_edit)
#define TI83P_e_version         (48)
#define TI83P_e_archfull        (49)
#define TI83P_e_variable        (50+e_edit)
#define TI83P_e_duplicate       (51+e_edit)
#define TI83P_higerrnum         (51)


// obsolete error numbers34              ;first link error
#define TI83P_e_linkiochksum   (34)
#define TI83P_e_linkiotimeout   (35)
#define TI83P_e_linkiobusy   (36)
#define TI83P_e_linkiover   (37)

//
//= ()=====================================================================
//           equates to ram locations for stat vars 
//= ()=====================================================================
//
//
#define TI83P_fplen   (9)//length of a floating-point number.
#define TI83P_statn     (TI83P_statvars)
#define TI83P_xmean     (TI83P_statn      + TI83P_fplen)
#define TI83P_sumx      (TI83P_xmean      + TI83P_fplen)
#define TI83P_sumxsqr   (TI83P_sumx       + TI83P_fplen)
#define TI83P_stdx      (TI83P_sumxsqr    + TI83P_fplen)
#define TI83P_stdpx     (TI83P_stdx       + TI83P_fplen)
#define TI83P_minx      (TI83P_stdpx      + TI83P_fplen)
#define TI83P_maxx      (TI83P_minx       + TI83P_fplen)
#define TI83P_miny      (TI83P_maxx       + TI83P_fplen)
#define TI83P_maxy      (TI83P_miny       + TI83P_fplen)
#define TI83P_ymean     (TI83P_maxy       + TI83P_fplen)
#define TI83P_sumy      (TI83P_ymean      + TI83P_fplen)
#define TI83P_sumysqr   (TI83P_sumy       + TI83P_fplen)
#define TI83P_stdy      (TI83P_sumysqr    + TI83P_fplen)
#define TI83P_stdpy     (TI83P_stdy       + TI83P_fplen)
#define TI83P_sumxy     (TI83P_stdpy      + TI83P_fplen)
#define TI83P_corr      (TI83P_sumxy      + TI83P_fplen)
#define TI83P_medx      (TI83P_corr       + TI83P_fplen)
#define TI83P_q1        (TI83P_medx       + TI83P_fplen)
#define TI83P_q3        (TI83P_q1         + TI83P_fplen)
#define TI83P_quada     (TI83P_q3         + TI83P_fplen)
#define TI83P_quadb     (TI83P_quada      + TI83P_fplen)
#define TI83P_quadc     (TI83P_quadb      + TI83P_fplen)
#define TI83P_cubed     (TI83P_quadc      + TI83P_fplen)
#define TI83P_quarte    (TI83P_cubed      + TI83P_fplen)
#define TI83P_medx1     (TI83P_quarte     + TI83P_fplen)
#define TI83P_medx2     (TI83P_medx1      + TI83P_fplen)
#define TI83P_medx3     (TI83P_medx2      + TI83P_fplen)
#define TI83P_medy1     (TI83P_medx3      + TI83P_fplen)
#define TI83P_medy2     (TI83P_medy1      + TI83P_fplen)
#define TI83P_medy3     (TI83P_medy2      + TI83P_fplen)
#define TI83P_pstat     (TI83P_medy3      + 2*TI83P_fplen)
#define TI83P_zstat     (TI83P_pstat      + TI83P_fplen)
#define TI83P_tstat     (TI83P_zstat      + TI83P_fplen)
#define TI83P_chistat   (TI83P_tstat      + TI83P_fplen)
#define TI83P_fstat     (TI83P_chistat    + TI83P_fplen)
#define TI83P_df        (TI83P_fstat      + TI83P_fplen)
#define TI83P_phat      (TI83P_df         + TI83P_fplen)
#define TI83P_phat1     (TI83P_phat       + TI83P_fplen)
#define TI83P_phat2     (TI83P_phat1      + TI83P_fplen)
#define TI83P_meanx1    (TI83P_phat2      + TI83P_fplen)
#define TI83P_stdx1     (TI83P_meanx1     + TI83P_fplen)
#define TI83P_statn1    (TI83P_stdx1      + TI83P_fplen)
#define TI83P_meanx2    (TI83P_statn1     + TI83P_fplen)
#define TI83P_stdx2     (TI83P_meanx2     + TI83P_fplen)
#define TI83P_statn2    (TI83P_stdx2      + TI83P_fplen)
#define TI83P_stdxp2    (TI83P_statn2     + TI83P_fplen)
#define TI83P_slower    (TI83P_stdxp2     + TI83P_fplen)
#define TI83P_supper    (TI83P_slower     + TI83P_fplen)
#define TI83P_sstat     (TI83P_supper     + TI83P_fplen)

#define TI83P_f_df	  (TI83P_anovaf_vars)
#define TI83P_f_ss	  (TI83P_f_df + TI83P_fplen)
#define TI83P_f_ms	  (TI83P_f_ss + TI83P_fplen)
#define TI83P_e_df	  (TI83P_f_ms + TI83P_fplen)
#define TI83P_e_ss	  (TI83P_e_df + TI83P_fplen)
#define TI83P_e_ms	  (TI83P_e_ss + TI83P_fplen)

